2016-11-21  Christophe Fergeau  <cfergeau@redhat.com>

	build: Update NEWS file

	build: Update SPICE_REVISION for new release
	No ABI addition/removal/... so no need to change anything else.

	smartcard: Remove duplicate accessor
	smartcard_channel_client_get_device() is the same as
	smartcard_channel_client_get_char_device(). Let's only keep the latter.

	smartcard: Fix SmartcardChannelClient creation
	The wrong type (RED_TYPE_CHANNEL_CLIENT rather than
	TYPE_SMARTCARD_CHANNEL_CLIENT) was used when creating a
	SmartcardChannelClient, which meant the _init function was never called,
	and SmartcardChannelClient::priv was never initialized.

	This caused a crash when trying to connect with --spice-smartcard to a
	VM with a smartcard channel configured.

2016-11-18  Pavel Grunt  <pgrunt@redhat.com>

	syntax-check: Skip strncpy check
	strncpy used in reds_init_socket() has destination NUL terminated

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	syntax-check: Update gnufiles
	Fix make check, otherwise it fails on
	   GEN      public-submodule-commit
	 Stopping at 'spice-common'; script returned non-zero status.
	 maint.mk: found non-public submodule commit

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-18  Frediano Ziglio  <fziglio@redhat.com>

	Avoid leaking ping_timer in MainChannelClient
	This leaks happen for every connection. Potentially the timer can
	be called after the client is closed causing an use after free.
	Recently RED_STATISTICS was switched off by default but previous
	version have this issue.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-11-18  Pavel Grunt  <pgrunt@redhat.com>

	red-qxl: Remove traling semicolon
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-18  Frediano Ziglio  <fziglio@redhat.com>

	Avoid use after free
	self->priv was deleted and then used

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-11-17  Pavel Grunt  <pgrunt@redhat.com>

	Do not crash on NULL codecs
	Reviewed-by: Christophe Fergeau <cfergeau@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add test for codecs parsing
	With Glib2.34 test invalid codec strings

	Reviewed-by: Christophe Fergeau <cfergeau@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-17  Frediano Ziglio  <fziglio@redhat.com>

	Make sure statistic file are initialized even if init is not called
	This caused a NULL pointer dereference executing some tests
	calling spice_server_destroy.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Revert "replay: Replicate wakeups properly"
	This reverts commit c6881ad1a00d95d0231dcab7bb30827e86d4d572.

	This patch cause the replay utility run at full speed
	to slow down a lot and in some cases getting stuck.
	I don't understand the reason and when I tested was working
	but as we are going to release would be a pity if this test utility
	won't work as useful to get feedback and reports.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-11-17  Pavel Grunt  <pgrunt@redhat.com>

	Define G_LOG_DOMAIN
	Otherwise messages produced by g_{warn, return, ...} are not prefixed
	like the spice_ variants.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-16  Jonathon Jongsma  <jjongsma@redhat.com>

	Fix build when builddir != srcdir
	The following build error occurs when building outside of the source
	directory:

	glib-mkenums --template spice-server-enums.tmpl.c ../../server/spice-server.h > spice-server-enums.c
	Can't open spice-server-enums.tmpl.c: No such file or directory
	Makefile:1111: recipe for target 'spice-server-enums.c' failed

	Make/Automake uses VPATH to determine that the spice-server-enums.tmpl.c
	file listed in the prerequisites for the rule is located in the srcdir.
	When we use an automatic variable (e.g. $<), the full path to the
	resolved file is used. But when we use the literal filename directly
	within the rule definition, this won't happen. So we need to explicitly
	specify that the input template file is located in srcdir.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-16  Frediano Ziglio  <fziglio@redhat.com>

	Make RedStatFile private inside stat-file.c
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Avoid leaking file descriptor for statistics
	mmap memory area will remain even if the descriptor is closed.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Use g_strdup_printf instead of manually malloc/snprintf
	Make the code easier and shorter.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Add a base test for statistic file
	Create a file and add/remove some nodes.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix node removal
	Avoid to produce loop in the tree removing and adding nodes.
	Unlink the node from the containing tree.
	This possibly will create unlinked trees if a parent node is
	deleted.

	What was happening is that the creation of loops inside
	the tree caused some statistical function to go into an
	infinite loop (and reds_stat tool too).

	Nodes were only invalidated but still linked so when reused
	the new node could point to an already existing node (like a
	sibling) which pointed to the new reused one.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Separate code to manage statistic file
	Code is quite independent so move in separate file.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-11-16  Pavel Grunt  <pgrunt@redhat.com>

	Do not use gstreamer in default codecs if not available
	Avoid the following warning when build with disabled gstreamer:
	Spice-WARNING **: reds.c:3660:reds_set_video_codecs: spice: unsupported video encoder gstreamer

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-15  Pavel Grunt  <pgrunt@redhat.com>

	ci: Test syntax-check
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	ci: Print results of tests on failure
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-15  Frediano Ziglio  <fziglio@redhat.com>

	Remove core_public and core_interface_adapter globals usage
	Avoid not constant globals.

	We started encapsulating all global state into RedsState however
	there are still some global variable. This patch remove the
	core_public global variable.

	To implement this a new SpiceCoreInterface *public_interface
	field is added to SpiceCoreInterfaceInternal and the
	SpiceCoreInterfaceInternal* argument is passed to callbacks to
	understand which external interface to use.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Handle top down bitmaps dumping
	The top down flag can be specified using negative heights.

	According to
	https://msdn.microsoft.com/en-us/library/windows/desktop/dd183376(v=vs.85).aspx:

	"The height of the bitmap, in pixels. If biHeight is positive, the
	bitmap is a bottom-up DIB and its origin is the lower-left corner.
	If biHeight is negative, the bitmap is a top-down DIB and its origin
	is the upper-left corner."

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spicevmc: Remove some duplicate typedefs
	These cause compiler errors using RHEL6.
	These typedefs are defined in the same file some lines above.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	gstreamer: Use pthread to avoid Glib compatibility issues with RHEL6
	GCond/GMutex interface is different between Glib 2.32 and
	previous versions. Use pthread for compatibility.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-11-14  Frediano Ziglio  <fziglio@redhat.com>

	sound: Remove sin field from SpicePlaybackState and SpiceRecordState
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	sound: Reuse code for spice_server_get_best_{record,playback}_rate
	These function were really similar.
	Factor out a new snd_get_best_rate to avoid code duplication.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	sound: Move frequency field to SndWorker
	This field is common to SpicePlaybackState and SpiceRecordState
	which are based on SndWorker.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	sound: Free worker volume in common function
	The common function is supposed to clear the state of SndWorker
	so clear even volume which now is in SndWorker

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Fix header include order for some files
	Include common and libraries includes before local ones as
	stated by style.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	syntax-check: Use templates for glib-mkenums
	Syntax checker complained about autoconf variable expansion used
	inside Makefile.am.
	This patch uses template files instead of options.
	This also reduces quoting making template code more readable.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Use SPICE_VERIFY macro for RHEL6 compatibility
	The verify macro used currently has some problem
	as it raise a warning in RHEL6.
	Use new SPICE_VERIFY macro defined in spice-common
	to avoid this issue.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-11-14  Jonathon Jongsma  <jjongsma@redhat.com>

	char-device: add 'self' param to vfuncs
	Add a 'self' parameter to all of the char device virtual functions so
	that we don't have to play games with the 'opaque' pointer.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-14  Christophe Fergeau  <cfergeau@redhat.com>

	build: Cleanup disabled warnings a bit
	Some C-specific warnings were turned off as the spice module used to
	ship a C++ spice client. It's long gone, so we can reenable these
	warnings.
	There were warnings disabled for tunnel support and CEGUI usage which
	have both been removed too.
	-Wno-format-nonliteral was disabled twice.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-12  Frediano Ziglio  <fziglio@redhat.com>

	Fix typo in comment

	replay: Update comment
	Function just return the command, has no ext_cmd parameter to fill.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-11-12  Jonathon Jongsma  <jjongsma@redhat.com>

	Sound: change on_new_*_channel() signatures
	Pass the new sound channel to these functions rather than setting
	worker->connection before calling the function and expecting it to be
	set when the function is called. The fewer unenforced assumptions that
	must be true for a function to work properly, the easier it will be to
	maintain.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-12  Frediano Ziglio  <fziglio@redhat.com>

	sound: Peep hole optimisation
	Reduce SpiceVolumeState structure size on 64 architectures
	swapping the order of two fields.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	sound: Minor simplification due to volume move
	Reuse more code in snd_send_volume and snd_send_mute.
	Reduce conversions in on_new_playback_channel and
	on_new_record_channel.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	sound: Move volume field to SndWorker
	This field is common to SpicePlaybackState and SpiceRecordState
	which are based on SndWorker.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-11-10  Frediano Ziglio  <fziglio@redhat.com>

	replay: Remove time argument from recording functions
	Time is always the the current real time so avoid to compute
	it for every call but move to red-record-qxl.c.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	build: Disable some newly added warnings
	-Wshift-overflow cause an error to be detected in Glib headers.
	-Wformat-signedness and -Wnull-dereference probably could be
	fixed but currently they produce lot of errors.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	build: Update manywarnings.m4
	Allows to catch more issues.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Make red-replay-qxl.h a public header
	The functions declared in that header are all exported by the
	library.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: Check properly version number
	0 as version was never used so don't allow it

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: Replicate wakeups properly
	Instead of waking up the command loop for every command queued,
	handle saved wakeups and replicate these.
	This better reproduces what happened in the server.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-11-09  Frediano Ziglio  <fziglio@redhat.com>

	Make QXLMessage handling safe
	The QXLMessage has no size so potentially a guest could give an
	address that cause the string to overflow out of the video memory.
	The current solution is to parse the message, release the resources
	associated without printing the message from the client.
	This also considering that the QXLMessage usage was deprecated
	a while ago (I don't know exactly when).
	This patches limit the string to 100000 characters (guest can feed
	so much logs in other way) and limit to video memory.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	red-parse-qxl: Use same fuction to parse blend and copy commands
	SpiceBlend and SpiceCopy are just different names for the same
	structure.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	syntax-check: Silent a wrong positive
	Due to syntax-check limitation this free calls results in
	a syntax error.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	syntax-check: Include config.h file #include <>
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	syntax-check: Remove empty line at end of file
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	syntax-check: Remove space at end of line
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-11-09  Christophe Fergeau  <cfergeau@redhat.com>

	syntax-check: Add exception for server/stat.h
	Due to the use of static inline functions, the headers uses
	G_GNUC_UNUSED, which the sc_avoid_attribute_unused_in_header test
	complains about.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-09  Frediano Ziglio  <fziglio@redhat.com>

	Fix typo in comment

	Revert accidentally merged experimental patches

2016-11-07  Frediano Ziglio  <fziglio@redhat.com>

	build a structure to hold all DCC stream fields
	try to understand streams

	NOTES

	channel: cap roundtrip using Linux information if available
	Linux kernel already compute roundtrip.
	If available use it to limit discovered one.

2016-11-07  Jonathon Jongsma  <jjongsma@redhat.com>

	RedChannelClient: use Gobject properties
	Use g_param_spec_object() instead of g_param_spec_pointer() for the
	'client' and 'channel' properties now that these types are GObjects.
	This improves refcounting and typesafety slightly.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-11-07  Pavel Grunt  <pgrunt@redhat.com>

	spice-options-test: Convert to gtest to catch criticals
	Fail on glib warnings instead of ignoring them

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-11-07  Frediano Ziglio  <fziglio@redhat.com>

	spicevmc: Change creation of RedCharDeviceSpiceVmc
	Instead of having channel and device object create one the other
	create the objects at the beginning and then join them.

	This make explicit the code that links the two objects and separate
	the objects creation from the linking.

	Also remove some boilerplate code.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-04  Jonathon Jongsma  <jjongsma@redhat.com>

	spicevmc: use 'channel' instead of 'state'
	After renaming the object to RedVmcChannel, the local variables still
	used the old 'state' terminology. Changing these variables to 'channel'
	makes things a bit more consistent.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove spicevmc_red_channel_client_get_state()
	This helper function does nothing but cast the return from
	red_channel_client_get_channel(), and it has a confusing name
	(_get_state(), but returns a channel)

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-04  Frediano Ziglio  <fziglio@redhat.com>

	spicevmc: Clear RedVmcChannel on red_char_device_spicevmc_dispose
	This move object destructions from spicevmc_device_disconnect
	to RedCharDeviceSpiceVmc destructor functions assuring any possible
	RedCharDeviceSpiceVmc object free will clear its references.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spicevmc: More RedVmcChannel::recv_from_client_buf cleanup to finalize
	No reason why this should be done only on spicevmc_device_disconnect.
	red_char_device_write_buffer_release can be called with first pointer
	NULL.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spicevmc: Free pipe_item in finalize
	Assure field is freed at the end and not used or allocate again.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-11-04  Jonathon Jongsma  <jjongsma@redhat.com>

	spicevmc: store channel in char device
	Store the channel in the char device object, and unref it in dispose.
	Previously, we were just creating a channel and potentially allowing it
	to leak.  There may be better long-term solutions, but this works for
	now.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-02  Jonathon Jongsma  <jjongsma@redhat.com>

	Convert RedClient to GObject
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move RedClient to a separate file
	Also move the RedClient struct out of the header to avoid accessing the
	internals from other files.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Re-arrange channel client creation to avoid exposing client lock
	Instead of requiring the channel client to lock the client's lock,
	re-arrange things so that all of the locking can be internal to
	RedClient methods. So instead of having a pre-create validate function,
	we simply move the check to red_client_add_channel() and return an error
	if a channel already exists. This encapsulates the client implementation
	better and also reduces code duplication in RedChannelClient and
	DummyChannelClient.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Convert RedsState::clients to GList
	Switch from a Ring to a GList so that we can hide the internals of
	RedClient in a future commit.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-02  Frediano Ziglio  <fziglio@redhat.com>

	Avoid to typedef twice RedChannel
	It's already defined in the same file some lines above.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	red-channel-client: Change initialization order
	Make the order of initialization closer to what it was before
	conversion to GObject.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	red-channel-client: Move incoming/ougoing initialization to constructor
	These fields need just channel to be set to be initialized.
	Move their initialization to constructor to make sure
	they are initialized as soon as possible.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	red-channel-client: Init pipe field during init
	There was a chance that on error GQueue were not
	initialized but an attempt to destroy it is made.
	This ensures GQueue is initialized as soon as
	possible. Note that red_channel_client_initable_init
	is called after all init and construction callbacks.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-11-01  Pavel Grunt  <pgrunt@redhat.com>

	Add .gitlab-ci.yml
	Acked-by: Victor Toso <victortoso@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-01  Jonathon Jongsma  <jjongsma@redhat.com>

	Rename SpiceVmcState to RedVmcChannel
	Internal types use the 'Red' prefix by convention, rather than the
	'Spice' prefix. In addition, this type inherits from RedChannel, so
	makes the code a lot clearer to call it a 'channel' rather than a
	'state'.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-01  Frediano Ziglio  <fziglio@redhat.com>

	red-channel-client: Remove only written field
	id field of RedChannelClient is not used and marked as debugging.
	Also it's value is quite confusing.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-11-01  Christophe Fergeau  <cfergeau@redhat.com>

	syntax-check: Add missing license headers
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	syntax-check: Remove unused header includes
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	syntax-check: Add missing <config.h> includes
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	syntax-check: Remove trailing whitespace from EOL and EOF
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	syntax-check: Add missing contributors names to AUTHORS
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	syntax-check: Change tabs to spaces
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	syntax-check: Add missing license
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-01  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Clarify GStreamer's virtual buffer size documentation
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-01  Jonathon Jongsma  <jjongsma@redhat.com>

	Limit maximum "n-surfaces" via param spec
	In commit beec1b41, we manually limited this property value in
	_set_property(). But there's a simpler way to do it: via the param spec
	for the property.

	This also means that we can remove the warning log in red_worker_new()
	since GObject will automatically warn if a property is assigned a value
	outside of its valid range.

	Change the minimum and default value for this property from 0 to 1 so
	that we always have a primary surface.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-01  Pavel Grunt  <pgrunt@redhat.com>

	Do not enable statistic by default
	It is more a feature for developers, not force them.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Allow to compile without RED_STATISTICS
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-11-01  Frediano Ziglio  <fziglio@redhat.com>

	Do not declare image_encoders_compress_lz4 if LZ4 is not available
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove red_pipe_add_verb family function
	These functions were implementing the same stuff as empty
	messages functions provided by RedChannel so reuse them.

	The implementation seems a bit different but the result
	is the same. Specifically:
	- RedEmptyMsgPipeItem::msg is int while RedVerbItem::verb was
	  uint16_t however this data goes into the message type which
	  is uint16_t (a 16 bit on the network protocol);
	- red_channel_client_send_empty_msg calls
	  red_channel_client_begin_send_message while red_marshall_verb
	  does not. However red_marshall_verb is called only by
	  cursor_channel_send_item and dcc_send_item which always
	  calls red_channel_client_begin_send_message.
	  Note that in dcc_send_item when an empty message is sent
	  red_channel_client_send_message_pending always returns
	  true;
	- when a PipeItem is created red_channel_client_pipe_add_empty_msg
	  calls red_channel_client_push while red_pipe_add_verb does not.
	  This actually make very little difference as this kind of item are
	  never removed from the queue and a push is forced in every case
	  running the event handler for the stream watch (see
	  prepare_pipe_add and red_channel_client_event).

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-10-31  Frediano Ziglio  <fziglio@redhat.com>

	Constify video_codec_caps
	This remove a writable global variable.

	Acked-by: Uri Lublin <uril@redhat.com>

	worker: Remove dependencies from red-worker.h
	red_drawable_unref declaration was moved to red-parse-qxl.h.
	Result is that only RedDispatcher know of the existence of RedWorker.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Move capability initialisation into channel creation
	No reason why RedWorker should know the capabilities of
	DisplayChannel.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-10-29  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Limit the h264 image compression level
	When uncapped x264enc can compress the frames beyond recognition in low
	bitrate situation. Beyond the set limit the gains are modest and it is
	better to drop frames to reduce the bit rate further.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-28  Frediano Ziglio  <fziglio@redhat.com>

	Allows to have more than 1 QXL device
	This was introduced with 96e94c6f32d4345ea25ef7a474fbd92de03b38ad
	(Convert RedChannel hierarchy to GObject).
	The id of CursorChannel/DisplayChannel were always 0 causing
	a wrong assertion on the code.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Call parent constructor always at the beginning
	In this case there is not much change but better
	to follow that style as all other constructors
	do.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix handle-acks regression
	This was introduced with 96e94c6f32d4345ea25ef7a474fbd92de03b38ad
	(Convert RedChannel hierarchy to GObject).
	The handle-acks settings was TRUE for CursorChannel and DisplayChannel.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-10-27  Frediano Ziglio  <fziglio@redhat.com>

	Fix typo in comment
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Make reds_stat utility work with both 32 and 64 bit architectures.
	Due to alignment problems the structure of statistics file is
	different between 32 and 64 bit. This as on 32 bit uint64_t is
	aligned to 4 bytes instead of 8 so sizeof(SpiceStat) can be either
	20 (32 bit) or 24 (64 bit).
	This cause reds_stat utility to be bit dependent.
	Detect the correct SpiceStat size and use that information.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Fix core-interface type regression
	This was introduced with 96e94c6f32d4345ea25ef7a474fbd92de03b38ad
	(Convert RedChannel hierarchy to GObject).
	The type for "core-interface" property should be
	SpiceCoreInterfaceInternal, not SpiceCoreInterface.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Remove g_smartcard_channel global
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-10-26  Frediano Ziglio  <fziglio@redhat.com>

	Remove duplicate include
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-10-26  Pavel Grunt  <pgrunt@redhat.com>

	Add missing header to Makefile.am
	Fix make distcheck

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-25  Jonathon Jongsma  <jjongsma@redhat.com>

	Implement vfuncs for DummyChannel
	96e94c6f inadvertantly introduced a regression where an assert was
	triggered in red_channel_constructed for DummyChannel since DummyChannel
	didn't implement any of the expected RedChannel vfuncs. This patch
	avoids the assert by assigning some empty vfuncs.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Convert RedChannel hierarchy to GObject
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-25  Frediano Ziglio  <fziglio@redhat.com>

	Remove unused declaration
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-10-20  Frediano Ziglio  <fziglio@redhat.com>

	red-worker: Do not include not necessary red-channel-client.h
	Definitions are all in red-channel.h

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Avoid to typedef twice MainChannel
	MainChannel is already defined in main-channel.h.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	display channel: Don't let client set too many surfaces
	Limit the n_surfaces argument to avoid overflowing the surfaces array.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Avoid recursive inclusion of headers
	red-common.h included utils.h which included red-common.h

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Allows to use scripts for "make check"
	Allow both compiled and non-compiled tests to be used with "make
	check". Compiled tests should be added to check_PROGRAMS, and scripts
	that do not need to be built should be added to TESTS.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Declare same enumerator in a single header
	Avoid having duplication and desynchronisation.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Move monitors_config_ref inside red_monitors_config_item_new
	This makes red_monitors_config_item_new() and
	red_monitors_config_item_free() symmetric.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	dcc: Use spice_new instead of spice_malloc
	spice_new return directly the correct type.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Fix typo in comment
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Make compression image declarations more similar
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Reuse SPICE_N_ELEMENTS macro
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-10-19  Frediano Ziglio  <fziglio@redhat.com>

	Include main-channel-client.h where MainChannelClient is used
	Acked-by: Jonathon Jongsma <jjongsma at redhat.com>

	Avoid to typedef twice RedChannel and RedClient
	These are already defined in red-channel.h which is included in
	red-channel-client.h header.

	Acked-by: Jonathon Jongsma <jjongsma at redhat.com>

	Add reds_stat to compiled software
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Remove warnings from reds_stat utility
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-10-18  Frediano Ziglio  <fziglio@redhat.com>

	Include directly used header in dcc.h
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-10-18  Jonathon Jongsma  <jjongsma@redhat.com>

	Improve MainChannel encapsulation
	Encapsulate MainChannel a bit better in preparation for proting to
	GObject.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-18  Frediano Ziglio  <fziglio@redhat.com>

	Be consistent with opaque type
	vdi_port_read_buf_release is registered passing data as
	RedVDIReadBuf*, not RedPipeItem*. Cast opaque to proper
	pointer type to avoid the assumption that first field of
	RedVDIReadBuf is a RedPipeItem.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Use a compatibility header to support GLib 2.28
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Do not typedef DisplayChannel twice
	Already defined in dcc.h.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Avoid to typedef twice CursorChannel
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-10-17  Uri Lublin  <uril@redhat.com>

	mjpeg_encoder_new: allocate memory after sanity check
	This patch prevents a leak in case the function returns early

	Found by coverity.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	input-channel: add a comment to mark fallthrough in switch
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-14  Jonathon Jongsma  <jjongsma@redhat.com>

	Add CommonGraphicsChannelPrivate struct
	Encapsulate private data for CommonGraphicsChannel and prepare for
	GObject conversion.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-14  Christophe Fergeau  <cfergeau@redhat.com>

	doc: Remove mention that qxl.guestdebug is Windows-only
	The Linux QXL KMS driver also uses it.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-14  Pavel Grunt  <pgrunt@redhat.com>

	rcc: Make OutgoingHandler private
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	reds: Define openssl lock only if needed
	Silence a warning:
	 reds.c:150:25: warning: 'lock_cs' defined but not used [-Wunused-variable]
	  static pthread_mutex_t *lock_cs;

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-14  Francois Gouget  <fgouget@codeweavers.com>

	server: Remove a redundant IncomingHandler typedef
	This fixes a compilation error with gcc 4.4.7 on RHEL 6.8.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-14  Jonathon Jongsma  <jjongsma@redhat.com>

	Use macros for casting Channel types
	In preparation for converting RedChannel to GObject, switch to using
	RED_CHANNEL()-type macros for casting. For now they just do a regular
	cast, but it helps reduce the size of the GObject patch to make it
	easier to review.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move CommonGraphicsChannel to a new file
	Move out of red-worker.c. This requires a little bit of minor
	refactoring to avoid accessing some RedWorker internals in the
	constructor function, etc.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-14  Francois Gouget  <fgouget@codeweavers.com>

	server: Remove a redundant CursorChannelClient typedef
	CursorChannelClient is already defined in cursor-channel-client.h.
	This fixes compilation errors with gcc 4.4.7 on RHEL 6.8.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-10-13  Jonathon Jongsma  <jjongsma@redhat.com>

	Don't increment num_clients_mig_wait twice
	When MainChannelClient was split to a separate file, the responsibility
	for incrementing this field was supposed to belong to the MainChannel
	function (main_channel_connect_semi_seamless()), but by mistake it was
	incremented both there and in the client function
	(main_channel_client_connect_semi_seamless()).

	The bug was introduced in a11b785f191d2381932f8c1bb6281539f2afe483

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-11  Pavel Grunt  <pgrunt@redhat.com>

	Test agent message filter processing
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add agent message filter test
	Test filter initialization and configuration

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	agent-msg-filter: Remove extra headers
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-10-11  Frediano Ziglio  <fziglio@redhat.com>

	style: Specify function definition indentation
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-10-07  Frediano Ziglio  <fziglio@redhat.com>

	Convert RedChannelClient hierarchy to GObject
	Convert the RedChannelClient heirarchy into GObjects. Since the existing
	constructors could fail and return NULL, I inherited the base channel
	client from GInitable, which introduces a dependency on gio.

	When using private structs with GObject, there's a maximum size of (I
	think) 64k, which was exceeded by some of the private structs. To avoid
	this limitation I changed some members to dynamically allocated.

2016-09-30  Frediano Ziglio  <fziglio@redhat.com>

	Split RedCharDeviceSmartcard and SmartCardChannelClient

	Cache field to make code easier
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-09-29  Frediano Ziglio  <fziglio@redhat.com>

	Add a comment for marshaller field
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-09-27  Jonathon Jongsma  <jjongsma@redhat.com>

	Generate GTypes for spice-server enums
	The GType will be useful to allow these enums to be used as GObject
	properties.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-09-27  Frediano Ziglio  <fziglio@redhat.com>

	Rename red_surface to surface
	Attempt to use consistent naming.
	Usually we use surface name for RedSurface.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Rename surface argument to surface_cmd
	Attempt to use consistent naming.
	Usually we use surface name for RedSurface so make sure
	code reader do not get confused using a different name
	for RedSurfaceCmd.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Rename detach_stream to stream_detach_drawable and removed unused argument
	This function deal only with Stream.
	Also the name was misleading and was not clear if it detached the stream
	from the DisplayChannel.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Removed only written roundtrip_stat field
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Removed unused stat field
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Use enum value returning invalid value
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Check client is using unix sockets in dcc_gl_draw_item_new
	Currently this is simply avoided by the fact that Virgl with 3d means
	Unix socket. Once you enable (in Qemu) tcp sockets this message will
	be added to all clients (supposing multiple clients) so potentially
	will be in all queues. The same check is done for dcc_gl_scanout_item_new.
	dcc_gl_scanout_item_new is called when Qemu calls spice_qxl_gl_draw_async.
	Technically a client can support SPICE_DISPLAY_CAP_GL_SCANOUT but server
	cannot send the DRM prime directly as this require a unix socket so
	if the test for SPICE_DISPLAY_CAP_GL_SCANOUT is done here it make sense
	to do the check for the socket type too.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-09-26  Frediano Ziglio  <fziglio@redhat.com>

	Reuse VD_AGENT_HAS_CAPABILITY macro for bit array
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: RedCompressBuf optimization
	Move large buffer field at the end of structure.
	Due to the way machine address memory this usually can reduce code size
	and make program sligthly faster.
	Actually reduce size by 100 bytes.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Make error simpler in reds_stat
	There's no reason for so hard optimisations so avoid
	having to maintain multiple labels.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Prevent setting invalid image compression values
	In case of invalid value the original compression is unchanged.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-09-22  Frediano Ziglio  <fziglio@redhat.com>

	replay: Update pointer in allocated list
	Avoid to free invalid pointer.

	Reported-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Small comment on structure checking
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove unused fields
	These fields were added in a32e90257e834e340075e633132b52c612be4578
	as part of the multiple client support and were never used.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Capitalize option documentation
	All other options are documented using initial capital case letter.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify serial sending packets
	serial was the future serial to send while last_sent_serial was the
	last sent.
	serial sent started from 1.
	To make sure sequence variable is updated just before sending the
	message, not every message prepared.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: Do not check surface twice
	validate_surface already do the same checks.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-09-21  Frediano Ziglio  <fziglio@redhat.com>

	replay: Use unsigned in formatting
	Avoid negative syntax. Also could prevent some memory problem is number
	get too big.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: Use proper formatting for scanf family
	Currently on Linux PRIu64 and SCNu64 are the same but just to make
	sure in the future use the correct macros.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: Propagate error correctly in replay_fread
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: Move error check
	Do the check after replay_fscanf to make sure everything
	is fine before calling red_replay_compat_drawable or
	red_replay_native_drawable.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: Detect errors from red_replay_data_chunks
	Change the return to ssize_t to be able to distinguish from
	empty buffer to error.
	Check result returned and avoid continuing potentially
	deferencing NULL pointers.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: Handle errors reading strings from record file
	To check fscanf read all needed information a dummy "%n" is appended
	to any string and the value stored there is tested. This as scanf family
	could return a valid value but not entirely process the string so
	adding a "%n" and checking this was processed make sure all expected
	string is found.
	The code to check for a specific string is now a bit more complicated
	as replay_fscanf use a macro which append a constant string.
	The "error" field is used to mark any error happened, so in most cases
	there is no explicit check beside when this could cause a problem
	(for instance results of replay_fscanf used which would result in
	uninitialised variable usage).

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: Record allocations in a GList to handle errors
	Allocations are kept into a GList to be able to free in case some
	errors happened.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Base FOREACH_DCC on GLIST_FOREACH
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Base FOREACH_CLIENT on GLIST_FOREACH
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Use proper FOREACH_DCC instead of FOREACH_CLIENT
	FOREACH_DCC should be more DisplayChannel related.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	RedChannel: Use more FOREACH_CLIENT macro
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	RedChannel: Add FOREACH_CHANNEL_CLIENT and use it to iterate
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Introduce some macros to simplify iteration on GList
	Noting that coding by hand these loop introduced some regression
	I'm trying to introduce back from macros.
	Before trying something harder to make possible to bind the type of
	the content I'm trying some simple macro as were before.
	I added the type to avoid some blindly void* casts.
	Also the GListIter is introduced to avoid the possibility to exchange
	easily some parameters.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Use spice_realloc instead of manually code it
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove only set serial field
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-09-20  Frediano Ziglio  <fziglio@redhat.com>

	Simplify send_free_list
	The check for free_list->wait.header.wait_count was always true.

	Acked-by: Uri Lublin <uril@redhat.com>

	Revert if to make code more readable
	Keep all code to send SPICE_MSG_LIST together.

	Acked-by: Uri Lublin <uril@redhat.com>

2016-09-20  Jonathon Jongsma  <jjongsma@redhat.com>

	Use and introduce channel client cast macros
	In anticipation of porting to GObject, use casting macros (e.g.
	MAIN_CHANNEL_CLIENT()) to cast RedChannelClient types. This will help
	reduce the changeset slightly porting to GObject and thus make it easier
	to review those upcoming changes.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-09-19  Jonathon Jongsma  <jjongsma@redhat.com>

	Change RedCharDevicePrivate::clients to GList
	More Ring cleanup. At the moment, we only support a single client, so
	this is only a one-element list

	Change RedCharDevice::write_queue to GQueue
	Change a couple more Rings to GQueue

	Change Drawable->pipes from Ring to GList
	This improves the readability of the code and keeps things
	encapsulated better.

	RedChannelClient: store pipe items in a GQueue
	Instead of using a Ring (and having a ring item link in every pipe
	item), store them in a GQueue. This also necesitated changing
	RedCharDeviceVDIPort->priv->read_bufs to a GList as well.

	Also Optimise client pipe by passing pipe position instead of data.
	This avoids having the search the data scanning all the queue changing
	the order of these operations from O(n) to O(1).

2016-09-16  Jonathon Jongsma  <jjongsma@redhat.com>

	Rename display_channel_set_monitors_config_to_primary()
	Since this function is a DisplayChannel method, use a name consistent
	with naming conventions.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Add DisplayChannelPrivate struct
	Move all of the DisplayChannel data memembers into a private struct to
	encapsulate things better. This necessitated a few new 'public' methods
	and a small bit of refactoring to avoid poking into DisplayChannel
	internals from too many places. The DisplayChannel and the
	DisplayChannelClient are still far too intertwined to completely avoid
	accessing private data, so at the moment the private struct is defined
	in display-channel.h and the DisplayChannelClient implementation
	still accesses it sometimes.

	Improve encapsulation of DisplayChannel
	Add a couple new functions to the header so that they can be called by
	other objects rather than poking into the internals of the struct.

2016-09-16  Pavel Grunt  <pgrunt@redhat.com>

	reds: Simplify vdi_port_read_buf_process
	Reuse and handle the return value from agent_msg_filter_process_data

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-09-16  Frediano Ziglio  <fziglio@redhat.com>

	replay: Rename eof to error
	The eof variable and enumeration will be used for all errors
	so avoid confusion.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	replay: Assure read_binary receives a NULL pointer
	read_binary do not allocate a buffer for no-NULL pointers.
	Avoid using uninitialized data and allocate proper buffer.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-09-16  Pavel Grunt  <pgrunt@redhat.com>

	agent-filter: Use enum as return value
	Explicitely discard AGENT_MSG_FILTER_MONITORS_CONFIG messages
	from the agent.

	Also remove unused AGENT_MSG_FILTER_END

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-09-16  Frediano Ziglio  <fziglio@redhat.com>

	Remove unused drawable parameter
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Reduce indentation
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Simplify some boolean arithmetic
	Pass boolean directly.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-09-16  Jonathon Jongsma  <jjongsma@redhat.com>

	Replace a couple Rings with GList
	Make RedsState::mig_target_clients into a GList to improve encapsulation
	and maintainability. Also RedsMigTargetClient::pending_links. With
	GList, a type implementation can be ignorant of whether they're
	contained within a list or not.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-09-15  Jonathon Jongsma  <jjongsma@redhat.com>

	Make glz_dictionary_list a GList
	Removing more intrusive RingItems from various structures and improving
	readibility.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add CursorChannelPrivate struct
	Encapsulate private data of CursorChannel in a private struct. This
	isn't very useful at the moment, but it will help prepare the way for
	porting the RedChannel heirarchy to GObject.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-09-15  Uri Lublin  <uril@redhat.com>

	dcc_compress_image: fix a possible overflow when calculating image_size
	Both src->stride and src->y are uint32_t
	Fixed by making one of them uint64_t

	Found by coverity

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	dcc_gl_draw_item_new: allocate item when needed
	Prevents a leak on early return.

	Found by coverity.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	dcc_gl_scanout_item_new: allocate item when needed
	Prevents a leak on early return.

	Found by coverity.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	dcc: do not check the pointer returned by spice_new
	The rest of the code assumes spice_new does not return NULL

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-09-13  Li Zhijian  <lizhijian@cn.fujitsu.com>

	docs/spice_style.txt: fix typo
	'then' -> 'than'
	'character' -> 'characters'

2016-09-12  Pavel Grunt  <pgrunt@redhat.com>

	agent-filter: Constantify parameter
	Filter should not modify data

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-09-12  Frediano Ziglio  <fziglio@redhat.com>

	Remove global key_modifiers_timer variable
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Remove unused structure declaration
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-09-09  Jonathon Jongsma  <jjongsma@redhat.com>

	RedsState: clean up spice_server_char_device_add_interface
	Previously we were creating a variable named 'dev_state' and then
	apparently not using it. Well, we *were* actually using it, but in a
	convoluted sort of way. Creating a new RedCharDevice has a
	side-effect of setting itself as the 'st' attribute of
	SpiceCharDeviceInstance. So 'dev_state' and 'char_device->st' are in
	fact the same variable. But they were being used interchangeably, which
	was rather confusing. For example

	if (dev_state)
	    // do something with char_device->st

	So this patch doesn't actually change anything, but it makes the code a
	bit easier to follow.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-09-09  Christophe Fergeau  <cfergeau@redhat.com>

	Fix 'freezed' typo
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-09-08  Jonathon Jongsma  <jjongsma@redhat.com>

	Use RED_CHANNEL_CLIENT() macro for casting
	Also remove (main|inputs)_channel_client_get_base() function to prepare
	for porting to GObject.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-09-08  Victor Toso  <victortoso@redhat.com>

	mcc: early return and lower indentation
	main_channel_client_start_net_test() checks MainChannelClient already
	which is the single reason why main_channel_client_push_ping() could
	fail. Reorganizing this code a little bit.

	Acked-by: Frediano Ziglio <fziglio@redhat.com

	mcc: early return and lower indentation
	Acked-by: Frediano Ziglio <fziglio@redhat.com

2016-09-08  Jonathon Jongsma  <jjongsma@redhat.com>

	Rename RCC_TO_DCC() to DISPLAY_CHANNEL_CLIENT()
	Prepare for port to GObject

	Acked-by: Frediano Ziglio <fziglio@redhat.com

	Add DisplayChannelClientPrivate and CursorChannelPrivate structs
	These need to be introduced at the same time since cache-item.tmpl.c
	assumes that both of these classes will have a cache in the same place:
	either within the channel client struct itself or (now) within a priv
	struct owned by the channel client.

	This encapsulates private data and prepares for porting to GObject.

	Acked-by: Frediano Ziglio <fziglio@redhat.com

	Add RedChannelClientPrivate struct
	Encapsulate private data and prepare for port to GObject

	Acked-by: Frediano Ziglio <fziglio@redhat.com

	Add MainChannelClientPrivate struct
	Encapsulate private data and prepare for port to GObject

	Acked-by: Frediano Ziglio <fziglio@redhat.com

	Add InputsChannelClientPrivate struct
	Encapsulate private data and prepare for port to GObject.

	Acked-by: Frediano Ziglio <fziglio@redhat.com

	Add SmartCardChannelClientPrivate struct
	Prepare to port to GObject by encapsulating all private data

	Acked-by: Frediano Ziglio <fziglio@redhat.com

	Move CursorChannelClient to separate file
	Acked-by: Frediano Ziglio <fziglio@redhat.com

	Move RedChannelClient to separate file
	Reduce direct access to RedChannelClient, and get ready to convert to
	GObject.

	Acked-by: Frediano Ziglio <fziglio@redhat.com

2016-09-07  Pavel Grunt  <pgrunt@redhat.com>

	tests: Check setting of agent properties
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	reds: Do not crash when setting agent property
	Agent properties like file transfer or copy & paste can be disabled by
	calling spice_server_set_agent_{copypaste, file_xfer} before the spice
	server is initialized. In that case the call crashes the server because
	the agent device is created after the initialization.

	To avoid the crash this commit introduce a helper function for setting
	the agent properties after the server is initialized.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-08-30  Jonathon Jongsma  <jjongsma@redhat.com>

	Use red_channel_client_get_stream()
	Don't touch the rcc struct directly. Improve encapsulation to help
	prepare for separating RedChannelClient to a separate file.

	Don't poke RedChannelClient::send_data from RedChannel
	More preparation for separating RedChannelClient into a separate file.
	Rename function slightly for improved readability:
	 red_channel_client_blocked() -> red_channel_client_is_blocked()

	Add red_channel_client_(set|is)_destroying()
	Encapsulate the structure a bit more and avoid poking into it from other
	class implementations. Getting ready to split RedChannelClient out to a
	separate file.

	Use red_channel_client_get_client() everywhere
	Instead of having all other classes poke into the RedChannelClient
	struct to get the RedClient associated with the channel client, call the
	accessor function. This commit allows us to encapsulate RedChannelClient
	and move it to its own file soon.

	Add red_channel_client_get_channel()
	Don't poke into the structure to get the channel

	This prepares for encapsulating RedChannelClient a bit more and
	separating it into its own source file.

2016-08-12  Francois Gouget  <fgouget@codeweavers.com>

	server: Use SPICE_GNUC_DEPRECATED to avoid a dependency on glib.h
	spice-server.h cannot include glib.h because it is a public header and
	is used by projects that do not use GLib.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-08-12  Frediano Ziglio  <fziglio@redhat.com>

	OpenSSL from 1.1.0 is thread safe by default
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-08-11  Frediano Ziglio  <fziglio@redhat.com>

	Avoids to initialise OpenSSL threading twice
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gstreamer: Use a dummy format to make sure format is always defined.
	This avoid a check for NULL.
	Also will be used to catch invalid values when table will be extended.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Make process_commands_generation variable type coherent
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gstreamer: Peephole optimisation for SpiceFormatForGStreamer
	Reduce structure length using static allocated string inside the
	structure.
	This will also avoid using .data.rel.ro section and relocations
	reducing even more library size.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gstreamer: Fix infinite loop in get_period_bit_rate
	This was discovered by chance by me and Uri trying some remote connection
	with slow network (8Mbit) and high latency

	  $ ping 10.10.48.87 -c 3
	  3 packets transmitted, 3 received, 0% packet loss, time 2002ms
	  rtt min/avg/max/mdev = 281.069/316.758/374.413/41.153 ms

	The encoder->history status was (edited for readability):

	(gdb) p ((SpiceGstEncoder*)0x61c000264880)->history_first
	$6 = 29
	(gdb) p ((SpiceGstEncoder*)0x61c000264880)->history_last
	$14 = 28
	(gdb) p ((SpiceGstEncoder*)0x61c000264880)->history
	[0] {mm_time = 11298131, duration = 7391006, size = 5616},
	[1] {mm_time = 11298148, duration = 7373663, size = 5559},
	[2] {mm_time = 11298166, duration = 7052209, size = 5511},
	[3] {mm_time = 11298183, duration = 7006828, size = 5722},
	[4] {mm_time = 11298199, duration = 7433311, size = 5756},
	[5] {mm_time = 11298216, duration = 7134734, size = 5545},
	[6] {mm_time = 11298232, duration = 7436589, size = 5521},
	[7] {mm_time = 11298249, duration = 7152181, size = 5540},
	[8] {mm_time = 11298266, duration = 7181308, size = 7796},
	[9] {mm_time = 11298283, duration = 5053084, size = 50824},
	[10] {mm_time = 11298298, duration = 7472305, size = 7427},
	[11] {mm_time = 11298315, duration = 7385017, size = 6682},
	[12] {mm_time = 11298333, duration = 7287125, size = 6377},
	[13] {mm_time = 11298349, duration = 7191461, size = 6159},
	[14] {mm_time = 11298367, duration = 7104546, size = 6035},
	[15] {mm_time = 11298382, duration = 7266942, size = 5896},
	[16] {mm_time = 11298400, duration = 7108001, size = 5812},
	[17] {mm_time = 11298418, duration = 7020583, size = 5807},
	[18] {mm_time = 11298433, duration = 7066056, size = 5758},
	[19] {mm_time = 11298450, duration = 7052900, size = 5676},
	[20] {mm_time = 11298467, duration = 7248233, size = 5765},
	[21] {mm_time = 11298483, duration = 7077348, size = 5712},
	[22] {mm_time = 11298502, duration = 7495368, size = 5835},
	[23] {mm_time = 11298517, duration = 7068626, size = 5805},
	[24] {mm_time = 11298534, duration = 7060375, size = 5801},
	[25] {mm_time = 11298551, duration = 7020383, size = 5868},
	[26] {mm_time = 11298568, duration = 7248400, size = 5830},
	[27] {mm_time = 11298584, duration = 7001304, size = 6621},
	[28] {mm_time = 11298600, duration = 7311600, size = 6113},
	[29] {mm_time = 11297612, duration = 6999174, size = 5666},  <--- to
	[30] {mm_time = 11297628, duration = 7506688, size = 5502},
	[31] {mm_time = 11297646, duration = 7209494, size = 5687},
	[32] {mm_time = 11297663, duration = 7396429, size = 5724},
	[33] {mm_time = 11297679, duration = 7172624, size = 5839},
	[34] {mm_time = 11297696, duration = 7300811, size = 5645},
	[35] {mm_time = 11297713, duration = 7108985, size = 5553},
	[36] {mm_time = 11297729, duration = 7171701, size = 5774},
	[37] {mm_time = 11297745, duration = 7174018, size = 5637},
	[38] {mm_time = 11297762, duration = 7313549, size = 5655},
	[39] {mm_time = 11297780, duration = 5183985, size = 51014},
	[40] {mm_time = 11297796, duration = 7038329, size = 7374},
	[41] {mm_time = 11297813, duration = 7211506, size = 6585},
	[42] {mm_time = 11297830, duration = 7112690, size = 5729},
	[43] {mm_time = 11297846, duration = 7103074, size = 5761},
	[44] {mm_time = 11297864, duration = 7599826, size = 5661},
	[45] {mm_time = 11297879, duration = 7355392, size = 5351},
	[46] {mm_time = 11297897, duration = 7454367, size = 5488},
	[47] {mm_time = 11297913, duration = 7127145, size = 5573},
	[48] {mm_time = 11297932, duration = 7550098, size = 5447},
	[49] {mm_time = 11297948, duration = 7506884, size = 5809},
	[50] {mm_time = 11297966, duration = 7405712, size = 5783},
	[51] {mm_time = 11297982, duration = 7182025, size = 5599},
	[52] {mm_time = 11298001, duration = 7323887, size = 5817},
	[53] {mm_time = 11298014, duration = 7342091, size = 5575},
	[54] {mm_time = 11298031, duration = 7596319, size = 5739},
	[55] {mm_time = 11298052, duration = 7428169, size = 5669},
	[56] {mm_time = 11298065, duration = 7457282, size = 5732},
	[57] {mm_time = 11298081, duration = 7174029, size = 5541},
	[58] {mm_time = 11298097, duration = 7340512, size = 5680},
	[59] {mm_time = 11298115, duration = 7427439, size = 5701}}
	(gdb) p from
	$16 = 11297544
	(gdb) p to
	$17 = 11297612

	You can see that encoder->history[encoder->history_first].mm_time == to
	cause the check index == encoder->history_first to not be executed.

	This code change was suggested by Uri.

	Reported-by: Uri Lublin <uril@redhat.com>
	Tested-by: Uri Lublin <uril@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gstreamer: Use static compile check
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-08-09  Jonathon Jongsma  <jjongsma@redhat.com>

	Miscellaneous header changes
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-08-09  Frediano Ziglio  <fziglio@redhat.com>

	remove CommonGraphicsChannelClient structure
	Was just containing a RedChannelClient field

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	move is_low_bandwidth to DisplayChannelClient
	The field is only used by DisplayChannelClient, not by CursorChannelClient

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	remove common_graphics_channel_new_client function
	The function was just calling another function with same parameters

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	move during_target_migrate out of common_graphics_channel_new_client
	This reduces the number of arguments that need to be passed to the
	function, and also avoids changing a different object within a function
	that is supposed to just create a new object

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	move channel window setting to config_socket
	Make common_graphics_channel_new_client smaller

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-08-09  Jonathon Jongsma  <jjongsma@redhat.com>

	Limit direct access to DisplayChannelClient
	Add a few more methods and accessors so that other files don't need to
	manipulate the struct members directly. Move the struct definition to a
	private header which only the dcc-* files will include.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-08-04  Christophe Fergeau  <cfergeau@redhat.com>

	build: Update libtool versioning for 0.13.2

	Update spice-common
	This brings these changes:

	Christophe Fergeau (6):
	      Update verify.h to latest version
	      codegen: Remove unused write_message_marshaller argument
	      Adjust verify.h licence
	      codegen: Fix 'registred' typo
	      codegen: Use "" rather than <> for cmdline includes
	      codegen: Autogenerate client_marshallers.h

	Eduardo Lima (Etrunko) (1):
	      Use explicit path for inclusion

	Francois Gouget (1):
	      codegen: Fix compatibility with Python 2.6

	Frediano Ziglio (4):
	      add a check for negate cases on enumerations
	      extend a comment for type attributes
	      Use a macro to simplify ring_get_length
	      codegen: Improve header guard generation

	Pavel Grunt (1):
	      codegen: Do not generate extra null check

	Update NEWS for 0.13.2

2016-08-03  Frediano Ziglio  <fziglio@redhat.com>

	gstreamer: Allows to add output format to options
	This allow option string to contain separator so you could set as
	"field=value ! format".
	This is useful as some encoders use the output format to specify
	compression types (for instance with some H264 encoders you can
	specify the profile to use).

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	gstreamer: Peephole optimisation
	SpiceGstFrameInformation change from 24 to 16 bytes reducing
	SpiceGstEncoder 480 bytes.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-08-02  snir sheriber  <ssheribe@redhat.com>

	User-Manual: mention webdav is disabled by default
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-08-02  Frediano Ziglio  <fziglio@redhat.com>

	Reduce indentation inverting condition
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix typo for macro names
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-08-01  Frediano Ziglio  <fziglio@redhat.com>

	Handle scancode extensions E1 and E2
	Do not handle them as normal keys.
	State is not saved for these keys.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Prevent possible buffer overflow in SpiceKbdState
	key and key_ext in SpiceKbdState are indexed using

	   state[scan & 0x7f]

	where scan is a 8 bit value got from client. In theory client can send
	any value causing scan & 0x7f to be 0x7f. However these arrays contains
	only 0x7f values so 0x7f cause a off one overflow.
	This potentially cause key_ext to overflow in reds pointer following.
	Happily this is not exploitable in either 32 or 64 bit environment.
	On 64 bit key_ext is followed by a 4 byte (sizeof(bool) == 4) padding
	which is written by the possible overflow.
	On 32 bit reds will be overwritten with either 0 or 1 which will cause
	a SIGSEGV leading to a DoS. Considering that you have to have access
	to the machine with a client you are just shutting down only guests you
	can access to.

	Acked-by: Uri Lublin <uril@redhat.com>

2016-07-28  Marc-André Lureau  <marcandre.lureau@redhat.com>

	Call migrate_end_complete() after falling back to switch-host
	Eventually, during a seamless migration, qemu may finish to migrate
	before the spice client even finished to connect all channels to
	destination and informed the server. In this case,
	main_channel_client_migrate_src_complete() will fall back to
	switch-host method, and reds_mig_fill_wait_disconnect() is called to
	complete the migration (disconnecting all channels).

	reds_mig_cleanup() is called when all channels are disconnected, but
	reds->mig_wait_connect is still TRUE, and it will call
	migrate_connect_complete() instead of the expected
	migrate_end_complete(). Setting reds->mig_wait_connect to FALSE when
	reds_mig_fill_wait_disconnect() solves the issue.

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1352836

2016-07-28  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Don't start streaming if there is no video encoder
	Without a video encoder no frame will be streamed anyway.
	This fixes the case where the client does not support any of the
	server's codecs, such as if it was compiled with --enable-gstvideo=no
	--disable-builtin-mjpeg.

2016-07-27  Francois Gouget  <fgouget@codeweavers.com>

	server: Make sure g_object_new receive the correct data
	g_object_new is a variadic function which takes property values.
	As the compiler cannot check if these property values are correct,
	make sure they are using casts.
	This actually fixes a crash in reds.c for 32 bit architectures.

	Based on a patch by Frediano Ziglio <fziglio@redhat.com>

2016-07-14  Uri Lublin  <uril@redhat.com>

	spicevmc_device_connect: get parser for appropriate channel_type
	spicevmc_device_connect() is called for non-usb types too.

2016-07-13  Frediano Ziglio  <fziglio@redhat.com>

	Fix gl draw command called without scanout
	This happens during VM shutdown.
	Qemu should never send a draw command without scanout.
	This should be fixed in Qemu  or in Virgl driver.

	Acked-by: Uri Lublin <uril@redhat.com>

	Use fd parameter instead of reading file descriptor from reds
	Acked-by: Uri Lublin <uril@redhat.com>

	Remove useless return statement
	Acked-by: Uri Lublin <uril@redhat.com>

2016-07-08  Marc-André Lureau  <marcandre.lureau@redhat.com>

	smartcard: allocate msg with the expected size
	This is related to CVE-2016-0749

	==529== ERROR: AddressSanitizer: heap-buffer-overflow on address 0x60040009c098 at pc 0x7fffee0eda6d bp 0x7fffffffcd00 sp 0x7fffffffccf0
	WRITE of size 4 at 0x60040009c098 thread T0
	    #0 0x7fffee0eda6c in smartcard_char_device_notify_reader_add /home/elmarco/pkg/spice/spice-0.12.4/server/smartcard.c:334
	    #1 0x7fffee0ef783 in smartcard_add_reader /home/elmarco/pkg/spice/spice-0.12.4/server/smartcard.c:642
	    #2 0x7fffee0f0568 in smartcard_channel_handle_message /home/elmarco/pkg/spice/spice-0.12.4/server/smartcard.c:757
	    #3 0x7fffee032f3f in red_peer_handle_incoming /home/elmarco/pkg/spice/spice-0.12.4/server/red_channel.c:304
	    #4 0x7fffee033216 in red_channel_client_receive /home/elmarco/pkg/spice/spice-0.12.4/server/red_channel.c:322
	    #5 0x7fffee03bf1f in red_channel_client_event /home/elmarco/pkg/spice/spice-0.12.4/server/red_channel.c:1561
	    #6 0x555555c3c53d in qemu_iohandler_poll /home/elmarco/src/qemu/iohandler.c:143
	    #7 0x555555c3b800 in main_loop_wait /home/elmarco/src/qemu/main-loop.c:504
	    #8 0x5555556f160c in main_loop /home/elmarco/src/qemu/vl.c:1818
	    #9 0x5555556f160c in main /home/elmarco/src/qemu/vl.c:4394
	    #10 0x7fffed80eb14 in __libc_start_main /usr/src/debug/glibc-2.17-c758a686/csu/libc-start.c:274
	    #11 0x5555556f9c20 in _start (/home/elmarco/src/qemu/x86_64-softmmu/qemu-system-x86_64+0x1a5c20)
	0x60040009c098 is located 0 bytes to the right of 8-byte region [0x60040009c090,0x60040009c098)
	allocated by thread T0 here:
	    #0 0x7ffff4e612be in __interceptor_realloc /usr/src/debug/gcc-4.8.5-20150702/obj-x86_64-redhat-linux/x86_64-redhat-linux/libsanitizer/asan/../../../../libsanitizer/asan/asan_malloc_linux.cc:92
	    #1 0x7fffee121308 in spice_realloc /home/elmarco/pkg/spice/spice-0.12.4/spice-common/common/mem.c:123
	    #2 0x7fffee004a48 in __spice_char_device_write_buffer_get /home/elmarco/pkg/spice/spice-0.12.4/server/char_device.c:516
	    #3 0x7fffee004e87 in spice_char_device_write_buffer_get /home/elmarco/pkg/spice/spice-0.12.4/server/char_device.c:557
	    #4 0x7fffee0ed8b9 in smartcard_char_device_notify_reader_add /home/elmarco/pkg/spice/spice-0.12.4/server/smartcard.c:325
	    #5 0x7fffee0ef783 in smartcard_add_reader /home/elmarco/pkg/spice/spice-0.12.4/server/smartcard.c:642
	    #6 0x7fffee0f0568 in smartcard_channel_handle_message /home/elmarco/pkg/spice/spice-0.12.4/server/smartcard.c:757
	    #7 0x7fffee032f3f in red_peer_handle_incoming /home/elmarco/pkg/spice/spice-0.12.4/server/red_channel.c:304
	    #8 0x7fffee033216 in red_channel_client_receive /home/elmarco/pkg/spice/spice-0.12.4/server/red_channel.c:322
	    #9 0x7fffee03bf1f in red_channel_client_event /home/elmarco/pkg/spice/spice-0.12.4/server/red_channel.c:1561
	    #10 0x555555c3c53d in qemu_iohandler_poll /home/elmarco/src/qemu/iohandler.c:143
	SUMMARY: AddressSanitizer: heap-buffer-overflow /home/elmarco/pkg/spice/spice-0.12.4/server/smartcard.c:334 smartcard_char_device_notify_reader_add

	smartcard: add a ref to item before adding to pipe
	There is an unref when the message is sent.
	This is related to CVE-2016-0749

	==17204== ERROR: AddressSanitizer: heap-use-after-free on address 0x6008000144a8 at pc 0x7fffee0ce245 bp 0x7fffffffc630 sp 0x7fffffffc620
	READ of size 4 at 0x6008000144a8 thread T0
	    #0 0x7fffee0ce244 in smartcard_unref_vsc_msg_item /home/elmarco/src/spice/spice/server/smartcard.c:608
	    #1 0x7fffee0cb451 in smartcard_unref_msg_to_client /home/elmarco/src/spice/spice/server/smartcard.c:178
	    #2 0x7fffedfcdf14 in spice_char_device_read_from_device /home/elmarco/src/spice/spice/server/char-device.c:330
	    #3 0x7fffedfd1763 in spice_char_device_wakeup /home/elmarco/src/spice/spice/server/char-device.c:901
	    #4 0x7fffee05da98 in spice_server_char_device_wakeup /home/elmarco/src/spice/spice/server/reds.c:2990
	    #5 0x55555593fa34 in spice_chr_write /home/elmarco/src/qemu/spice-qemu-char.c:189
	    #6 0x5555559375f1 in qemu_chr_fe_write /home/elmarco/src/qemu/qemu-char.c:220
	    #7 0x555555b3b682 in ccid_card_vscard_send_msg.isra.2 /home/elmarco/src/qemu/hw/usb/ccid-card-passthru.c:76
	    #8 0x555555b3c466 in ccid_card_vscard_send_error /home/elmarco/src/qemu/hw/usb/ccid-card-passthru.c:91
	    #9 0x555555b3c466 in ccid_card_vscard_handle_message /home/elmarco/src/qemu/hw/usb/ccid-card-passthru.c:242
	    #10 0x555555b3c466 in ccid_card_vscard_read /home/elmarco/src/qemu/hw/usb/ccid-card-passthru.c:289
	    #11 0x55555593f169 in vmc_write /home/elmarco/src/qemu/spice-qemu-char.c:41
	    #12 0x7fffedfcee6d in spice_char_device_write_to_device /home/elmarco/src/spice/spice/server/char-device.c:477
	    #13 0x7fffedfcfd31 in spice_char_device_write_buffer_add /home/elmarco/src/spice/spice/server/char-device.c:629
	    #14 0x7fffee0ce9df in smartcard_channel_write_to_reader /home/elmarco/src/spice/spice/server/smartcard.c:675
	    #15 0x7fffee0cc7db in smartcard_char_device_notify_reader_add /home/elmarco/src/spice/spice/server/smartcard.c:341
	    #16 0x7fffee0ce4f3 in smartcard_add_reader /home/elmarco/src/spice/spice/server/smartcard.c:648
	    #17 0x7fffee0cf2e2 in smartcard_channel_handle_message /home/elmarco/src/spice/spice/server/smartcard.c:763
	    #18 0x7fffedffe21f in red_peer_handle_incoming /home/elmarco/src/spice/spice/server/red-channel.c:307
	    #19 0x7fffedffe4f6 in red_channel_client_receive /home/elmarco/src/spice/spice/server/red-channel.c:325
	    #20 0x7fffee00726c in red_channel_client_event /home/elmarco/src/spice/spice/server/red-channel.c:1566
	    #21 0x555555c3c53d in qemu_iohandler_poll /home/elmarco/src/qemu/iohandler.c:143
	    #22 0x555555c3b800 in main_loop_wait /home/elmarco/src/qemu/main-loop.c:504
	    #23 0x5555556f160c in main_loop /home/elmarco/src/qemu/vl.c:1818
	    #24 0x5555556f160c in main /home/elmarco/src/qemu/vl.c:4394
	    #25 0x7fffed7d0b14 in __libc_start_main /usr/src/debug/glibc-2.17-c758a686/csu/libc-start.c:274
	    #26 0x5555556f9c20 in _start (/home/elmarco/src/qemu/x86_64-softmmu/qemu-system-x86_64+0x1a5c20)
	0x6008000144a8 is located 24 bytes inside of 40-byte region [0x600800014490,0x6008000144b8)
	freed by thread T0 here:
	    #0 0x7ffff4e61009 in __interceptor_free /usr/src/debug/gcc-4.8.5-20150702/obj-x86_64-redhat-linux/x86_64-redhat-linux/libsanitizer/asan/../../../../libsanitizer/asan/asan_malloc_linux.cc:61
	    #1 0x7fffee0ce2a1 in smartcard_unref_vsc_msg_item /home/elmarco/src/spice/spice/server/smartcard.c:610
	    #2 0x7fffee0cdd58 in smartcard_channel_release_pipe_item /home/elmarco/src/spice/spice/server/smartcard.c:548
	    #3 0x7fffee000668 in red_channel_client_release_item /home/elmarco/src/spice/spice/server/red-channel.c:602
	    #4 0x7fffee0006ef in red_channel_client_release_sent_item /home/elmarco/src/spice/spice/server/red-channel.c:609
	    #5 0x7fffee0007b5 in red_channel_peer_on_out_msg_done /home/elmarco/src/spice/spice/server/red-channel.c:620
	    #6 0x7fffedffed7e in red_peer_handle_outgoing /home/elmarco/src/spice/spice/server/red-channel.c:385
	    #7 0x7fffee0057bb in red_channel_client_send /home/elmarco/src/spice/spice/server/red-channel.c:1294
	    #8 0x7fffee0076e6 in red_channel_client_begin_send_message /home/elmarco/src/spice/spice/server/red-channel.c:1605
	    #9 0x7fffee0cdccd in smartcard_channel_send_item /home/elmarco/src/spice/spice/server/smartcard.c:541
	    #10 0x7fffee000570 in red_channel_client_send_item /home/elmarco/src/spice/spice/server/red-channel.c:588
	    #11 0x7fffee005bfb in red_channel_client_push /home/elmarco/src/spice/spice/server/red-channel.c:1347
	    #12 0x7fffee007ef7 in red_channel_client_pipe_add_push /home/elmarco/src/spice/spice/server/red-channel.c:1673
	    #13 0x7fffee0cde4d in smartcard_channel_client_pipe_add_push /home/elmarco/src/spice/spice/server/smartcard.c:571
	    #14 0x7fffee0cb567 in smartcard_send_msg_to_client /home/elmarco/src/spice/spice/server/smartcard.c:187
	    #15 0x7fffedfcdba2 in spice_char_device_send_msg_to_clients /home/elmarco/src/spice/spice/server/char-device.c:282
	    #16 0x7fffedfcdea4 in spice_char_device_read_from_device /home/elmarco/src/spice/spice/server/char-device.c:329
	    #17 0x7fffedfd1763 in spice_char_device_wakeup /home/elmarco/src/spice/spice/server/char-device.c:901
	    #18 0x7fffee05da98 in spice_server_char_device_wakeup /home/elmarco/src/spice/spice/server/reds.c:2990
	    #19 0x55555593fa34 in spice_chr_write /home/elmarco/src/qemu/spice-qemu-char.c:189

2016-07-01  Pavel Grunt  <pgrunt@redhat.com>

	Fix -Werror=format with DEBUG_ENCODE
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Do not force computing streaming statistic
	Let user to define STREAM_STATS to enable them

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Fix compiling with defined DEBUG_DISPATCHER
	setup_dummy_signal_handler was used before declared

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-29  Frediano Ziglio  <fziglio@redhat.com>

	Constify spice_server_char_device_recognized_subtypes
	Users should not change the list of supported subtypes.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Constify event_loop_core
	Was used as write variable only for testing.
	Avoid usage of not constant globals.
	Making globals constants avoid future race condition
	usages.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-22  Frediano Ziglio  <fziglio@redhat.com>

	Protect globals servers variable with a mutex
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Make video_encoder_procs constant
	This is not going to be modified.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Initialise OpenSSL just once
	Avoid multiple initializations of this library.
	Also initialize using thread safe code to avoid possible race
	conditions.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Make spice_server_char_device_recognized_subtypes_list static
	Not used outside the compile unit.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Make servers global static
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-20  Frediano Ziglio  <fziglio@redhat.com>

	Use proper types in compress_send_data_t
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-17  Frediano Ziglio  <fziglio@redhat.com>

	Make RedGlzDrawable typedef private
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Destroy pthread structures
	Current Linux pthread implementation should use futex so there should
	be no leak but calling destroy avoid possible future leaks.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Rename dcc-encoders.[ch] to image-encoders.[ch]
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Reduce header dependency
	Avoid dependencies from RedChannel stuff.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove dependency from dcc-encoders to Drawable
	Encoding image requires a RedDrawable (where the data is stored) and
	a Ring where to store information to free Glz structures.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Use new GlzImageRetention instead of accessing Drawable internals
	Remove some coupling, we mainly need to store a list of RedGlzDrawables.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-16  Frediano Ziglio  <fziglio@redhat.com>

	Make GlzSharedDictionary structure private in dcc-encoders.c
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Do not access ImageEncoders internal to lock/unlock glz encoding
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Better encapsulation for image_encoders_compress_glz call
	Do not access too much encoders data.
	Slightly different as now if glz is frozen lz compression is used.
	Glz is frozen only during migration.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Rename encoder_globals to encoder_shared_data
	Was missing due to a mistake.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove unused free_compress_bufs field from DisplayChannel
	RedCompressBuf are no longer pooled.
	The usage was removed in 92d9b782bd0754083f79a04a9e9edc38339c0cc4.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-16  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	Move lz4-encoder.[ch] to conditional block in Makefile.am
	Let's follow the 'standard' for optional components. This commit also
	drops (now) unecessary #ifdef USE_LZ4 from lz4-encode.c, as the decision
	to build this file is now made in Makefile.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Use correct variable to print if LZ4 support is to be built.

2016-06-16  Frediano Ziglio  <fziglio@redhat.com>

	Make video-encoder.h self independent
	gpointer definition was not included causing the header to fails to
	compile if included first.

	Acked-by: Francois Gouget <fgouget@codeweavers.com>

2016-06-16  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	Fix set but not used variable warning
	Introduced by commit 903c91cd3013c763abd3f2292f8fbd911a0c83f0, this
	variable is used only for LZ4 code. Move the declaration to the proper
	block of code.

	Build log:

	spicevmc.c: In function 'handle_compressed_msg':
	spicevmc.c:346:14: error: variable 'decompressed' set but not used [-Werror=unused-but-set-variable]
	     uint8_t *decompressed;
	                   ^

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix build for systems without LZ4 dependency installed
	This was introduced by commit 903c91cd3013c763abd3f2292f8fbd911a0c83f0.
	To fix it, we simply protect the try_compress_lz4 function with proper
	ifdef guards.

	Build log:

	spicevmc.c: In function 'try_compress_lz4':
	spicevmc.c:143:5: error: implicit declaration of function 'LZ4_compress_default' [-Werror=implicit-function-declaration]
	     compressed_data_count = LZ4_compress_default((char*)&msg_item->buf,
	     ^
	spicevmc.c:143:5: error: nested extern declaration of 'LZ4_compress_default' [-Werror=nested-externs]

	spicevmc.c: At top level:
	spicevmc.c:124:24: error: 'try_compress_lz4' defined but not used [-Werror=unused-function]
	 static RedVmcPipeItem* try_compress_lz4(SpiceVmcState *state, int n, RedVmcPipeItem *msg_item)
	                        ^

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-06-16  Frediano Ziglio  <fziglio@redhat.com>

	Remove message_buf from EncoderData
	This buffer was just written and then used, no reason to store into
	a more persistent structure.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-16  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	configure: Better wording hasn't -> has not
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-15  Frediano Ziglio  <fziglio@redhat.com>

	Make red_glz_drawable_free() static
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Encapsulate some data in dcc-encoders
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-15  Pavel Grunt  <pgrunt@redhat.com>

	Fix missing prototypes
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove unused reds_expects_link_id
	Not needed since f683815ad53cc39f485ddac9770e23282ca5c340

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-06-15  Jonathon Jongsma  <jjongsma@redhat.com>

	Rename image_encoders_free_glz_drawable()
	Rename this function to red_glz_drawable_free() and remove the
	ImageEncoders argument since the RedGlzDrawable already holds a pointer
	to the ImageEncoders structure

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Rename image_encoders_free_glz_drawable_instance()
	Rename this function to glz_drawable_instance_item_free() and remove the
	ImageEncoders argument since the RedGlzDrawable already holds a pointer
	to the ImageEncoders structure.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-06-15  Frediano Ziglio  <fziglio@redhat.com>

	Make image_encoders_freeze_glz() static
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Encapsulate code to save glz state
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Change RedGlzDrawable::drawable from pointer to boolean
	The field was used just as a flag.
	This has the advantage to make clear to not use the pointer as we don't
	have ownership.
	Also makes the structure a bit smaller.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Better encoders encapsulation
	Avoid to access some fields from dcc.c

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Encapsulate dcc_release_glz
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-14  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Add support for GStreamer 0.10
	configure will use GStreamer 1.0 if present and fall back to
	GStreamer 0.10 otherwise.
	ffenc_mjpeg takes its bitrate as a long so extend set_gstenc_bitrate().

	streaming: Dynamically adjust the GStreamer encoder bitrate if possible
	This is faster and lets the encoder leverage past bitrate shaping
	history to attain the target faster.

	streaming: Respect the GStreamer encoder's valid bit rate range
	GObject returns an error instead of clamping if given an out of range
	property value.

	streaming: Give up after a while if GStreamer cannot handle the video
	This typically happens when sending very small frames (less than
	16 pixels in one dimension) to the x264enc encoder.
	This avoids repeatedly wasting time rebuilding the pipeline.

	streaming: Adjust the frame rate based on the GStreamer encoding time

	streaming: Adjust the GStreamer encoder bit rate to the network
	The video encoder uses the client reports and/or notifications of
	server frame drops as its feedback mechanisms. In particular it keeps
	track of the maximum video margin and reduces the bit rate whenever the
	margin goes below certain thresholds or decreases too sharply.
	It uses these to figure out the lowest bit rate that causes negative
	feedback, and the highest bit rate that allows a return to positive
	feedbacks. It then works to narrow this range and settles on the lower
	end once the spread has gone below a given threshold.
	All the while it monitors the effective bit rate to ensure the target
	bit rate does not grow significantly beyond what the GStreamer encoder
	will produce: this avoids target bit rate 'bubbles' which would
	invariably be followed by a bit rate crash with accompanying frame loss.
	As soon as the network feedback indicates a significant degradation the
	bit rate is lowered to minimize the risk of frame loss and/or long
	freezes.
	It also relies on the existing shaping of the GStreamer output bit rate
	to minimize the pipeline reconfigurations.

	streaming: Shape the bit rate of the GStreamer codecs output
	The GStreamer codecs don't follow the specified bit rate very closely:
	they can decide to exceed it for ten seconds or more if they consider
	the scene deserves it. Such long bursts are enough to cause network
	congestion, resulting in many lost frames which cause significant
	display corruption.
	So the GStreamer video encoder now uses a short 300ms virtual buffer
	to shape the compressed video output and ensure we don't exceed the
	target bit rate for any significant length of time.
	It could instead rely on the network feedback (when available) to lower
	the bit rate. However frequent GStreamer bit rate changes lower the
	overall compression level and also result in a lower average bit rate,
	both of which result in lower video quality.
	The GStreamer video encoder also keeps track of the encoded frame size
	so it can gather statistics and call update_client_playback_delay()
	with accurate information and also annotate the client report debug
	traces with the corresponding bit rate information.

	streaming: Add h264 support to the GStreamer video encoder

	streaming: Avoid copying the input frame in the GStreamer encoder
	Note that we can only avoid copies for the first 1 Mpixels or so.
	That's because Spice splits larger frames into more chunks than we can
	fit GstMemory fragments in a GStreamer buffer. So if there are more
	pixels we will avoid copies for the first 3840 KB and copy the rest.
	Furthermore, while in practice the GStreamer encoder will only modify
	the RedDrawable refcount during the encode_frame(), in theory the
	refcount could be decremented from the GStreamer thread after
	encode_frame() returns.

	streaming: Handle and recover from GStreamer encoding errors
	If an error occurs for whatever reason (e.g. codec not supporting odd
	frame sizes), the GStreamer pipeline will drop the current buffer,
	causing the encoder to be stuck waiting for the sample. So this patch
	tracks error notifications and ensures we don't wait for a sample if
	none will come.

	streaming: Let the video encoder manage the compressed buffer
	This way the video encoder is not forced to use malloc()/free().
	This also allows more flexibility in how the video encoder manages the
	buffer which allows for a zero-copy implementation in both video
	encoders.

	streaming: Add VP8 support to the GStreamer video encoder

2016-06-14  Pavel Grunt  <pgrunt@redhat.com>

	replay: Add an option to change video codec

2016-06-14  Francois Gouget  <fgouget@codeweavers.com>

	streaming: Let the administrator pick the video encoder and codec
	The Spice server administrator can specify the encoder and codec
	preferences to optimize for CPU or bandwidth usage. Preferences are
	described in a semi-colon separated list of encoder:codec pairs.
	The server has a default preference list which can explicitly be
	selected by specifying 'auto'.

	streaming: Check the client video codec capabilities
	The server picks a codec supported by the client based on the following
	new client capabilities:
	 * SPICE_DISPLAY_CAP_MULTI_CODEC which denotes a recent client that
	   supports multiple codecs. This capability is needed to not have to
	   hardcode that MJPEG is supported. This makes it possible to write
	   clients that don't support MJPEG.
	 * SPICE_DISPLAY_CAP_CODEC_XXX, where XXX is a supported codec. Note
	   that for now the server only supports the MJPEG codec.

	streaming: Add a GStreamer 1.0 MJPEG video encoder and use it by default
	This introduces a pared down GStreamer-based video encoder to serve as
	the basis for later enhancements.
	In this form the new encoder supports both regular and sized streams
	but lacks any rate control. It should still work fine if bandwidth is
	sufficient such as on LANs.

	streaming: Remove the width/height encode_frame() parameters
	encode_frame() needs the QXL_DRAW_COPY operation's SpiceCopy.src_area
	field anyway, so the width and height parameters were redundant.

	mjpeg: Use src_area as the authoritative source for the frame dimensions
	Video frames correspond to QXL_DRAW_COPY operations where the frame area
	is defined by the SpiceCopy.src_area field.

	streaming: Simplify is_next_stream_frame()
	After the removal of Drawable::sized_stream, we no longer need to detect
	if the stream changes size in is_next_stream_frame() so it can return a
	boolean rather than a value from an enum.

	streaming: Remove unused detach_stream() argument
	After the removal of Drawable::sized_stream, the last argument to
	detach_stream() is no longer used.

	streaming: Remove the Drawable.sized_stream field
	Only red_marshall_stream_data() needs to know whether to send the frame
	using a SpiceMsgDisplayStreamDataSized or a regular StreamData message.
	So check whether we have a sized frame there and simplify the rest of
	the code.

	streaming: Rework red_marshall_stream_data a bit
	This code just refactors the function without doing any functional
	changes. The actual changes will be in the next commit, and this will
	make the next commit much more obvious.

	streaming: Better check for sized frames
	Usually the RedDrawable bbox dimensions match the src_area dimensions
	so that checking that the bbox matches the stream's original dest_area
	should be enough to determine if sized stream support is needed to
	send the frame.
	But making the bbox different could be used to have the scaling be
	performed on the client side. So it's better not to assume the bbox and
	src_area have the same dimensions.

2016-06-14  Frediano Ziglio  <fziglio@redhat.com>

	Move image_encoders_compress_glz to dcc-encoders.c
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Make dcc_compress_image_glz independent to DisplayChannelClient
	Also rename to image_encoders_compress_glz

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Move others glz fields to dcc-encoders
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Change dcc_encoders_init to take ImageEncoders instead of DisplayChannelClient
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Move some glz fields to ImageEncoders
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Add a structure to hold ImageEncoders shared data
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-14  snir sheriber  <ssheribe@redhat.com>

	LZ4 compression is now available at the Spicevmc channel
	Compressed message type is CompressedData which contains compression
	type (1 byte) followed by the uncompressed data size (4 bytes - exists
	only if data was compressed) followed by the compressed data

	If SPICE_USBREDIR_CAP_DATA_COMPRESS_LZ4 capability is available &&
	data_size > COMPRESS_THRESHOLD && !AF_LOCAL data will be sent
	compressed otherwise data will be sent uncompressed (also if
	compression has failed)

	Update the required protocol to 0.12.12

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-06-10  Frediano Ziglio  <fziglio@redhat.com>

	Remove unused DCC_TO_WORKER macro
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	More encapsulation for dcc_encoders_free
	Encoders function should not use DisplayChannelClient

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Encapsulate zlib information in ImageEncoders structure
	This change is less clean the other similar patches as zlib and
	glz require more steps.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-09  Frediano Ziglio  <fziglio@redhat.com>

	Move image_encoders_compress_lz4 to dcc-encoders.c
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Prepare to move dcc_compress_image_lz4 to ImageEncoders
	Remove all DisplayChannel(Client) dependencies.
	Rename function.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Encapsulate lz4 information in ImageEncoders structure
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Move image_encoders_compress_jpeg to dcc-encoders.c
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Prepare to move dcc_compress_image_jpeg to ImageEncoders
	Remove all DisplayChannel(Client) dependencies.
	Rename function.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Encapsulate jpeg information in ImageEncoders structure
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Move image_encoders_compress_lz to dcc-encoders.c
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Prepare to move dcc_compress_image_lz to ImageEncoders
	Remove all DisplayChannel(Client) dependencies.
	Rename function.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Encapsulate lz information in ImageEncoders structure
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Move image_encoders_compress_quic to dcc-encoders.c
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Prepare to move dcc_compress_image_quic to ImageEncoders
	Remove all DisplayChannel(Client) dependencies.
	Rename function.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Encapsulate quic information in a new ImageEncoders structure
	Start putting all encoding code into dcc-encoders.c.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Move marshalling code from dcc-encoders to dcc-send
	No reasons why dcc-encoders should know about marshalling.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Add compress_buf_free function
	dcc-encoders should be in change of allocate and free the structure
	don't put internal assumptions (which functions are used for memory
	management) in different files.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-06-08  Frediano Ziglio  <fziglio@redhat.com>

	record: Use spice_get_monotonic_time_ns instead of stat_now(CLOCK_MONOTONIC)
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	record: Use proper type for timestamp
	Use red_time_t to make sure timestamp has the right precision even
	on 32 bit systems.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	improve primary surface parameter checks
	Primary surface, as additional surfaces, can be used to access
	host memory from the guest using invalid parameters.

	The removed warning is not enough to prevent all cases. Also a warning
	is not enough to stop an escalation to happen.
	The red_validate_surface do different checks to make sure surface
	request is valid and not cause possible buffer/integer overflows:
	- format is valid;
	- width is not large to cause overflow compared to stride;
	- stride is not -2^31 (a number which negate is still <0);
	- stride * height does not overflow.

	This fixes https://bugzilla.redhat.com/show_bug.cgi?id=1312980.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	factor out red_validate_surface function to validate surface parameters
	Make possible to reuse it outside red-parse-qxl.c.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Move dcc glz field initialization into dcc_new
	There is no reason to initialize these fields in two different places.
	Note that an usage between dcc_new and the function where these
	field were initialised would have resulted in a crash.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-07  Frediano Ziglio  <fziglio@redhat.com>

	record: Make red_record_cursor_cmd static
	This function is never used outside this compile unit.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: Handle cursor commands
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-07  Victor Toso  <victortoso@redhat.com>

	char-device: fix mismatch of client tokens
	As the tokens counter were not being reset you could enter in a
	situation where client thinks it has more tokens then server which
	would eventually lead to client's disconnection from 0c5eca97f16ec6
	onwards (before it was crashing).

	It is easy to check the above situation if you track the amount of
	tokens you have in the client and simply kill and restart the agent
	while doing some file transfer: the client could reach more then 13
	tokens which should not really be possible.

	Based on patch from Frediano Ziglio <fziglio@redhat.com>

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-06-06  Frediano Ziglio  <fziglio@redhat.com>

	replay: Load cursor commands
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: Record cursor commands
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	record: Support cursor commands
	Use red_record_cursor_cmd to be able to record cursor commands.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	avoid integer underflow under 32 bit architectures
	The segment_size computation on 32 bit can lead to big numbers which
	can lead to negative offset. Let'ss avoid to underrun the buffer,
	as it's not checked.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-06-05  Frediano Ziglio  <fziglio@redhat.com>

	fix integer overflows in red_get_path
	Use 64 bit arithmetic to avoid overflows.
	The multiplication between count and a constant can overflow.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-06-04  Frediano Ziglio  <fziglio@redhat.com>

	Remove unused parameter
	Acked-by: Jonathon Jongsma <jjongsma at redhat.com>

2016-06-03  Frediano Ziglio  <fziglio@redhat.com>

	Remove only written field
	EncoderData::dcc field is never read back.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-03  Francois Gouget  <fgouget@codeweavers.com>

	red-parse-qxl: Check consistency of QXL_DRAW_COPY operations
	The source area should not extend outside the source bitmap, or have
	swapped coordinates.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-06-02  Jonathon Jongsma  <jjongsma@redhat.com>

	Remove global "allowed" variable
	This variable was always the same value as
	dispatcher_allows_client_mouse.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-06-02  Frediano Ziglio  <fziglio@redhat.com>

	Remove only written lock_count variable
	Possibly used for debugging or an initial recursive lock.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-06-01  Frediano Ziglio  <fziglio@redhat.com>

	channel: Remove clients_num and use g_list_length
	This fixes a regression introduced by
	4028fb1c794ef2a212f22b024b1c39f460439e7b, where clients_num
	was not updated correctly anymore.

	There is no reason to cache the number of elements on that list,
	as the expected number of clients is quite small.

	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

	smartcard: Avoid crash on remove_interface call
	SpiceCharDeviceInstance is not a GObject, the GObject is char_device->st
	as the above line is stating.
	The crash never happen as Qemu never calls spice_server_remove_interface
	for smartcards.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify setting char device instance
	Setting "sin" property is equivalent to call
	red_char_device_reset_dev_instance so there is no need for a if/else
	as the code is doing mostly (beside setting agent_attached) the
	same thing

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove obsolete comment
	AGENT_CONNECT with token count is implemented by agent_connected_tokens
	message.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Fix some typos in comments
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-05-31  Jonathon Jongsma  <jjongsma@redhat.com>

	Replace RedClient::channels with GList
	Allows us to not expose the client_link in RedChannelClient.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-31  Frediano Ziglio  <fziglio@redhat.com>

	Handle flow control without crashing for agent
	RedCharDevice used for the agent has flow control enabled.
	This make possible for red_char_device_write_buffer_get to return NULL.
	Handle such situation without crashing avoiding NULL dereference.

	This fixes https://bugs.freedesktop.org/show_bug.cgi?id=95416.

	Acked-by: Uri Lublin <uril@redhat.com>

2016-05-27  Frediano Ziglio  <fziglio@redhat.com>

	Avoid getting channel from client
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Move upcast conversion to a safer place
	Upcast conversions are by definition unsafe. There are however some
	location where such conversion are more safe. In this case send_item
	callback is registered specifically for this type of RedChannel making
	the conversion more reliable.
	The other conversion (CursorChannel -> RedChannel) became safe.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Add some comments to cursor-channel.h header
	Explain usage of the class.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-05-26  Frediano Ziglio  <fziglio@redhat.com>

	Avoid double conversion
	Avoid converting from RedChannelClient* to DisplayChannelClient* and
	DisplayChannelClient* to RedChannelClient* just to use RedChannelClient*
	('display_channel->clients' is a list of RedChannelClients).

	Acked-by: Uri Lublin <uril@redhat.com>

	Remove useless double conversion
	Avoid converting RedChannelClient* to CursorChannelClient* and then
	CursorChannelClient* to RedChannelClient* just to use RedChannelClient*.

	Acked-by: Uri Lublin <uril@redhat.com>

	replay: rename red_record_dev_input_primary_surface_create
	Rename red_record_dev_input_primary_surface_create to
	red_record_primary_surface_create.
	Name is more concise and was not clear what "dev_input" was supposed
	to specify.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: allows to specify a filter for record output
	This allows compression using external programs or any type
	of filters.

	To use it set SPICE_WORKER_RECORD_FILTER environment to the
	filter command you want to use. The command is executed with
	g_spawn_async_with_pipes (which uses execve) so is not a shell
	command although the command is parsed using g_shell_parse_argv
	which split arguments as shell does.

	One easy way to use it is to just use a compressor like gzip with

	  export SPICE_WORKER_RECORD_FILENAME=/tmp/qemu_record.gz
	  export SPICE_WORKER_RECORD_FILTER=gzip
	  qemu ...

	The filter will receive the recording on standard input and is
	supposed to write in output filename (which is the standard output).
	You can use additional arguments in SPICE_WORKER_RECORD_FILTER to
	specify for instance compression level.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: better record encapsulation
	Remove global/static from red_record_qxl.c.
	Defined a structure and use it to hold record state.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Hide CursorChannelClient implementation details
	The existence of this class can be hidden to user of CursorChannel class

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Make cursor_channel_client_new static
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Move cursor_connect to CursorChannel
	This function was handling mainly CursorChannel state

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-05-25  Frediano Ziglio  <fziglio@redhat.com>

	Make some function static
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify current_add_equal loop
	Acked-by: Eduardo Lima <etrunko@redhat.com>

	dc: use FOREACH_CLIENT macro for loop

	dc: inline dpi computation
	Actually not exactly the same as this fix a bug if base is not the
	first element (in this case if dpi_ring_item is NULL dpi is not)

	dc: join the two loop
	They tested the same condition, no break in inside loop (which would
	exit all loops)

	dc: reuse code inside loop

	dc: convert break to continue
	Both jump to check worker_ring_item (internal or external loops)

	dc: use while again
	Convert from for(;;) { if () break; ... } to while

	dc: if link is NULL jumping outside loop will check variable and exit
	The outer loop will exit too.

	dc: if dpi is not NULL even dpi_ring_item is not NULL

	dc: dpi is always a value computed from dpi_ring_item

	dc: move code inside if
	these lines are only executed then the condition are satisfied

	dc: dcc used is always a value from current link

	dc: link is never null here

	dc: the link condition make this case terminate loop
	dpi_ring_item is changed but ignored

	dc: split if

	dc: convert to infinite loop

	style: Add some abbreviations
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	style: Sort abbreviations alphabetically
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Removed unused GET_CODE definition
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Remove potentially unsafe casts
	The id type is already uint64_t, no need to cast using some low
	level casts.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove unused macro definitions
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Move RedCacheItem size field inside cache_data union
	This reduce a bit the structure size and make clear that
	the field is used only when the item is a cache item.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove not necessary inval_type from RedCacheItem
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-05-25  Jonathon Jongsma  <jjongsma@redhat.com>

	Fix build warning when RED_WORKER_STAT is undefined
	since display_channel_print_stats is now static, the compiler complains
	when RED_WORKER_STAT is undefined since this function is not used:

	    ../../server/display-channel.c:853:13: error: 'display_channel_print_stats' defined but not used [-Werror=unused-function]

	To fix, don't define the function when RED_WORKER_STAT is undefined.
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-05-24  Jonathon Jongsma  <jjongsma@redhat.com>

	RedChannel: Add FOREACH_CLIENT and use it to iterate
	Remove the custom FOREACH_DCC macro and use the more generic
	FOREACH_CLIENT macro and use it for all channels.

	Replace RedChannel::clients with GList
	Instead of using a Ring, use a GList to store the list of channel
	clients. This allows us to iterate the clients without poking inside of
	the client struct to get the channel_link. This is required in order to
	make the RedChannelClient struct private.

	Move InputsChannelClient to a separate file
	Preparation for converting to GObject

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-05-24  Frediano Ziglio  <fziglio@redhat.com>

	change main_channel_marshall_mouse_mode call style
	Make the call more similar to other marshall function calls in the
	same function.

	move all item creation in main-channel-client.c
	Move all core to create and destroy MainChannel pipe items in a single
	place.

	Introduce SPICE_UPCAST macro
	This was proposed by Christophe as improvement over some typesafe
	patches.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-05-24  Jonathon Jongsma  <jjongsma@redhat.com>

	cache-item.h: remove unnecessary channel include
	It's only necessary to include red-pipe-item.h

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	AgentMsgFilter: use typedef
	Instead of using the full 'struct AgentMsgFilter', use the typedef name

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-05-24  Frediano Ziglio  <fziglio@redhat.com>

	Make some function static
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-05-21  Frediano Ziglio  <fziglio@redhat.com>

	Get code more typesafe
	Scan remaining code searching for problems with structure
	layout assumptions in the code.
	Where code required some restructuring put some verify checks
	to make sure code won't compile if these assumptions are not
	in place anymore.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	reduce casts to RedPipeItem and RingItem
	Make code more type safe. This allow to move or delete structure
	fields more safely

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	rename RedVDIReadBug::parent to base
	All other classes using RedPipeItem as base use base as parent name

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	make red_pipe_item_unref more typesafe
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	make red_pipe_item_ref more typesafe
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	make red_pipe_item_init_full more typesafe
	Use a proper type for free callback

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Use a marker instead of checking a RedPipeItem presence
	This avoids having to retain a pointer just to check item is still in
	the queue with ring_item_is_linked(&item->link).

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Call dcc_send_item directly
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Handle reference for RedPipeItem in RedChannel
	Remove the need to release the item inside send_item callbacks.
	This looks like a partial rollback of previous patch but is
	to make clear the intention of the change.
	The lifetime of items could extend a bit further but there
	are no cases this small lag should cause problems.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove RedChannel::hold_item callback
	This is quite confusing and prone to errors.
	Use RedPipeItem reference counting instead.
	To compensate for the additional reference due to red_pipe_item_ref
	in RedChannel sub class with empty hold_item have to add a
	red_pipe_item_unref call in send_item.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-05-20  Jonathon Jongsma  <jjongsma@redhat.com>

	Remove 'peer' from name of channel client methods
	There is some inconsistent naming of RedChannelClient methods. Some
	include the word 'peer' (which normally seems to refer to RedsStream).
	Remove the 'peer' terminology from those functions that are basically
	RedChannelClient methods.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-05-20  Frediano Ziglio  <fziglio@redhat.com>

	let compiler manage the copy in a more typesafe way
	Do not use memcpy but just copy the data

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-20  Jonathon Jongsma  <jjongsma@redhat.com>

	Move MainChannelClient to separate file
	Preparation for converting to GObject

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-05-20  Uri Lublin  <uril@redhat.com>

	glz: simplification of do_match and PIXEL_ID
	Following commit e8017dd366afabbd099a13d7d455a37fd50be124 here
	are some more ifdef simplification.

	For PIXEL_ID and PIXEL_DIST macros,
	the ifndef LZ_PLT defines are special cases of the LZ_PLT
	(#else) defines, when pix_per_byte is 1

	Now do_match can accept pix_per_byte param for all different
	definitions (implementations).

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-05-20  Frediano Ziglio  <fziglio@redhat.com>

	Fix typo in comment
	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

	style: Add an abbreviation
	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>

2016-05-19  Jonathon Jongsma  <jjongsma@redhat.com>

	Add red_client_seamless_migration_done_for_channel()
	This is a public RedClient API that handles updating itself rather than
	having the RedChannelClient poke around at the internal structure in
	rec_channel_client_seamless_migration_done().

	Simplify DisplayChannel hold_item()
	Since all pipe items implement refcounting now, just call
	red_pipe_item_ref() and eliminate the switch statement.

	Remove unnecessary cursor_pipe_item_ref()
	Use the base red_pipe_item_ref() instead of adding an additional static
	wrapper function.

2016-05-18  Frediano Ziglio  <fziglio@redhat.com>

	make spice-server-replay use dynamic spice-server library
	spice-server-replay is built with the same settings as tests.
	Currently the tests links to a convenience spice-server library.
	A convenience library is a static library build with object file
	for a dynamic library.
	This make all tests contain all spice-server library code and not
	linking to the spice-server dynamic library (the .so).
	It's not a problem for most tests however this make impossible for
	spice-server-replay utility to be used with a dynamic spice-server
	library (you have to recompile it including the library).
	This is a pity as you could for instance compare your system
	library behavior with the library you are developing.
	Also if we decide to install in a future the utility for testing
	we would have lot of code duplication.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	remove a warning building a test
	With my compile switches (which are mostly derived from RedHat spec
	file) I'm getting this warning:

	stream-test.c: In function 'sock_fd_read':
	stream-test.c:66:43: warning: dereferencing type-punned pointer will
	break strict-aliasing rules [-Wstrict-aliasing]
	             *fd = *((int *) CMSG_DATA(cmsg));
	                                           ^

	memcpy could decrease performance but as this is a test it's not
	an issue.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Simplify #ifdef/#endif in glz code
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	char-device: Update function names in documentation
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Make sure all headers are independent
	Make sure is possible to include any headers alone.

	I used this script to check independence (run under server directory):
	----
	#!/bin/bash

	set -e

	# check not already modified
	if grep -q libheaders.la Makefile.am; then
	    echo "Header library already prepared" >&2
	    exit 1
	fi

	add_lib() {
	    local hdr="$1"

	    hdr=${hdr%.h}
	    c="mao_${hdr}.c"
	    echo "#include \"${hdr}.h\"" > $c
	    echo -e "\t$c \\" >&3
	}

	# add library to compile all headers alones
	exec 3>> Makefile.am
	echo "
	noinst_LTLIBRARIES += libheaders.la
	libheaders_la_SOURCES =				\\" >&3
	for hdr in *.h; do
	    case $hdr in
	    spice-bitmap-utils.h)
	        add_lib $hdr
	        ;;
	    spice*.h)
	        ;;
	    *)
	        add_lib $hdr
	        ;;
	    esac
	done
	echo -e "\t\$(NULL)" >&3
	exec 3>&-
	----

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	style: Add some documentation for names
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Use more reference counting on RedPipeItem
	This is the continuation of Christophe patches using reference
	counting for RedPipeItem.
	Extend it's usage.
	This for instance leads to the removal of release_item callback.

	Use reference counting for RedPipeItem
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Reuse red_channel_client_release_sent_item function
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Make red_channel_client_clear_sent_item static
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove red_channel_client_release_item
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove release_item callback
	Just a call to red_pipe_item_unref.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove main_channel_release_pipe_item
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify main_channel_release_pipe_item
	Reuse RedPipeItem facilities.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Use a default release_item implementation in RedChannel
	Avoid having to provide a lot of empty implementations

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove dcc_release_item
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify pipe items release in CursorChannel
	All RedPipeItems can be freed with red_pipe_item_unref.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Reuse RedPipeItem facilities for RedCursorPipeItem
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove unused parameter from put_cursor_pipe_item
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify spicevmc_red_channel_release_pipe_item
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify smartcard_channel_release_pipe_item
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify dcc_release_item
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify release_item_after_push
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Handle STREAM_CREATE and STREAM_DESTROY pipe items more coherently
	The items of these pipe items were allocated staticaly inside the
	StreamAgent structure. All others RedPipeItem are allocated dynamically.
	This could solve possible future maintenance as the life of these
	item is more easier to understand.
	It's more easier to understand why reference where incremented.
	It also make the StreamAgent structure a bit smaller.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify release of STREAM_CREATE and STREAM_DESTROY pipe items
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify release of CREATE_SURFACE and DESTROY_SURFACE pipe items
	Putting base as first item the default free function is fine.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Call red_pipe_item_unref instead of free
	This is the standard way to release a RedPipeItem

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Simplify RED_PIPE_ITEM_TYPE_DRAW item release
	Move ring_remove to the function to release this type of item.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove useless assignment
	Type was already initialized calling red_pipe_item_init

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove unused refs field
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-05-17  Frediano Ziglio  <fziglio@redhat.com>

	remove only written num_mig_target_clients field in RedsState
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	remove only written peer_minor_version field in RedsState
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	use more portable SPICE_OFFSETOF instead of offsetof
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	glz: simplification of PIXEL_DIST calls
	Make macro have same prototype even if we need an extra argument.
	This avoids having different calls for LZ_PLT.

	Acked-by: Uri Lublin <uril@redhat.com>

	stats: change image statistics format
	Change from %f to %g. This allows printf to choose format based on
	order of numbers.
	Also increase precision making sure that number of precision is
	respected, not matter the order of the number.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	stats: simplify printing statistics
	Use some utility function to show and compute statistics.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-13  Frediano Ziglio  <fziglio@redhat.com>

	fix wrong assert causing streaming to crash
	This regression was introduced by commit
	18d3876b78c7f19c577da000d322dbd44e63e456
	("UpgradeItem: use base PipeItem for refcounting")

	This fix https://bugs.freedesktop.org/show_bug.cgi?id=95365.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-05-12  Frediano Ziglio  <fziglio@redhat.com>

	style: put some notes on inclusion order
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	unify header include order
	Use this style for include headers inside headers:

	  #include <system_headers.h>
	  #include <no_spice_no_system_libraries.h>
	  #include <spice_protocol.h>
	  #include <spice_common.h>

	  #include "spice_server.h"

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-05-12  Jonathon Jongsma  <jjongsma@redhat.com>

	Add missing include to red-pipe-item.h
	This doesn't cause problems at the moment, because the files that
	include this file also include the other files that are needed, but just
	for completeness...

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-12  Marc-André Lureau  <marcandre.lureau@gmail.com>

	spice-migration.h: un-deprecate set_seamless_migration()
	This function was wrongly marked as deprecated in commit b41220b1441b8.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-05-11  Frediano Ziglio  <fziglio@redhat.com>

	fix crash if agent interface is removed
	Removing an interface cause SpiceBaseInstance->st to be set to NULL.
	This pointer was then deferenced in agent code.
	As SpiceBaseInstance should not be used after this call make sure
	we don't keep pointers to it.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	style: use capital case for C language
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	style: remove outdated void argument
	For C is better to have void instead of arguments as otherwise
	K&R rules apply.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	style: update file name style
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	style: update copyright lines
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	style: fix condition indentation example
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	style: we are now using capital FIXME and TODO
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	style: remove documentation for C++
	C++ usage was removed with spicec (the old client).

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	style: remove spice client section
	Spice client is no more in this repository and also the style was changed

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-10  Frediano Ziglio  <fziglio@redhat.com>

	removed converted Spice_style.odt
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	converts Spice_style.odt to asciidoc spice_style.txt
	The conversion try keeps the content as is no matter if updated or not.
	Asciidoc format is already used for manual.
	Using a text format make easier to see git diff and send patches.
	Also it's easier to convert to different format and copy to web pages.

	Related: https://bugs.freedesktop.org/show_bug.cgi?id=95258

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	reset pointer to RedCharDeviceWriteBuffer calling red_char_device_write_buffer_release
	This code make easier to be sure we don't have dangling pointers
	resetting in the function which free the structure.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-05-10  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Remove 'CXX' from configure summary
	We no longer make use of a c++ compiler since dropping the client, so
	no need to show it in the configure summary.

	build-sys: Drop unneeded python check
	spice-server does not use python, the spice-common submodule needs it, but
	it has its own python check through the use of AM_PATH_PYTHON

2016-05-10  Frediano Ziglio  <fziglio@redhat.com>

	fix "spice--gtk" typo in configure.ac
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-05-09  Frediano Ziglio  <fziglio@redhat.com>

	char-device: improved comment
	- fix typo;
	- simplify sentence.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Remove unused definitions
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	remove sw-canvas.h
	This include was just including another file

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	use #include<> style for spice-common header inclusions.
	The include directory is specified with the -I which is the directory
	used directly by #include<>.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-05  Frediano Ziglio  <fziglio@redhat.com>

	remove dangling pointer for RedCharDeviceVDIPort
	When a client disconnects remove it from the list of clients connected
	to the spice char-device.

	This was caused by commit 1cec1c5118b65124de6bc6f984f376ff4e297bfb
	("reds: Make VDIPortState a GObject") as the lifespan of RedCharDevice
	was changed.

	This could be reproduced with:
	- start rhel7 machine
	- connect remote viewer (RV)
	- RV: login
	- connect ssh
	- SSH: stop agent
	- disconnect RV
	- SSH: start agent
	- connect to RV

	and caused (using address sanitizer):

	main_channel_handle_parsed: agent start
	=================================================================
	==29592==ERROR: AddressSanitizer: heap-use-after-free on address 0x60c00001cff0 at pc 0x7fa85b6e8595 bp 0x7ffde3801940 sp 0x7ffde3801930
	READ of size 8 at 0x60c00001cff0 thread T0
	    #0 0x7fa85b6e8594 in red_client_get_main /home/freddy/work/spice-server/server/red-channel.c:2190
	    #1 0x7fa85b7311e6 in vdi_port_send_msg_to_client /home/freddy/work/spice-server/server/reds.c:880
	    #2 0x7fa85b69383e in red_char_device_send_msg_to_client /home/freddy/work/spice-server/server/char-device.c:138
	    #3 0x7fa85b69383e in red_char_device_send_msg_to_clients /home/freddy/work/spice-server/server/char-device.c:356
	    #4 0x7fa85b69383e in red_char_device_read_from_device /home/freddy/work/spice-server/server/char-device.c:403
	    #5 0x55a2633b81c1  (/usr/bin/qemu-system-x86_64+0x5561c1)
	    #6 0x55a2633afe7a  (/usr/bin/qemu-system-x86_64+0x54de7a)
	    #7 0x55a2634cb7b1  (/usr/bin/qemu-system-x86_64+0x6697b1)
	    #8 0x55a2632078d0  (/usr/bin/qemu-system-x86_64+0x3a58d0)
	    #9 0x55a26379b2e8  (/usr/bin/qemu-system-x86_64+0x9392e8)
	    #10 0x55a26379a7a0  (/usr/bin/qemu-system-x86_64+0x9387a0)
	    #11 0x55a26313fb78 in main (/usr/bin/qemu-system-x86_64+0x2ddb78)
	    #12 0x7fa85a3cc57f in __libc_start_main (/lib64/libc.so.6+0x2057f)
	    #13 0x55a26314b0c8  (/usr/bin/qemu-system-x86_64+0x2e90c8)

	0x60c00001cff0 is located 48 bytes inside of 128-byte region [0x60c00001cfc0,0x60c00001d040)
	freed by thread T0 here:
	    #0 0x7fa869e3667a in __interceptor_free (/lib64/libasan.so.2+0x9867a)
	    #1 0x7fa85b6d75f7 in red_client_unref /home/freddy/work/spice-server/server/red-channel.c:2076
	    #2 0x7fa85b6ead74 in dispatcher_handle_single_read /home/freddy/work/spice-server/server/dispatcher.c:291
	    #3 0x7fa85b6ead74 in dispatcher_handle_recv_read /home/freddy/work/spice-server/server/dispatcher.c:314
	    #4 0x55a26379b2e8  (/usr/bin/qemu-system-x86_64+0x9392e8)
	    #5 0x55a26379a7a0  (/usr/bin/qemu-system-x86_64+0x9387a0)
	    #6 0x55a26313fb78 in main (/usr/bin/qemu-system-x86_64+0x2ddb78)
	    #7 0x7fa85a3cc57f in __libc_start_main (/lib64/libc.so.6+0x2057f)

	previously allocated by thread T0 here:
	    #0 0x7fa869e36b19 in __interceptor_calloc (/lib64/libasan.so.2+0x98b19)
	    #1 0x7fa85b7d6858 in spice_malloc0 /home/freddy/work/spice-server/spice-common/common/mem.c:109
	    #2 0x7fa85b6e760c in red_client_new /home/freddy/work/spice-server/server/red-channel.c:2053
	    #3 0x7fa85b7449e4 in reds_handle_main_link /home/freddy/work/spice-server/server/reds.c:1762
	    #4 0x7fa85b7449e4 in reds_handle_link /home/freddy/work/spice-server/server/reds.c:2002
	    #5 0x7fa85b745d3a in reds_handle_ticket /home/freddy/work/spice-server/server/reds.c:2056
	    #6 0x55a26379b2e8  (/usr/bin/qemu-system-x86_64+0x9392e8)
	    #7 0x55a26379a7a0  (/usr/bin/qemu-system-x86_64+0x9387a0)
	    #8 0x55a26313fb78 in main (/usr/bin/qemu-system-x86_64+0x2ddb78)
	    #9 0x7fa85a3cc57f in __libc_start_main (/lib64/libc.so.6+0x2057f)

	SUMMARY: AddressSanitizer: heap-use-after-free /home/freddy/work/spice-server/server/red-channel.c:2190 red_client_get_main
	Shadow bytes around the buggy address:
	  0x0c187fffb9a0: fd fd fd fd fd fd fd fd fa fa fa fa fa fa fa fa
	  0x0c187fffb9b0: fd fd fd fd fd fd fd fd fd fd fd fd fd fd fd fd
	  0x0c187fffb9c0: fa fa fa fa fa fa fa fa fd fd fd fd fd fd fd fd
	  0x0c187fffb9d0: fd fd fd fd fd fd fd fd fa fa fa fa fa fa fa fa
	  0x0c187fffb9e0: fd fd fd fd fd fd fd fd fd fd fd fd fd fd fd fd
	=>0x0c187fffb9f0: fa fa fa fa fa fa fa fa fd fd fd fd fd fd[fd]fd
	  0x0c187fffba00: fd fd fd fd fd fd fd fd fa fa fa fa fa fa fa fa
	  0x0c187fffba10: fd fd fd fd fd fd fd fd fd fd fd fd fd fd fd fd
	  0x0c187fffba20: fa fa fa fa fa fa fa fa fd fd fd fd fd fd fd fd
	  0x0c187fffba30: fd fd fd fd fd fd fd fd fa fa fa fa fa fa fa fa
	  0x0c187fffba40: fd fd fd fd fd fd fd fd fd fd fd fd fd fd fd fd

	Acked-by: Eduardo Lima (Etrunko) <etrunko@redhat.com>
	Acked-by: Uri Lublin <uril@redhat.com>

2016-05-04  Pavel Grunt  <pgrunt@redhat.com>

	agent-msg-filter: Move include from header
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-05-04  Frediano Ziglio  <fziglio@redhat.com>

	char-device: remove unused refs field
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-05-04  Francois Gouget  <fgouget@codeweavers.com>

	server: Enable adding alternative MJPEG video encoders
	This replaces the original mjpeg_encoder API with a VideoEncoder base
	class which can be reimplemented by other encoders.
	This also renames the members and enums from mjpeg_* to video_*.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	server: Correctly handle and trace stream report errors
	We may get stream reports after the stream has been closed, and even, in
	extreme cases, after a new stream has started reusing the same stream
	id. Neither case should cause the server to crash.
	So restore dcc_handle_stream_report() to how it was before being moved
	to dcc.c.

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-05-04  Snir Sheriber  <ssheribe@redhat.com>

	Using already exists function instead of SPICE_CONTAINEROF
	Using spicevmc_red_channel_client_get_state(rcc) (which already
	exists) instead of SPICE_CONTAINEROF(rcc->channel, SpiceVmcState,
	channel).

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-04-29  Jonathon Jongsma  <jjongsma@redhat.com>

	Name MainChannelClient methods consistently
	Always use main_channel_client_ prefix instead of just main_channel_ in
	some cases.

	Call public RedClient API instead of poking internals
	Use red_client_during_migrate_at_target() instead of checking
	rcc->client->during_target_migrate.

	Don't touch RedClient internals from RedChannelClient
	Change red_channel_client_set_migration_seamless() so that it returns a
	boolean which RedClient can use to update its internal count of
	num_migrated_channels rather than having RedChannelClient reaching into
	the internals of RedClient

2016-04-27  Christophe Fergeau  <cfergeau@redhat.com>

	audio: Remove global 'playback_compression' variable
	This variable belongs to SpiceServerConfig rather than being a static
	global variable hidden in sound.c

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove dead code in reds_fill_channels()
	channels_info->num_of_channels is assigned, its value is not used, and
	then it's assigned a different value. The first assignment can be
	removed.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Improve Reds/RedMainChannel interface
	Instead of exporting 2 methods to get number of channels, and to fill
	channel information, and use that from the main channel code, it's
	better to do everything in one go in reds.c, and call that single method
	from the main channel code.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Add _config_ to SpiceServerConfig accessors
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Mark unused public API methods/code as deprecated
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Add RedServerConfig
	This wraps/groups the various parameters that can be set by spice-server
	users through the spice_server_set_xxx public API.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-04-27  Jonathon Jongsma  <jjongsma@redhat.com>

	Rename all RedPipeItem subclasses
	Use 'Red' prefix to match internal type naming convention

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Rename PipeItem to RedPipeItem
	Following internal type naming conventions

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-04-27  Christophe Fergeau  <cfergeau@redhat.com>

	Use weak gobject ref instead of reds_on_char_device_state_destroy
	RedCharDevice implementation had to callback into reds.c in order to let
	it know a char device was being destroyed. Now that RedCharDevice is a
	gobject, a weak reference can be used instead allowing to remove that
	coupling.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Use GQueue for RedCharDevice::send_queue
	There was an extra RedCharDeviceMsgToClientItem type whose only
	purpose was to manage a linked list of items to send. GQueue has the
	same purpose as this type in addition to being generic. As the length of
	the send queue is tracked, a GQueue is more appropriate than a GList and
	allow to remove RedCharDevice::send_queue_size.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-04-27  Jonathon Jongsma  <jjongsma@redhat.com>

	UpgradeItem: use base PipeItem for refcounting
	No need to re-implement refcounting in this subclass.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Store display in Drawable struct
	If the Drawable keeps a pointer to the Display channel that it is
	associated with, we can unref it directly and not need to pass the
	'display' parameter separately to the unref function

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-04-26  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: remove check for canvas during cursor connect
	We want the cursor to be initialized even if there is no canvas,
	especially when using a GL scanout. This solves some client warnings
	when using qemu with GL scanout-only (patches under review on qemu ML).

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-04-25  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	Fix make dist
	spicec screenshot has been removed since commit b0186fe1267dfa2b8534c7c083dc301791279f08

2016-04-22  Pavel Grunt  <pgrunt@redhat.com>

	manual: Remove spicec screenshot

	manual: No need to use sudo to run qemu

	manual: Recommend UsbDk instead of USB Clerk

	manual: Recommend enabling monitors using remote-viewer's menu

2016-04-20  Christophe Fergeau  <cfergeau@redhat.com>

	Remove use of opaque from vdi_port_read_one_msg_from_device
	We can get 'reds' from the RedCharDevice accessible from the
	SpiceCharDeviceInstance passed as an argument.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-04-20  Jonathon Jongsma  <jjongsma@redhat.com>

	char device: use _reset_dev_instance() to set 'sin'
	Internally, use the method to set the 'sin' member variable so that we
	don't have to duplicate the g_object_notify() calls, and there are
	consistent debug statements whenever this value is modified. This also
	means that we need to handle NULL arguments to this function.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	char device: use 'device' rather than 'state' for var names
	Since the type name was changed, use variable names / debug statements
	that are consistent with the new name.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	char-device: notify when device instance is changed
	Since the device instance ("sin") is a gobject property, we should make
	sure to notify when it changes, particularly since we do some
	initialization in response to the "notify::sin" signal.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-04-19  Pavel Grunt  <pgrunt@redhat.com>

	sw-canvas: Get rid of unsused SW_CANVAS_IMAGE_CACHE
	See spice-common commit edac1b36b572cbd8988c44341185a9f51ea3eeb5
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-04-15  Christophe Fergeau  <cfergeau@redhat.com>

	char-device: Remove RedCharDeviceClass::{un, }ref_msg_to_client
	Now that client messages are always RedPipeItem, we don't need virtual
	functions to know how to ref/unref them.

	char-device: Replace RedCharDeviceMsgToClient with PipeItem
	Now that all derived classes use a type deriving from PipeItem for their
	RedCharDeviceMsgToClient, we can make this explicit in the
	RedCharDeviceClass vfuncs, and remove the RedCharDeviceMsgToClient
	typedef.

2016-04-15  Jonathon Jongsma  <jjongsma@redhat.com>

	dcc: Use refcounting for MonitorsConfigItem

	StreamClipItem: use base class refcounting
	PipeItem already implements refcounting. Use it.

	DrawablePipeItem: use base class for refcounting
	Since PipeItem already implements refcounting, there's no need to
	re-implement it here.

	dcc: use PipeItem refcounting for ImageItem
	Since the base class now implements refcounting, there's no need to
	re-invent it here.

2016-04-15  Christophe Fergeau  <cfergeau@redhat.com>

	SpiceVmcPipeItem: use base PipeItem for ref counting
	This allows to reuse pipe_item_{ref, unref} rather than
	reimplementing them in spicevmc.c

	smartcard: Use base PipeItem for MsgItem refcounting
	This allows to reuse pipe_item_{ref, unref} rather than
	reimplementing them in smartcard.c

	reds: Derive VDIPortReadBuf from PipeItem
	Since PipeItem is already refcounted, this allows to remove various
	layers of ref/unref helpers from reds.c, and use the generic
	pipe_item_{ref, unref} instead.

	Add reference counting to PipeItem class
	A user-defined callback is called when the refcount drops to 0.

	Reference counting is manually coded for several classes deriving from
	PipeItem, so this change will help to share this code, and allow to remove
	some ref/unref virtual functions in some interfaces when we can assume
	every instance derives from this base class.

	Reviewed-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-04-12  Frediano Ziglio  <fziglio@redhat.com>

	red-channel: make red_client_{ref,unref} thread safe
	These function are called on both sides of dispatcher so the
	increment/decrement of the counter is done in multiple threads.
	This caused the counter to not get incremented correctly and
	freed the structure too early, leaving a dangling pointer in
	the other thread.

	This fixes https://bugzilla.redhat.com/show_bug.cgi?id=1253375.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-04-11  Christophe Fergeau  <cfergeau@redhat.com>

	char-device: Fix el6 compilation
	One more duplicate typedef, once in reds.c and another time in
	reds-private.h
	RedsState::agent_dev is defined in reds-private.h but only used in
	reds.c, so longer term this could all be moved back to reds.c

2016-04-07  Christophe Fergeau  <cfergeau@redhat.com>

	Move RedCharDeviceCallbacks into RedCharDeviceClass
	This structure holding virtual function pointers was kept until now as a
	RedCharDevice member in order to make the GObject conversion easier.
	Now that all RedCharDevice children are converted to GObject, it can be
	moved into RedCharDeviceClass.

	reds: Remove red_char_device_new()
	Nothing is using it anymore now that CharDevice classes are
	gobjectified.

2016-04-06  Christophe Fergeau  <cfergeau@redhat.com>

	reds: Make VDIPortState a GObject
	This inherits from RedCharDevice.

2016-04-06  Jonathon Jongsma  <jjongsma@redhat.com>

	Rename VDIPortState to RedCharDeviceVDIPort
	Consistent with internal naming conventions, and prepares for
	conversion to GObject

2016-04-06  Christophe Fergeau  <cfergeau@redhat.com>

	smartcard: Turn RedCharDeviceSmartcard into a GObject
	This inherits from RedCharDevice. Once all char device states are
	converted, we can turn the associated vfuncs into RedCharDeviceClass
	vfuncs.

2016-04-06  Jonathon Jongsma  <jjongsma@redhat.com>

	Rename SmartCardDeviceState to RedCharDeviceSmartcard
	More consistent with naming conventions, and prepares for converting
	this type to a GObject which inherits from RedCharDevice.

2016-04-06  Christophe Fergeau  <cfergeau@redhat.com>

	Update spice-common submodule
	Mostly to get fixes for older glib versions (both at compile time and
	runtime).

	Changes this brings in:

	Christophe Fergeau (4):
	      tests: Fix glib version check
	      log: Clamp SPICE_DEBUG_LEVEL if it's too high
	      log: Use SPICE_CONSTRUCTOR_FUNC
	      log: Make sure glib threading is initialized

	Eduardo Lima (Etrunko) (2):
	      Fix build in systems with Glib version older than 2.38
	      Add check for openssl

	qxl: Remove duplicate QXLState typedef
	We can directly include spice-qxl.h in red-qxl.h as it already gets it indirectly anyway.
	>

	reds: Move RedsState typedef to red-common.h
	This allows to stop using struct RedsState * rather than RedsState * in
	headers which cannot include reds.h. This also allows to remove the
	duplicate RedsState typedef in reds.h and reds-stream.h which is causing
	issues with older gcc versions.

	char-device: Fix property name in red_char_device_new()
	This method will be removed in a subsequent commit, but for now it's
	causing breakage since it's setting "reds" instead of "spice-server"

2016-04-05  Christophe Fergeau  <cfergeau@redhat.com>

	audio: Improve snd_receive type-safety
	We can pass it a SndChannel rather than an opaque void* data pointer
	which we then blindly cast.
	This came to light through a -Wshadow warning as there was a local
	variable 'data' in addition to the 'data' parameter.

	char-device: Remove duplicate typedef

	gobject: Add g_type_init() for older glibs
	Older glib versions require g_type_init() to be called before using
	GObject.

2016-04-02  Christophe Fergeau  <cfergeau@redhat.com>

	reds: Prepare to make VDIPortState a GObject
	This inherits from RedCharDevice.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	reds: Make VDIPortState private to reds.c
	VDIPortState and VDIReadBuf don't really need to be defined in a header
	file as they are only used in reds.c

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spicevmc: Introduce RedCharDeviceSpiceVmc GObject
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	char-device: Make RedCharDevice a GObject
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-04-01  Frediano Ziglio  <fziglio@redhat.com>

	Rename some missing names related to RedCharDevice
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Rename SpiceCharDeviceCallbacks to RedCharDeviceCallbacks
	The structure is an internal one so should not have the Spice prefix
	but use the Red one.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-04-01  Christophe Fergeau  <cfergeau@redhat.com>

	doc: Be more explicit about virgl requirements
	This is an attempt at listing the versions of the various packages which
	needs to be up to date for a functional virgl + spice.

	mjpeg: Add missing space to debug string

	build-sys: Update libtool versioning for 0.13.1

	Update NEWS for 0.13.1

2016-04-01  Jonathon Jongsma  <jjongsma@redhat.com>

	Rename RedCharDevice functions
	make the function names match the type names. So
	spice_char_device_state_* becomes red_char_device_* and
	spice_char_device_* also becomes red_char_device_*.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Rename SpiceCharDeviceClientState to RedCharDeviceClient
	Make it consistent with the renamed RedCharDevice and the convention of
	using 'Red' namespaces for internal types

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Rename SpiceCharDeviceState to RedCharDevice
	This is more consistent with internal type naming convention, and it
	paves the way for a new char device GObject heirarchy

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Rename SpiceCharDeviceWriteBuffer to RedCharDeviceWriteBuffer
	Internal types should use 'Red' namespace for consistency

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Rename SpiceCharDeviceMsgToClient to RedCharDeviceMsgToClient
	Internal types should use Red namespace for consistency

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-31  Christophe Fergeau  <cfergeau@redhat.com>

	char-device: Avoid use-after-free
	Reset pointer after freeing the structure pointing to it.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-30  Christophe Fergeau  <cfergeau@redhat.com>

	smartcard: Prepare to turn SmartcardState into a GObject
	Move all internal data into a private struct so that it won't be exposed
	when we move SmartCardDeviceState into the header.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-30  Jonathon Jongsma  <jjongsma@redhat.com>

	Convert Dispatcher and MainDispatcher to GObjects
	Allows more explicit inheritance relationship, and numerous other
	advantages.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-03-29  Christophe Fergeau  <cfergeau@redhat.com>

	char-device: Move instance data to SpiceCharDeviceState::priv
	Create a structure to hold private data.
	This helps to make patch for GObject smaller.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-03-29  Frediano Ziglio  <fziglio@redhat.com>

	dispatcher: move channel final initialization to red-worker
	CursorChannel and DisplayChannel was initialized half in red_worker_new
	and half in red_dispatcher_init using some accessor for RedWorker
	(red_worker_get_cursor_channel and red_worker_get_display_channel).
	Moving directly into red_worker_new make easier to follow code path.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-03-24  Frediano Ziglio  <fziglio@redhat.com>

	qxl: use Dispatcher in channel callbacks
	There is no need callbacks knows about internal QXLState.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-03-24  Francois Gouget  <fgouget@codeweavers.com>

	server: More clearly identify channels that support multiple clients
	Rename the function to channel_supports_multiple_clients() as
	channel_is_secondary() is unclear and was coded to return the opposite
	of what was originally intended.
	Also there are few channel types and whether they support multiple
	clients is totally static so we might as well delegate the check to
	the compiler.

2016-03-24  Frediano Ziglio  <fziglio@redhat.com>

	do not compile dump_bitmap if not necessary
	This function is used only for debugging

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-03-24  Christophe Fergeau  <cfergeau@redhat.com>

	doc: Add virgl documentation
	Document how to use virgl with QEMU/libvirt

	virt-manager documentation still needs to be added.

2016-03-24  Frediano Ziglio  <fziglio@redhat.com>

	make some functions static
	No need to have callback registered internally no static

	Acked-by: Victor Toso <victortoso@redhat.com>

	removed unused red_qxl_set_mm_time
	This helper call a deprecated callback.

	Acked-by: Victor Toso <victortoso@redhat.com>

	remove unused reds_set_mm_time
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-03-23  Frediano Ziglio  <fziglio@redhat.com>

	use constructor/destructor macros
	Initialize global images at load time:
	- make sure these stuff are initialized without using runtime
	resources;
	- make sure stuff are initialize really earlier.
	Do not use atexit function but a destructor.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	qxl: implement QXLWorker interface, do not use as a base class
	QXLWorker is the old interface now completely deprecated.
	Remove the strict dependency of having it as a base class.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	declare and use message for RED_WORKER_MESSAGE_GL_SCANOUT
	All other messages (even empty ones) have a structure defined.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	build-sys: use safer SPICE_CONTAINEROF version
	Enable additional checks for this macro.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-03-23  Jonathon Jongsma  <jjongsma@redhat.com>

	Remove last usage of global 'reds' variable
	This should be the final piece of removing the global reds variable. We
	still need a global variable to clean up during the atexit() function,
	but we use a GList of servers (even though we technically don't support
	multiple servers in the same process yet).

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-22  Christophe Fergeau  <cfergeau@redhat.com>

	char-device: Add helpers for SpiceCharDeviceCallbacks vfuncs
	Add helper functions wrapping calls to the virtual functions
	defined in SpiceCharDeviceCallbacks.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-21  Christophe Fergeau  <cfergeau@redhat.com>

	Remove dependency of vdi_port_read_buf_process on RedsState
	This makes it easier to move the VDIPort API to a different file, and
	make it as self-contained as possible.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	agent: Sync AgentMsgFilter state upon agent connection
	AgentMsgFilter needs to know whether monitors config messages need to be
	filtered or not. This used to be done from within
	agent_msg_filter_config() using the global RedsState, but this got more
	tricky as it was removed.
	A first attempt a1e62fa5ae9 caused crashes on qemu startup with
	"qemu-system-x86_64 -spice port=5900" (without -vga qxl). A second
	attempt added a RedsState* argument to agent_msg_filter_config() which
	in my opinion is not really nice from a layering point of view.

	This new attempt makes sure AgentMsgFilter state is correct when the
	filter is set to stop discarding all data, which allows to remove direct
	use of RedsState from within AgentMsgFilter.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Revert "fix regression due to callback called earlier"
	Passing Reds into agent-msg-filter.[ch] isn't the right thing to do from
	a layering point of view.

	This reverts commit a1e62fa5ae983b7b69cb437b2635ce84b2471383.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-17  Christophe Fergeau  <cfergeau@redhat.com>

	Remove red_channel_set_data()
	It's always called at the same time as red_channel_register_client_cbs()
	and the data is used by the callbacks, so we can pass the data as an
	argument to red_channel_register_client_cbs().

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Use red_qxl_check_qxl_version in red-worker
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add more red_qxl_ methods
	Add red_qxl_ methods wrapping the QXLInterface vfuncs. This allows to
	remove most of the qxl_get_interface() use outside of red-qxl.c

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Use QXLInstance instead of QXLState in red_qxl_*
	This seems to make more sense this way, QXLInstance is the 'main' object
	with QXLState being its private data. External users then use QXLInstance
	rather than passing a pointer to the private data to red-qxl.h methods.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-16  Francois Gouget  <fgouget@codeweavers.com>

	server: Add some comments to the sound structures.
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	server: Give the SndChannel's ref and unref methods their expected name
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-16  Uri Lublin  <uril@redhat.com>

	replay: skip the first N (slow) commands
	Note that the commands are executed by spice-server.
	The "skip" is only done on the "sleep" part of the
	"slow" command-line option.

	This is helpful to run quickly through uninsteresting commands
	in a beginning of a recorded file and going slowly when
	interesting parts appear

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	replay: count commands
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-15  Christophe Fergeau  <cfergeau@redhat.com>

	Use more explicit variable name in marshall_gl_scanout()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Fix typo in variable name in function prototype
	num_common_cap rather than num_common_caps was not consistent with
	the naming of the other arguments.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove unused red_qxl_set_dispatcher_opaque
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-11  Christophe Fergeau  <cfergeau@redhat.com>

	Remove spice_server_set_keepalive_timeout
	This public API is no longer needed as the keepalive interval does not
	need to be configurable.
	This API was present in the 0.13.0 release, but was never added to a
	stable release, in my opinion it's still acceptable to remove it without
	changing soname.

	Always enable TCP keepalive
	Always enabled, hardcoded interval
	as per https://bugzilla.redhat.com/show_bug.cgi?id=1298590

2016-03-11  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Update spice-common
	Pick codegen build fix (codegen is back in spice-common, see related
	commits & discussion thread)

2016-03-10  Christophe Fergeau  <cfergeau@redhat.com>

	smartcard: Move private constant to C file
	APDUBufSize is only used within smartcard.c, no need to expose it in
	smartcard.h

	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Rename red_channel_pipe_item_init to pipe_item_init
	The RedChannel argument is not used by pipe_item_init. Removing it
	will make code simpler in places where we don't have a RedChannel
	directly available.
	This is acting on a PipeItem object so correct name is pipe_item_init.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	char-device: Refactor spice_char_device_client_add a bit
	Factor out CharDeviceClientState creation out of
	spice_char_device_client_add.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-09  Christophe Fergeau  <cfergeau@redhat.com>

	Replace RedsPrivate::mig_wait_disconnect_clients with a GList
	The code was introducing an intermediate RedsMigWaitDisconnectClient type to
	hold linked list elements, resulting in a memory handling behaviour very
	similar to a GList. Using GList directly makes the code shorter and more
	readable.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Replace RedsPrivate::char_devs_state with a GList
	The code was introducing an intermediate SpiceCharDevStateItem type to
	hold linked list elements, resulting in a memory handling behaviour very
	similar to a GList. Using GList directly makes the code shorter and more
	readable.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Introduce spice_char_device_get_interface()
	Hides awkward casting/dereferencing to go from a
	SpiceCharDeviceInstance to a SpiceCharDeviceInterface

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-09  Frediano Ziglio  <fziglio@redhat.com>

	Fix regression initialising QXL interface
	st field in QXLInstance was not checked for NULL before
	initialisation.
	The additional check make Xspice crash during startup.

	Reported-by: Francois Gouget <fgouget@codeweavers.com>
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-03-08  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Fix dcc_start() regression
	Commit e9ed125d introduced a dead-lock regression by taking twice the
	same lock recursively. The previous code checked if a dmabuf was set
	without taking the lock, for queuing scanout messages. Since the message
	is being processed later on, it make sense to queue and delay until it
	is sent to check if there is a scanout.

	backtrace:
	 #0  red_qxl_get_gl_scanout (qxl_state=0x5555582373c0) at red-qxl.c:828
	 #1  0x00007fffec1ae654 in marshall_gl_scanout (rcc=0x7fffda6a7010,
	 #m=0x7fff44025e60, item=0x7fff440958a0) at dcc-send.c:2310
	 #2  0x00007fffec1aec7b in dcc_send_item (dcc=0x7fffda6a7010,
	 #pipe_item=0x7fff440958a0) at dcc-send.c:2441
	 #3  0x00007fffec1730f6 in send_item (rcc=0x7fffda6a7010,
	 #item=0x7fff440958a0) at display-channel.c:1963
	 #4  0x00007fffec1504c3 in
	 #red_channel_client_send_item (rcc=0x7fffda6a7010, item=0x7fff440958a0)
	 #at red-channel.c:578
	 #5  0x00007fffec152d98 in red_channel_client_push (rcc=0x7fffda6a7010)
	 #at red-channel.c:1365
	 #6  0x00007fffec1a387e in dcc_push_monitors_config (dcc=0x7fffda6a7010)
	 #at dcc.c:563
	 #7  0x00007fffec1a3489 in dcc_start (dcc=0x7fffda6a7010) at dcc.c:475

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-05  Jonathon Jongsma  <jjongsma@redhat.com>

	Remove use of global 'reds' within RedWorker
	Get the server variable from the QXLState instead of using the
	global variable

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add red_qxl_get_server()
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Store reference to RedsState in QXLState
	Remove use of global 'reds' variable from QXLState functions.
	Instead store the owning RedsState variable inside the QXLState
	struct and use that when necessary.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-04  Frediano Ziglio  <fziglio@redhat.com>

	worker: remove useless qxl_state
	qxl_state can be extracted easily from qxl.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	use QXLState instead of RedDispatcher
	Considering that:
	- QXLState is the state of QXLInstance implementation;
	- RedDispatcher is the implementation of QXL;
	- qif (QXLInterface*) field can be computed really easy from QXLInstance;
	- most of its state is private.
	Make all structure private and use QXLState instead of RedDispatcher.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	rename red-dispatcher.* files to red-qxl.*
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	rename red_dispatcher_ functions to red_qxl_
	RedDispatcher is basically implementing QXLInstance.
	After some internal discussion we decided to use QXLState structure
	and red_qxl_ as function prefix.
	This is the first of 3 patches that rename functions, structure
	and files.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	fix indentation
	Fix indentation for spice_debug call.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	optimize handle_dev_input call
	Pass directly dispatcher to handle_dev_input callback.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	reduce header dependencies
	Avoid to include headers in cursor-channel.h which are only
	used by cursor-channel.c

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-03-03  Francois Gouget  <fgouget@codeweavers.com>

	server: Fix the order of the attach_stream() asserts
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-03-03  Christophe Fergeau  <cfergeau@redhat.com>

	Make use of the new reds_core_timer_* API
	This makes the code more readable.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Introduce reds_core_timer_*

	Introduce reds_core_watch_*
	These methods wrap the RedsCoreInterface::watch_add,
	RedsCoreInterface::watch_remove and RedsCoreInterface::watch_update_mask
	vfuncs.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-03-03  Uri Lublin  <uril@redhat.com>

	replay: do not use argv after g_option_context_parse
	Apparently, after using g_option_context_parse with G_OPTION_REMAINING
	argv is modified and should not be used.
	This patch uses "file" instead of "argv" and makes sure
	file is freed later.
	No free is called upon error - exit takes care of it.

2016-03-03  Francois Gouget  <fgouget@codeweavers.com>

	server: Store the opaque pointer in VideoEncoderRateControlCbs
	It has the same lifetime as the corresponding structure so this
	simplifies keeping track of it.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-26  Francois Gouget  <fgouget@codeweavers.com>

	server: Don't call snd_channel_get_server() if we don't have a channel
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-25  Francois Gouget  <fgouget@codeweavers.com>

	server: Remove an unnecessary cast in spice_replay_next_cmd()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-25  Michal Privoznik  <mprivozn@redhat.com>

	Update .gitignore files
	The first part updates the .gitignore file in the root directory
	because the file is obviously generated by automake but poison
	our working tree.
	The second part updates the .gitignore under server/tests/
	directory because since 0db1137d we have a noinst test library
	libtest.a. However, like in previous case, git should never track
	this file.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	configure: Require spice-protocol-0.12.11 at least
	After 7a06efde we require SPICE_MSG_DISPLAY_GL_SCANOUT_UNIX
	symbol from spice-protocol (or value to be more precise). This
	has been however introduced in version 0.12.11 of the
	spice-protocol (commit 3fc2221e there). However, our configure
	check does not reflect this change. Fix it.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-23  Frediano Ziglio  <fziglio@redhat.com>

	use G_N_ELEMENTS instead of manually compute array size
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	constify some global variables
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-02-20  Frediano Ziglio  <fziglio@redhat.com>

	fix possible core calling timer callback
	Was possible to have ping_timer_cb called with a NULL pointer.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-02-19  Frediano Ziglio  <fziglio@redhat.com>

	fix regression due to callback called earlier
	Patch 1f210080609f2c00b4d1859eb0b363a38838e7d3 ("Remove use of global
	'reds' from AgentMsgFilter") introduced a regression. This because
	QXLInterface->client_monitors_config was called before returning
	from spice_add_interface. Some client of spice-server expect the
	spice_add_interface already returned and some state change was done
	before client_monitors_config was called.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-02-18  Frediano Ziglio  <fziglio@redhat.com>

	memslot: do not crash if guest provide a wrong address
	This could happen with buggy driver.

	This fixes https://bugzilla.redhat.com/show_bug.cgi?id=1264356

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-02-17  Frediano Ziglio  <fziglio@redhat.com>

	reds: remove unneeded variable
	Remove version_string variable.
	Was never changed and used in a single place.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-02-17  Jonathon Jongsma  <jjongsma@redhat.com>

	CommonChannel -> CommonGraphicsChannel
	Rename this struct to make it clear that it's only the base class for
	graphics channels (e.g. display and cursor), not all channels.

	Also renamed CommonChannelClient to CommonGraphicsChannelClient.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-02-17  Pavel Grunt  <pgrunt@redhat.com>

	compress-stat: Add not compressed image to statistics
	To see how many images and data could not be compressed.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	dcc: Move COMPRESS_DEBUG to compression functions
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	dcc: Rewrite dcc_image_compress
	Rules are now:

	Compression type:
	  off      -> uncompressed
	  quic     -> jpeg if possible else quic else off
	  lz       -> lz if possible else off
	  glz      -> glz if possible else lz else off
	  auto_lz  -> lz if possible else jpeg else quic else off
	  auto_glz -> glz if possible else lz else jpeg else quic else off
	  lz4      -> lz4 if possible else lz else off

	jpeg is used only when jpeg-wan-compression allows it

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-16  Frediano Ziglio  <fziglio@redhat.com>

	make RedDataChunk structure private inside red-parse-qxl.c
	The structure is strictly used by the parser only, no reason to make it
	public.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: removed unused red_worker_get_qxl function
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	dcc: move id from CommonChannelClient to DisplayChannelClient
	Was not used by CursorChannelClient but only by DisplayChannelClient.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-02-16  Jonathon Jongsma  <jjongsma@redhat.com>

	Add GObject to build requirements
	Preparation for GObject-ifying some internals

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-16  Christophe Fergeau  <cfergeau@redhat.com>

	Remove redundant argument to vdi_port_read_buf_process
	The 'port' argument can be determined from VDIPortState, so no need to
	pass both (through RedsState) to vdi_port_read_buf_process().

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-16  Jonathon Jongsma  <jjongsma@redhat.com>

	Remove use of global 'reds' from AgentMsgFilter
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	Remove use of global 'reds' from sound.c
	Pass RedsState variable to snd_attach_(playback|record) and get a
	reference to this variable when needed by various functions.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	Remove global main_dispatcher variable
	Requires changing a bunch of internal API to take MainDispatcher
	arguments, etc. The main dispatcher object is now owned by RedsState,
	since that is the object that previously created (initialized) it.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	Add red_channel_get_server()
	Instead of poking into the internals of the RedChannel, provide an
	accessor.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	Add RedsState reference to RedsStream
	Allows us to remove use of global 'reds' variable from reds-stream.c.
	Requires changing the RedsStream constructor to accept a RedsState arg.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-02-16  Frediano Ziglio  <fziglio@redhat.com>

	Remove global 'dispatchers', 'num_active_workers' variables
	Since these are server-level variables, move them into RedsState.
	However, num_active_workers was removed because:
	- each dispatcher always has 1 active worker, so we can determine the
	  number of active workers by counting the dispatchers
	- it was never actually set correctly. Even if there was more than one
	  worker, this variable was always only set to either 0 or 1.

	This change required moving a bunch of helper code into RedsState as
	well, an providing some RedDispatcher interfaces to access dispatcher
	information from RedsState.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	move red_dispatcher_on_vm_stop and red_dispatcher_on_vm_start to RedsState
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	remove unused function
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	use list in RedsState for ic_change and sv_change
	Instead of using list in RedDispatcher (which is going to be removed)
	use the one in RedsState.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	keep dispatcher list in RedsState
	This duplicate the other list which will be removed

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	move calc_compression_level to reds
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	add RedsState parameter to update_client_mouse_allowed
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	remove num_active_workers
	This global variable was mainly 1.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2016-02-15  Frediano Ziglio  <fziglio@redhat.com>

	Revert "dcc: remove not necessary volatile specifications"
	This reverts commit efe5a0c501d157566522f87a394e29c5290e2185.

	Due to a problem in the compiler this causes compile to fail.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-02-15  Christophe Fergeau  <cfergeau@redhat.com>

	display-channel: Remove extra group_id arguments
	They are now carried in the appropriate command through
	QXLReleaseInfoExt, so we don't need to pass them around explicitly.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove CursorItem::group_id
	Now that the group_id is known to RedCursorCmd, we don't need to store
	it separately in CursorItem.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	red-parse-qxl: Use QXLReleaseInfoExt instead of QXLReleaseInfo
	This should allow to avoid moving the group_id separately from the QXL
	commands all over the code.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove RedGlzDrawable::group_id
	It's unused.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove Drawable::group_id
	We can now directly get it from RedDrawable.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Simplify red_drawable_unref()
	Now it no longer needs external state in order to destroy the
	RedDrawable instance when needed, so we can remove this from the
	prototype.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add group_id to RedDrawable
	Storing a QXLReleaseInfoExt rather than a QXLReleaseInfo in RedDrawable
	gives us a place to store group_id for free. Since we are building a
	QXLReleaseInfoExt from QXLReleaseInfo and group_id when destroying a
	RedDrawable instance, this is a move in the right direction.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add QXLInstance member to RedDrawable
	This allows to get rid of the DisplayChannel parameter to
	red_drawable_unref()

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove DisplayChannel::red_drawable_count
	It's only used in a few debug printfs. If we want these stats, we'll
	have to find a better way than forcing a dependency on a high-level
	class in a lower-level _unref method just to maintain the stats.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	qxl: Remove unused group_id arg to fill_attr
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-15  Jonathon Jongsma  <jjongsma@redhat.com>

	Add RedsState arg to all stat functions
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-12  Frediano Ziglio  <fziglio@redhat.com>

	revert new event-loop code for timers
	Was causing sporadic crashes.
	Also cause compatibility problems with RHEL 6.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	tests: add a new case for event loop timers
	Check that cancelling a timer the timer callback is not called.

	This can happen in latency code (red-channel.c).
	In red_channel_client_cancel_ping_timer latency timer is cancelled and
	state is set to PING_STATE_NONE however if timer was already active what
	happens is that the red_channel_client_ping_timer is called and the line

	  spice_assert(rcc->latency_monitor.state == PING_STATE_TIMER);

	is triggered causing spice-server to abort.
	This happens as GLib loop add all active sources to an array but if the
	timer is deactivated before the event is dispatched the event will be
	dispatched unless the source is destroyed.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-02-12  Jonathon Jongsma  <jjongsma@redhat.com>

	MainChannel: don't use global 'reds' variable
	Add RedsState arg to main_channel_new(), and use the 'reds' property
	that is stored in the base RedChannel struct rather than the global
	'reds' variable.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add RedsState arg to reds_set_migration_dest_info()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add RedsState arg to inputs_channel_new()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Store a reference to RedsState in Channel base class
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add RedsState arg to smartcard_device_connect()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-12  Frediano Ziglio  <fziglio@redhat.com>

	dcc: remove not necessary volatile specifications
	These automatic variable are used just inside the function.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	CommonChannel: hold a reference to QXLInstance instead of RedWorker
	CommonChannel does not need to know about RedWorker.
	This reduce a bit dependencies between objects.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	ccc: remove unused field
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: remove unused red_worker_get_memslot function
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	remove unused structure definition
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	dcc: remove group_id from compression functions
	The parameter was not used.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	channel: rename misleading functions
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: simplify process loops
	It was not clear when req_cmd_notification was called.
	This code reproduce just the old behavior but is easier to read.

	Steps are:

	// original

	if (worker->display_poll_tries < CMD_RING_POLL_RETRIES) {
	    worker->display_poll_tries++;
	    worker->event_timeout = MIN(worker->event_timeout, CMD_RING_POLL_TIMEOUT);
	    return n;
	}
	if (worker->display_poll_tries > CMD_RING_POLL_RETRIES ||
	             worker->qxl->st->qif->req_cmd_notification(worker->qxl)) {
	    worker->display_poll_tries++;
	    return n;
	}
	continue;

	// split if

	if (worker->display_poll_tries < CMD_RING_POLL_RETRIES) {
	    worker->display_poll_tries++;
	    worker->event_timeout = MIN(worker->event_timeout, CMD_RING_POLL_TIMEOUT);
	    return n;
	}
	if (worker->display_poll_tries > CMD_RING_POLL_RETRIES) {
	    worker->display_poll_tries++;
	    return n;
	}
	if (worker->qxl->st->qif->req_cmd_notification(worker->qxl)) {
	    worker->display_poll_tries++;
	    return n;
	}
	continue;

	// order inside if

	if (worker->display_poll_tries < CMD_RING_POLL_RETRIES) {
	    worker->event_timeout = MIN(worker->event_timeout, CMD_RING_POLL_TIMEOUT);
	    worker->display_poll_tries++;
	    return n;
	}
	if (worker->display_poll_tries > CMD_RING_POLL_RETRIES) {
	    worker->display_poll_tries++;
	    return n;
	}
	if (worker->qxl->st->qif->req_cmd_notification(worker->qxl)) {
	    worker->display_poll_tries++;
	    return n;
	}
	continue;

	// consider cases

	if (worker->display_poll_tries < CMD_RING_POLL_RETRIES) {
	    worker->event_timeout = MIN(worker->event_timeout, CMD_RING_POLL_TIMEOUT);
	    worker->display_poll_tries++;
	    return n;
	}
	if (worker->display_poll_tries > CMD_RING_POLL_RETRIES) {
	    worker->display_poll_tries++;
	    return n;
	}
	if (worker->display_poll_tries == CMD_RING_POLL_RETRIES) {
	    if (worker->qxl->st->qif->req_cmd_notification(worker->qxl)) {
	        worker->display_poll_tries++;
	        return n;
	    }
	    continue;
	}
	// unreachable

	// invert if

	if (worker->display_poll_tries < CMD_RING_POLL_RETRIES) {
	    worker->event_timeout = MIN(worker->event_timeout, CMD_RING_POLL_TIMEOUT);
	    worker->display_poll_tries++;
	    return n;
	}
	if (worker->display_poll_tries > CMD_RING_POLL_RETRIES) {
	    worker->display_poll_tries++;
	    return n;
	}
	if (worker->display_poll_tries == CMD_RING_POLL_RETRIES) {
	    if (!worker->qxl->st->qif->req_cmd_notification(worker->qxl)) {
	        continue;
	    }
	    worker->display_poll_tries++;
	    return n;
	}
	// unreachable

	// reuse code

	if (worker->display_poll_tries < CMD_RING_POLL_RETRIES) {
	    worker->event_timeout = MIN(worker->event_timeout, CMD_RING_POLL_TIMEOUT);
	} else if (worker->display_poll_tries > CMD_RING_POLL_RETRIES) {
	} else if (worker->display_poll_tries == CMD_RING_POLL_RETRIES) {
	    if (!worker->qxl->st->qif->req_cmd_notification(worker->qxl)) {
	        continue;
	    }
	}
	worker->display_poll_tries++;
	return n;

	// remove empty if

	if (worker->display_poll_tries < CMD_RING_POLL_RETRIES) {
	    worker->event_timeout = MIN(worker->event_timeout, CMD_RING_POLL_TIMEOUT);
	} else if (worker->display_poll_tries == CMD_RING_POLL_RETRIES) {
	    if (!worker->qxl->st->qif->req_cmd_notification(worker->qxl)) {
	        continue;
	    }
	}
	worker->display_poll_tries++;
	return n;

	// collapse two conditions

	if (worker->display_poll_tries < CMD_RING_POLL_RETRIES) {
	    worker->event_timeout = MIN(worker->event_timeout, CMD_RING_POLL_TIMEOUT);
	} else if (worker->display_poll_tries == CMD_RING_POLL_RETRIES &&
	           !worker->qxl->st->qif->req_cmd_notification(worker->qxl)) {
	    continue;
	}
	worker->display_poll_tries++;
	return n;

	Acked-by: Jonathon Jongsma <jjongsma at redhat.com>

2016-02-11  Frediano Ziglio  <fziglio@redhat.com>

	dispatcher: remove unused async_commands ring
	The only usage of this ring was to have a message when there was no
	commands on the list.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Store 'renderers' as GArray in RedsState
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-11  Jonathon Jongsma  <jjongsma@redhat.com>

	Add RedsState arg to activate_modifiers_watch()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add RedsState arg to spicevmc_device_connect|disconnect()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add RedsState arg to red_on_main_agent_tokens()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Store a reference to RedsState in RedsMigTargetClient
	This allows RedsMigTargetClient methods to use local variables rather
	than the global 'reds' variable

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	spice_server_kbd_leds: don't use global 'reds'
	Store a reference to the RedsState server in the keyboard state struct

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add reference to server in RedClient
	Allows client methods to not use global 'reds' variable

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove use of global 'reds' from VDIReadBuf functions
	Add a new 'state' property to VDIReadBuf so that we can refer back to
	the VDIPortState struct from the readbuf functions.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	char-device: use local 'reds' variable
	Store a reference to the server in the SpiceCharDeviceState struct and
	use that rather than the global 'reds' variable

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add RedsState member to RedLinkInfo
	This allows us to use local 'reds' variables in all of the various async
	callbacks rather than using the global 'reds' variable.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move 'core' into RedsState struct
	Also add reds_get_core_interface() accessor for external use.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-10  Christophe Fergeau  <cfergeau@redhat.com>

	reds: Pass RedState instance to reds_accept()
	Rather than relying on a global 'reds' variable, we can pass the needed
	instance through the callback user data.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	reds: Make sure accept_ssl_connection() gets a reds instance
	Commit 3a66b75 changed reds_accept_ssl_connection() to expect a RedState
	instance when its called, but the core->watch_add() which is calling it
	was not changed accordingly. This causes a crash when connecting through
	SSL.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-09  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Handle GL_DRAW_DONE
	When a client is done with drawing and sends
	SPICE_MSGC_DISPLAY_GL_DRAW_DONE, or when it ends, update the number of
	async counts.

	[reduce critical message to a warning; do not reset gl_draw_ongoing
	 - Frediano Ziglio]

	Handle GL_DRAW messages
	Create an async, and marshall the GL_DRAW message. Count number of
	clients, and wait until gl_draw_async_count is 0 to complete the async.
	The count is going to be updated in the following patch when the client
	is done with the draw.

	[removed unused sent field; move gl_draw_async_count to DisplayChannel
	 - Frediano Ziglio]

	Send current GL scanout to new client

	Handle GL_SCANOUT messages
	Go through dispatcher and marshall scanout message. Since the marshaller
	and the QXL state are manipulated from different threads, add a mutex to
	protect the current scanout.

	Add new spice-gl stubs API
	- spice_qxl_gl_scanout() to take the current scanout

	- spice_qxl_gl_draw_async() to draw the scanout, is like other Spice async
	  functions, it takes a cookie and will return in the
	  QXLInterface.async_complete()

	Two new fields are also added to QXLState, in order to save the current
	scanout, and the pending async.

	A scanout can't be updated if there are pending draw atm. Discarding
	outdated draws is left as a future improvement to allow updating the
	scanout without waiting for draw async to be done.

	[make QXL function names more coherent - Frediano Ziglio]

	red-channel: return number of created pipe items
	This is useful in the following patches to count the number of replies
	to wait for.

2016-02-09  Jonathon Jongsma  <jjongsma@redhat.com>

	Add RedsState arg to reds_handle_channel_event()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Add RedsState arg to reds_init_client_[ssl_]connection()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Rename vdi_port_read_buf_get() to match convention
	Since this is technically a RedsState method, name it as such.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-05  Frediano Ziglio  <fziglio@redhat.com>

	record: save real time during recording
	Instead of using CPU time use a timer depending on real times.
	Currently that time in the record log is not used.
	However if we want to reproduce problems with stream would be useful
	to have real times instead.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	channel: fix typo in comment
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-02-04  Jonathon Jongsma  <jjongsma@redhat.com>

	Move ssl_parameters to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move agent_mouse to RedsState struct
	Required adding a RedsState arg to reds_get_agent_mouse()

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move streaming_video to RedsState struct
	Also requires adding reds_get_streaming_video() accessor so that other
	files can check this value.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-03  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	tests: link test-qxl-parsing with libserver
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-03  Frediano Ziglio  <fziglio@redhat.com>

	worker: don't do too much polling
	Now that processing is correctly restored there is no need to keep
	polling to avoid main loop hangs. Reduce the polling count to 1
	(just try once).
	This reduce cpu usage if guests are mainly idle.
	If you consider 100 guests waiting to login with cursor blinking
	and considering the polling was done 200 times every 10ms (maximum)
	just the cursor blinking was causing 10100 loop iterations per second
	while now only 200 are needed (considering cursor blinking every
	second).

	Signed-by: Frediano Ziglio <figlio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: avoid blocking loop
	Make sure we process commands after we can send data to client.
	If during processing we detected that there was too much data in the
	clients queues the processing of commands just stop till the next
	iteration.
	However if all data are pushed in a single iteration of the loop
	and commands were already processed there was the (remote) possibility
	that the loop hangs till a separate event (like a screen resize on
	client window) arrive.
	I manage to reproduce and after half an hour no events arrived.
	This patch detect that processing was stuck and now we can process new
	commands and force a new iteration.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	replay: remove a message that could be caused by a race condition
	The req_cmd_notification callback is called by spice-server when it
	has processed all commands and wants to be notified (by a wakeup) that
	new commands have been appended to the command queue.
	Replay utility tries to fill the commands when it detects that
	spice-server is trying to read commands but there are no more commands.
	However, new commands are appended in a separate thread so if the main
	red worker loop on spice-server is really tight this request can
	happen.
	Avoid printing any message on this condition, message will be appended
	and loop woken up when replay code can do it.

	Signed-by: Frediano Ziglio <figlio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: push data when clients can receive them
	During every iteration of the main worker loop, outgoing data was pushed to
	the client. However, there was no guarantee that the loop would be woken up
	in every situation. So there were some conditions where the loop would stop
	iterating until a new event was sent.

	Currently, the events that can wake up the main worker loop include:
	 - data from dispatcher (including wakeups from the guest)
	 - data from clients
	 - timeouts on a stream
	 - other timeouts
	 - polling

	This patch adds a new wakeup event: when we have items that are queued to
	be sent to a client, we set up a watch event for writing data to the
	client. If no items are waiting to be sent, this watch will be disabled.
	This allows us to remove the explicit push from the main worker loop.

	This has some advantages:
	 - it could lower latency as we don't have to wait for a polling timeout.
	   From my experiments using a tight loop (so not really the ideal
	   condition to see the improvements) the total time was reduced by 2-3%)
	 - helps reduce the possibility of hanging loops
	 - avoids having to scan all clients to detect which one can accept data.

	Signed-by: Frediano Ziglio <figlio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-02-03  Jonathon Jongsma  <jjongsma@redhat.com>

	Move zlib_glz_state to RedsState struct
	Also required adding reds_get_zlib_glz_state() for external access.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move exit_on_disconnect to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Move agent_file_xfer to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move agent_copypaste to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-03  Frediano Ziglio  <fziglio@redhat.com>

	compatibility patch for event loop
	This patch use old code to implement timer events.
	The new version use some function from GLib 2.34 however some systems
	(like RHEL 6) have former GLib version (RHEL 6 has GLib 2.28 installed)

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	spice-common: pick up fix for uninitialized field
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-02-03  Jonathon Jongsma  <jjongsma@redhat.com>

	Remove use of global 'reds' var from spice_server_remove_interface()
	Since this is public API, we can't easily change the signature of the
	function to take a RedsState argument, so instead we apply a hack and
	store the reds argument inside the device state struct when the
	interface is added, and retrieve it for use later when it is removed.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Move ticketing_enabled to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-02  Jonathon Jongsma  <jjongsma@redhat.com>

	Move jpeg_state to RedsState struct
	Also required adding reds_get_jpeg_state() for external access.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move image_compression to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Make default_security and channels_security non-global
	Move them into the RedsState struct, adjust functions that use these
	variables to take a RedsState arg.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-02  Frediano Ziglio  <fziglio@redhat.com>

	red-channel: send marshaller message fd
	Send the fd associated to the last message sent.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Update spice-common
	Needed to have the updated spice_marshaller_get_fd function

2016-02-02  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	tests: make sure that the default rule builds all tests
	The default rule being "all", it builds noinst_PROGRAMS but not
	check_PROGRAMS. Let's build all the tests by default.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-01  Victor Toso  <victortoso@redhat.com>

	reds: remove unused structs
	RedsMigSpiceMessage and RedsMigCertPubKeyInfo

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-02-01  Frediano Ziglio  <fziglio@redhat.com>

	reds: constify renderers_info array
	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Victor Toso <victortoso@redhat.com>

	reds: remove default_renderer as field
	Was used to just assure there was at least one renderer in the list.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-02-01  Jonathon Jongsma  <jjongsma@redhat.com>

	Move spice_uuid, spice_uuid_is_set to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move spice_name to RedsState struct
	Remove more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move sasl_enabled, sasl_appname to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move taTicket to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move spice_family to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move spice_addr to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move migration_interface to RedsState struct
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move vdagent to RedsState struct
	Also change API of reds_has_vdagent() to take RedsState arg.  Removes
	another global variable.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move spice_listen_socket_fd to RedsState struct
	Removing more global variables

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-29  Jonathon Jongsma  <jjongsma@redhat.com>

	Move spice_secure_port to RedsState struct
	removing more global variables

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Move spice_port to RedsState struct
	Remove another global variable

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Change init_vd_agent_resources() to take RedsState arg
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-01-29  Frediano Ziglio  <fziglio@redhat.com>

	worker: unify flush_cursor_commands and flush_display_commands
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-01-28  Frediano Ziglio  <fziglio@redhat.com>

	worker: use glib main loop
	Use the glib mainloop instead of writing our own. The glib loop is both
	cleaner to use and is more extensible. It is also very mature and
	reduces the maintenance burden on the spice server.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-01-28  Jonathon Jongsma  <jjongsma@redhat.com>

	Move default_renderer into RedsState
	Not global.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	main_channel_init() -> main_channel_new()
	Rename to make function name more consistent

	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	inputs_init() -> inputs_channel_new()
	Rename function to be more consistent

	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Remove global inputs channel
	Make the RedsState object own an InputsChannel object rather than
	having a global inputs channel. This means changing a lot of
	inputs-related API to take an InputsChannel* argument and moving the
	keyboard, mouse, and tablet objects into the InputsChannel object.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-28  Frediano Ziglio  <fziglio@redhat.com>

	worker: remove useless check
	display_channel is never NULL.

	Acked-by: Jonathon Jongsma <jjongsma at redhat.com>

	worker: remove useless test
	red_channel_max_pipe_size returns 0 if no client (channel disconnected)
	no need to check if cursor_channel/display_channel are NULL or
	connected.

	Acked-by: Jonathon Jongsma <jjongsma at redhat.com>

	worker: do not leak cursor after disconnecting clients
	Calling cursor_channel_disconnect does not free cursor_display
	so this causes a leak.
	Is the only code where this pointer is reset preventing any
	further cursor channel connection. If a client is lazy reading
	cursor data during the flush connection is closed and further clients
	won't be able to use the cursor.
	This also prevents future use of a NULL pointer.

	Acked-by: Jonathon Jongsma <jjongsma at redhat.com>

2016-01-27  Frediano Ziglio  <fziglio@redhat.com>

	qxl: inline documentation for get_command and req_cmd_notification

2016-01-26  Frediano Ziglio  <fziglio@redhat.com>

	worker: improved implementation of SpiceTimer
	Use a custom GSource.
	This to avoid having to allocate a timer all the time we add one.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	replay: do not wake up loop too much
	Send wakeups only when a command is available.
	This emulate better what a guest driver should do (append the command
	to the ring and then signal).

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: use core interface to create watch
	This increase code reuse and make Glib integration more straight forward.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	worker: remove empty statement at line end
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: use variable already set at beginning of loops
	This is mainly question of style.
	Instead of repeating same conversion use the variable we set at the
	beginning of the function.
	Note also that I used same name to make the two functions more
	similar.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: remove max_pipe_size constant parameter
	All checks for full channel pipes have to be consistents
	so there is no point in passing as a parameter.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-01-22  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	channel: do not call pipe_add with null items
	If the creator was not able to produce the item, no need to call
	pipe_add().

	Acked-by: Frediano Ziglio <fziglio@redhat>

	channel: document pipes_create_batch() function
	Rename callback to pipe_add, and document the arguments.

	Acked-by: Frediano Ziglio <fziglio@redhat>

2016-01-22  Jonathon Jongsma  <jjongsma@redhat.com>

	Replay: report error if we don't read the correct file header
	The replay file should start with a header such as
	  SPICE_REPLAY 1

	Instead of soldiering on if we don't encounter this header, print a
	warning and return NULL.  Also exit with a failure if spice_replay_new()
	returns a NULL object in main.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-01-21  Jonathon Jongsma  <jjongsma@redhat.com>

	Change some functions to take RedsState arg
	In preparation for getting rid of the global 'reds' variable, we need to
	pass the RedsState variable to all functions where it is needed. For now
	the callers just pass in the global reds variable.

	Functions changed:
	- reds_mig_fill_wait_disconnect;
	- reds_mig_cleanup_wait_disconnect;
	- reds_mig_remove_wait_disconnect_client;
	- reds_migrate_channels_seamless;
	- reds_mig_finished;
	- reds_mig_switch;
	- reds_enable_mm_time;
	- reds_disable_mm_time;
	- attach_to_red_agent;
	- reds_char_device_add_state;
	- reds_char_device_remove_state;
	- reds_on_char_device_state_destroy;
	- spice_server_char_device_remove_interface;
	- migrate_timeout.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-21  Christophe Fergeau  <cfergeau@redhat.com>

	event-loop: Remove template
	Since SpiceCoreInterfaceInternal is a private data structure, we can
	extend it as we see fit without breaking ABI. In particular, adding a
	GMainContext member to it allows us to remove the need for
	the event loop template which is currently included in the
	basic_event_loop.c test file.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	test-loop: Improve basic_event_loop base_{timer, watch}_add
	They call the functions provided by event_loop_core, but with a NULL
	SpiceCoreInterfaceInternal parameter. It makes more sense to pass
	event_loop_core rather than NULL.
	This will allow to pass the GMainContext to be used through
	SpiceCoreInterfaceInternal rather than through a template parameter.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-20  Pavel Grunt  <pgrunt@redhat.com>

	dcc: make dcc_compress_image_*() private
	Reviewed-by: Victor Toso <victortoso@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	dcc-send: Use dcc_compress_image to compress image
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	dcc_compress_image: Handle NULL drawable
	It will be used in the following commit.
	The GLZ compression cannot be used when the drawable is NULL.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	build-sys: Update spice-common submodule

2016-01-20  Jonathon Jongsma  <jjongsma@redhat.com>

	Change some functions to take RedsState arg
	In preparation for getting rid of the global 'reds' variable, we need to
	pass the RedsState variable to all functions where it is needed. For now
	the callers just pass in the global reds variable.

	Functions changed:
	- reds_link_mig_target_channels;
	- reds_on_migrate_dst_set_seamless;
	- reds_on_client_seamless_migrate_complete;
	- reds_on_client_semi_seamless_migrate_complete;
	- reds_handle_other_links;
	- reds_handle_link;
	- reds_send_mm_time;
	- reds_set_client_mm_time_latency;
	- reds_init_net;
	- do_spice_init;
	- reds_init_ssl;
	- on_activating_ticketing;
	- reds_mig_release to take RedsState arg
	- reds_mig_started.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Change some functions to take RedsState arg
	In preparation for getting rid of the global 'reds' variable, we need to
	pass the RedsState variable to all functions where it is needed. For now
	the callers just pass in the global reds variable.

	Functions changed:
	- reds_on_main_migrate_connected;
	- reds_on_main_mouse_mode_request;
	- reds_on_main_channel_migrate;
	- reds_marshall_migrate_data;
	- reds_agent_state_restore;
	- reds_handle_migrate_data;
	- reds_send_link_ack;
	- reds_mig_target_client_add;
	- reds_mig_target_client_find;
	- reds_mig_target_client_free;
	- reds_mig_target_client_disconnect_all;
	- reds_find_client;
	- reds_get_client;
	- reds_handle_main_link;
	- reds_set_client_mouse_allowed.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-20  Frediano Ziglio  <fziglio@redhat.com>

	channel: do not free rcc->stream in red_channel_client_disconnect
	This fixes a crash if red_channel_client disconnect is called
	handling a message.
	This can happen for instance while handling SPICE_MSGC_ACK which calls
	red_channel_client_push which tries to detect write errors while writing
	to a socket (for instance socket disconnection).
	Messages are read in a loop and red_channel_client_disconnect would
	cause rcc->stream to be NULL which will result in a use-after-free
	problem (stream in red_peer_handle_incoming will use cached stream value).

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	tests: test removed triggered timers are not called
	This could happen for instance if a given timer remove all clients
	which have associated timers.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	tests: add a test for event loop
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	tests: extract code for event loop
	This code will be reused for main loop

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	tests: do not use default loop context
	Make sure we don't handle event reserved to other loop contexts.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-01-19  Christophe Fergeau  <cfergeau@redhat.com>

	Remove use of spice_warn_if()
	spice_warn_if_fail() is doing the same thing except for the inverted
	condition. spice_warn_if() is being removed from spice-common to avoid
	having potentially confusing redundancy.

2016-01-19  Jonathon Jongsma  <jjongsma@redhat.com>

	reds_num_of_clients() -> reds_get_n_clients()
	More consistent with glib naming conventions. Also make the function
	static since it's not used outside of this source file.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	reds_num_of_channels() -> reds_get_n_channels()
	More consistent with glib naming conventions.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Change some functions to take RedsState arg
	In preparation for getting rid of the global 'reds' variable, we need to
	pass the RedsState variable to all functions where it is needed. For now
	the callers just pass in the global reds variable.

	Functions changed:
	- vdi_port_read_buf_process;
	- vdi_port_read_buf_get;
	- vdi_port_read_buf_unref;
	- reds_handle_agent_mouse_event;
	- reds_num_of_channels;
	- reds_num_of_clients;
	- reds_fill_channels;
	- reds_on_main_agent_start;
	- reds_get_agent_data_buffer;
	- reds_release_agent_data_buffer;
	- reds_client_monitors_config_cleanup;
	- red_on_main_agent_data.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-01-19  Frediano Ziglio  <fziglio@redhat.com>

	tests: remove leaks in test-qxl-parsing
	This make happy address sanitizer during make check.
	Otherwise memory leak detector can keep in and make tests fails.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-01-19  Jonathon Jongsma  <jjongsma@redhat.com>

	Pass 'reds' as opaque data in vdi port char device
	This allows us to access the RedsState variable non-globally without
	changing the signature of the callback functions.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-01-18  Jonathon Jongsma  <jjongsma@redhat.com>

	Change some functions to take RedsState arg
	In preparation for getting rid of the global 'reds' variable, we need to
	pass the RedsState variable to all functions where it is needed. For now
	the callers just pass in the global reds variable.

	Functions changed:
	- reds_register_channel;
	- reds_unregister_channel;
	- reds_get_mouse_mode;
	- reds_set_mouse_mode;
	- reds_update_mouse_mode;
	- reds_agent_remove;
	- reds_find_channel;
	- reds_mig_cleanup;
	- reds_reset_vdp;
	- reds_main_channel_connected;
	- reds_client_disconnect;
	- reds_disconnect;
	- reds_mig_disconnect.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2016-01-15  Frediano Ziglio  <fziglio@redhat.com>

	replay: better documentation for -C and -S options
	Document all possible values

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	replay: add streaming setting option
	Add -S to allow to set a video streaming rule.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	utils: handle errors writing to bitmap file
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	utils: fix endianess issues writing bitmap file
	Do not print directly binary data but serialize in a portable way
	and then use write functions.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	utils: use always fwrite to write bitmap
	Make easier to check error on next patch

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-01-15  Jonathon Jongsma  <jjongsma@redhat.com>

	Make global 'reds' extern
	This allows it to be accessed from other files. This is a temporary step
	toward getting rid of the global-ness of this variable, and it allows us
	to update the function signature bit-by-bit.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-15  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	stream-test: add batch test
	Check that two consecutive msgfd are read back from two different reads.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-15  Frediano Ziglio  <fziglio@redhat.com>

	replay: use spice_malloc(0) instead of raw malloc
	These function report memory allocation errors.
	spice_malloc0 also reset memory after allocation.

	Acked-by: Victor Toso <victortoso@redhat.com>

2016-01-15  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	build-sys: build a noinst libtest.a to link to
	Group the test utility in a library, to avoid repeating the same
	sources. In this case, automake already figues out what the source of
	the programs to build is.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-15  Frediano Ziglio  <fziglio@redhat.com>

	replay: remove command line memory leaks
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2016-01-14  Frediano Ziglio  <fziglio@redhat.com>

	build-sys: update spice-common
	This is an update to fix build issues with spice-protocol.git.
	generated_server_demarshallers.c: In function
	‘parse_msgc_display_gl_draw_done’:
	generated_server_demarshallers.c:767:23: error:
	‘SpiceMsgcDisplayGlDrawDone’ undeclared (first use in this function)
	     mem_size = sizeof(SpiceMsgcDisplayGlDrawDone);
	...

	Also needed for upcoming gl-scanout messages.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-14  Christophe Fergeau  <cfergeau@redhat.com>

	Remove GSlice use
	It's being slowly deprecated in glib
	https://bugzilla.gnome.org/show_bug.cgi?id=754687

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove compress_buf_new
	This commit reworks a bit the management of RedCompressBuf so that
	compress_buf_new/compress_buf_free become unneeded.
	Since d25d6ca0 and the introduction of encoder_data_reset,
	compress_buf_free is already unused outside of dcc-encoders.c and could
	be static. This in turn makes compress_buf_new a bit odd as the matching
	destructor is never used in dcc.c.
	This commit introduces an encoder_data_init() method which is hiding
	the initialization of the EncoderData structure from the dcc.c code,
	allowing to get rid of compress_buf_new() calls from dcc.c code.

	It also uses this as an opportunity to stop using GSlice for
	RedCompressBuf.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-14  Frediano Ziglio  <fziglio@redhat.com>

	channel: simplify red_channel_client_send_item
	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Victor Toso <victortoso@redhat.com>

2016-01-14  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	tests: add fdpass stream test
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-14  Marc-André Lureau  <mlureau@redhat.com>

	reds-stream: add send_msgfd()
	A new function to send fd with unix socket anciliary data.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-14  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	build-sys: build a utility libserver.la
	This allow tests programs to link with statically built library to access all symbols

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-13  Christophe Fergeau  <cfergeau@redhat.com>

	Update NEWS for 0.13.0 release

	spicevmc: Drop unsent data on client disconnection
	When redirecting a USB webcam over a slow link, it's currently possible
	to hit an assertion in spice-server by running cheese (application using
	the webcam), killing the client with ctrl+c and then restarting the
	client:
	qemu-kvm: spicevmc.c:324: spicevmc_red_channel_alloc_msg_rcv_buf:
	Assertion `!state->recv_from_client_buf' failed.

	This happens when red_peer_handle_incoming tries to allocate memory for
	a message using spicevmc:
	handler->msg = handler->cb->alloc_msg_buf(handler->opaque, msg_type,
	msg_size);

	red_peer_handle_incoming() is called when there is client data to be
	read, and does
	- call alloc_msg_buf() to allocate memory for the message
	- read the message
	- if the read was partial, return early, the main loop will call again
	  red_peer_handle_incoming() when there is more data available for that
	  channel
	- parse the message
	- call release_msg_buf() to free the message

	For channels based on spicevmc (usbredir and port), alloc_msg_buf()
	stores message data in SpiceVmcState::recv_from_client_buf and before
	allocating new memory, it asserts that it's NULL.

	This is what causes this crash in the following scenario:
	- SpiceVmc::alloc_msg_buf() is called and allocates memory for a new
	  message in SpiceVmcState::recv_from_client_buf
	- red_peer_handle_incoming() returns early as all the spicevmc message
	  data hasn't been received yet
	- the client gets killed
	- the main channel notices the disconnect and calls
	  main_dispatcher_client_disconnect() which will disconnect all the
	  channels
	- SpiceVmc::on_disconnect is called
	- after the new client connects, SpiceVmc::alloc_msg_buf() is called,
	  notices that SpiceVmcState::recv_from_client_buf is already set, and
	  asserts()

	This commit makes sure the partial SpiceVmcState::recv_from_client_buf
	data is cleared on disconnect so that the assert does not trigger.

	This fixes https://bugzilla.redhat.com/show_bug.cgi?id=1264113

2016-01-12  Sunny Shin  <sunny4s.git@gmail.com>

	channel: add option tcp keepalive timeout to channels

2016-01-12  Christophe Fergeau  <cfergeau@redhat.com>

	stat: Make stat_compress_init/stat_init the same
	When COMPRESS_STAT is not set, and RED_WORKER_STAT is set,
	stat_time() will be a no-op, but stat_start_time_init() will try to use
	stat_info_t::clock. This causes a compile warning on 32 bit arches (not
	sure why not on 64 bit builds), as well as an error from valgrind.

	Since stat_time() and stat_compress_time() are both doing the same work,
	this commit makes them the same function, which ensures
	stat_info_t::clock will be set and stat_start_time_init() can be used
	regardless of the _init() method which is called.

2016-01-12  Francois Gouget  <fgouget@codeweavers.com>

	server: Fix conversions between QXLPHYSICAL and pointers
	This avoids compilation errors with -Werror on 32 bit systems as the
	pointer size differs from that of a QXLPHYSICAL.

	server: Simplify the next chunk initialization in red_replay_data_chunks()

	server: Fix a pointer to uint64_t cast in spice_replay_next_cmd()
	This avoids a compilation error with -Werror on 32 bit systems as the
	pointer size differs from that of an uint64_t.

2016-01-11  Frediano Ziglio  <fziglio@redhat.com>

	channel: use iface parameter to distinguish interface context
	Now we can use the iface parameter to distinguish the context instead
	of doing strange assumption on opaque and its state.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	channel: add interface parameters to SpiceCoreInterfaceInternal
	This patch and previous ones want to solve the problem of not having a
	context in SpiceCoreInterface. SpiceCoreInterface defines a set of
	callbacks to handle events in spice-server. These callbacks allow to
	handle timers, watch for file descriptors and send channel events.
	All these callbacks do not accept a context (usually in C passed as a
	void* parameter) so it is hard for them to differentiate the interface
	specified.
	Unfortunately this structure is used even internally from different
	contexts for instance every RedWorker thread has a different context. To
	solve this issue some workarounds are used. Currently for timers a variable
	depending on the current thread is used while for watches the opaque
	parameter to pass to the event callback is used as it currently points just
	to RedChannelClient structure.  This however imposes some implicit
	maintainance problem in the future. What happens for instance if for some
	reason a timer is registered during worker initialization, run in another
	thread? What if we decide to register a file descriptor callback for
	something not a RedChannelClient?  Could be that the program will run
	without any issue till some bytes change and weird things could happen.

	The implementation of this solution is done implementing an internal "core"
	interface that has context specific and use it to differentiate the
	context instead of relying on some other, hard to maintain, detail. Then an
	adapter structure (name inpired to the adapter pattern) will provide the
	internal core interface using the external, public, definition (in the
	future this technique can be used to extend the external interface without
	breaking the ABI).

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	channel: build adapter for public core interface
	Add wrapper functions for SpiceCoreInterface in order to present
	a SpiceCoreInterfaceInternal. These functions just expect
	SpiceCoreInterfaceInternal API and forward request to
	SpiceCoreInterface.
	This allows to change ABI details of internal one.

	See comments in "channel: add interface parameters to
	SpiceCoreInterfaceInternal" patch.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	channel: add a new internal SpiceCoreInterface
	Define an internal structure that matches 100% the ABI of the public one.
	The structure will be changed by following patches.
	See comments in "channel: add interface parameters to
	SpiceCoreInterfaceInternal" patch.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	stats: use CLOCK_THREAD_CPUTIME_ID for cpu statistics
	Use CLOCK_THREAD_CPUTIME_ID instead of getting the clock
	with pthread_getcpuclockid.
	This avoids to call red_worker_get_clockid. This function returns
	uninitialized value at the time DisplayChannel is built resulting in setting
	statistics to CLOCK_REALTIME (which is 0) instead to cpu time as expected.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	dcc: avoid to report errors triggered by client
	Client can always send report even if a stream is not available.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-01-08  Frediano Ziglio  <fziglio@redhat.com>

	add some tests for cursors parsing
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	add test for QXL parsing functions
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	check properly if red_get_data_chunks fails or not
	Instead of returning 0 which could be a valid value returns an invalid
	one and check on the caller.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	prevent integer overflow in red_get_clip_rects
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	dcc: write and use a new encoder_data_reset function to clean buffers
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	dcc: free glz buffer after zlib compression
	For zlib+glz compression image if first compressed with glz then the
	resulting buffer is compressed again with zlib then the buffer from
	zlib is returned to the caller.
	However the temporary glz buffer was not freed resulting in a memory
	leak.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2016-01-08  Eduardo Lima (Etrunko)  <etrunko@redhat.com>

	server: Fix tests Makefile
	As reported in https://bugs.freedesktop.org/show_bug.cgi?id=93520, the
	build from git is failing in Archlinux systems with undefined
	references to glib symbols.

	This patch fixes the problem by simply reordering the order libraries
	will be linked. Also, removes duplicate $(GLIB_LIBS) variable.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2016-01-08  Pavel Grunt  <pgrunt@redhat.com>

	syntax-check: Fix sc_cast_of_argument_to_free
	red_replay_qxl.c was renamed in 525cd67be7c5

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	syntax-check: Remove empty line at EOF
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	syntax-check: Fix missing AUTHORS
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-12-22  Frediano Ziglio  <fziglio@redhat.com>

	replay: better help for -s option
	-s accepts an option to delay command queueing.

	Acked-by: Marc-André Lureau <mlureau@redhat.com>

2015-12-21  Marc-André Lureau  <mlureau@redhat.com>

	reds-stream: add reds_stream_is_plain_unix()
	Utility function used in follow-up code.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-21  Pavel Grunt  <pgrunt@redhat.com>

	build-sys: Use sasl check from spice-common
	Support only libsasl2 providing libsasl2.pc file

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-12-21  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	tests: remove test_util.h
	Replace ASSERT() with spice_assert().

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-21  Frediano Ziglio  <fziglio@redhat.com>

	tests: remove unused macro
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-12-17  Lukas Venhoda  <lvenhoda@redhat.com>

	dcc: Don't disconnect channel, when compression is not supported
	Don't disconnect the display channel, when unsupported compression is
	requested from the client. Not changing the compression is enough.

	https://bugs.freedesktop.org/show_bug.cgi?id=92821
	Acked-by: Victor Toso <victortoso@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-16  Christophe Fergeau  <cfergeau@redhat.com>

	build: Remove unused SPICEC_STATIC_LINKAGE_BSTATIC
	A left-over from the client code.

2015-12-16  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	stream: consitify reds_stream_get_family() argument
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-15  Francois Gouget  <fgouget@codeweavers.com>

	server: Use '%zu' to print size_t variables
	The size_t definition is different between 32 and 64 bit systems so that
	neither '%u' nor '%lu' work for both. '%zu' should be used instead.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	server: Remove an unneeded mjpeg-encoder.h include
	The corresponding code has been moved elsewhere during the refactoring.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	server: Use PRI macros in printf for 32/64 bit compatibility
	Some integer type definitions are different between 32 and 64 bit
	systems which causes problems in printf. The PRI macros automatically
	provide the printf format appropriate for the system.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-12-15  Frediano Ziglio  <fziglio@redhat.com>

	tests: reuse Makefile macro
	For coherency use COMMON_BASE macro instead of including single
	files.

	Acked-by: Victor Toso <victortoso@redhat.com>

	tests: allocate memory in a coherent fashion
	Do not free memory allocated with C functions (like calloc) using g_free;
	although this is possible with default Glib allocator this is not safe.
	Also use consistent allocation functions. All other spice-server code
	does not use Glib allocations so for coherence do not use them for
	watches.

	Acked-by: Victor Toso <victortoso@redhat.com>

2015-12-14  Marc-André Lureau  <mlureau@redhat.com>

	red-channel: constify some callback structs
	Because we can.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-14  Christophe Fergeau  <cfergeau@redhat.com>

	build: Don't list some installed headers twice
	Since commit febaed3, spice.h and spice-experimental.h are listed both
	in libspice_server_la_HEADERS and libspice_server_la_SOURCES. Since we
	want these headers to be installed, we can remove them from _SOURCES.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-14  Francois Gouget  <fgouget@codeweavers.com>

	server: Add time constants to go with spice_get_monotonic_time_ms()
	They clarify the time unit being used and simplify calculations.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	server: Add time constants to go with spice_get_monotonic_time_ns()
	They clarify the time unit being used, reduce the need for casts and
	simplify calculations.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	server: Rename DISPLAY_CLIENT_TIMEOUT and de-duplicate it
	Given that it is used for both cursor and display, COMMON_CLIENT_TIMEOUT
	seems more appropriate. Also define it only in red-worker.h.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-11  Pavel Grunt  <pgrunt@redhat.com>

	worker: Rename function name in the comment as well
	It was renamed in 47b023866faac2c5e3302d4d3fc42a0260a5557c

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-12-11  Frediano Ziglio  <fziglio@redhat.com>

	dcc: do not cause problem with multiple threads.
	With multiple cards configured you can have multiple workers running in
	different thread.
	With such configuration static variables not syncronized could lead
	to undefined behavior.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	reds: do not use g_malloc0 in server code
	The rest of code is using spice_malloc* functions, use them for
	consistency.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-12-11  Francois Gouget  <fgouget@codeweavers.com>

	server: Use spice_get_monotonic_time_ms() in spice_timer_queue.c
	This reduces code duplication.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	server: Add spice_get_monotonic_time_ms()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	server: Rename red_get_monotonic_time() to spice_get_monotonic_time_ns()
	This is a generic function not tied to the red_xxx functionality and the
	new name clarifies that it returns the time in nanoseconds (unlike
	g_get_monotonic_time()).

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	server: Provide a framerate estimate based on the initial frames
	This way the video encoder can actually count on a real estimate when
	it is initializing.
	Note that the server only creates a video stream if at least 20 bitmap
	'blits' of the same size and type arrive, each within a maximum time
	interval from the previous one. So it was only keeping track of the
	frame to frame interval. Thus to get an average frame rate over all the
	20 frames it's necessary to also keep track of the first_frame_time.

2015-12-11  Marc-André Lureau  <mlureau@redhat.com>

	snd: remove duplicated snd_attach_*() code
	red_channel_set_data() already sets channel->data.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	build-sys: disable static lib by default
	It's not used in general, so no need to build it by default.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-10  Marc-Andre Lureau  <marcandre.lureau@gmail.com>

	red-dispatcher: group cases
	A small cleanup.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-10  Marc-André Lureau  <mlureau@redhat.com>

	snd: simplify reds_register_channel() call
	Give channel argument directly

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-10  Frediano Ziglio  <fziglio@redhat.com>

	channel: make sure we retain RedChannelClient while processing it
	During display_channel_handle_migrate_data the pointer is passed
	to different functions which could release it making the pointer
	invalid. Make sure pointer is not freed while processing.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	channel: rename red_channel_(client_)waits_* functions
	Make clear that these funcion are just checking a condition.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-12-10  Francois Gouget  <fgouget@codeweavers.com>

	server: Remove an unneeded time.h include directive
	main-channel.c now uses g_get_monotonic_time() instead of
	clock_gettime().

2015-12-09  Frediano Ziglio  <fziglio@redhat.com>

	server: misc header cleanups
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	server: merge spice-bitmap-utils and spice_bitmap_utils
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	stat: add test for statistic functions
	Make sure code compile with and without statistics enabled (beside
	printing functions).

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	stat: use a better design for statistic functions
	make sure code compile with statistics enabled or disabled.
	Dummy (empty) structures and functions are used instead of preprocessor.
	Also fix a problem as stat_compress_init did not initialize clock
	field.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	stat: fix portability problem in stat_time_t declaration
	Assure stat_time_t is 64 bit on all architectures.
	long is not 64 bit on 32 bit systems so use uint64_t intead.
	Also avoid 32 bit overflows for such architectures.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-12-09  Marc-André Lureau  <marcandre.lureau@gmail.com>

	display: replace some dubious asserts
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Uri Lublin <uril@redhat.com>

2015-12-08  Francois Gouget  <fgouget@codeweavers.com>

	server: Use g_get_monotonic_time() to get the time in microseconds
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	server: Define the MJPEG encoder warmup time in nanoseconds
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	server: Simplify the MJPEG encoder's maximum framerate estimation
	Note that if frame_size == bytes_per_sec == 0 this now returns
	MJPEG_MAX_FPS but this should not happen anyway.

	server: Rename SUPPORT_AUTOMATED_TESTS to HAVE_AUTOMATED_TESTS
	This improves consistency with spice-deps.m4 which names its
	AM_CONDITIONAL() variables HAVE_XXX.

2015-12-04  Alon Levy  <alon@pobox.com>

	server: multiple clients works ok if we limit the pipe to the slowest client
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-12-04  Frediano Ziglio  <fziglio@redhat.com>

	pass proper type to SPICE_CONTAINEROF
	In some case the member specified to SPICE_CONTAINEROF was not
	exactly the same type of the pointer passed.
	This can cause issues if structure changes so use proper member.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: improve validation for update command
	If surface_id is not valid we should still release resource allocated
	by red_get_update_cmd and from the guest.
	This to reduce leaks in case of a race or another error in the guest
	driver.
	Also not issue a warning on invalid surface number to avoid filling
	log space unconditionally.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-12-04  Jonathon Jongsma  <jjongsma@redhat.com>

	remove glz_encoder_config.h
	Move all code from glz_encoder_config.h into other files.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-04  Alon Levy  <alon@pobox.com>

	tests: test_display_base: use a faster wakeup time to easily test multiple client blocking
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-12-04  Frediano Ziglio  <fziglio@redhat.com>

	server: rename files
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	memslot: change some spice_assert to spice_return_if_fail
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	display: misc style and rename changes
	- remove some red_ prefix;
	- move red_drawable->self_bitmap check outside handle_self_bitmap;
	- move update check outside red_get_area (renamed surface_read_bits);
	- rename depend_on_surface_id argument to surface_id;
	- rename success variable to add_to_pipe.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: move red_process_draw to display-channel.c
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	display: make get_drawable symmetric to display_channel_drawable_unref
	Make possible to safely call display_channel_drawable_unref straight
	after calling get_drawable.

	Problem was function definitions and dependency.

	display_channel_drawable_try_new is supposed to return an uninitialized
	pointer (or NULL on failure) to a Drawable structure.

	(display_channel_)get_drawable is supposed to return an initialized
	pointer (or NULL) to a Drawable structure.

	(display_channel_)add_drawable is supposed to add the Drawable to the
	list/tree of drawing to draw.

	Now, with these definitions after get_drawable the Drawable state (if
	pointer is not NULL) should be consistent and we should be able to call
	display_channel_drawable_unref.

	In the current code this was not true as for instance surface_id was
	copied to Drawable but the reference counter of the surface was not
	incremented leading possible unref call to decrement the counter and
	free the surface. This can happen if any call between get_drawable and
	unref does not increment the reference in a consistent way. This
	basically means that every present or future code in the path between
	get_drawable and unref have to know this unconsistency and handle it.
	This is a maintaining problem as people need to know these details when
	editing existing code (actually this is display_channel_add_drawable
	code).
	This basically create a dependency between get_drawable and
	add_drawable.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-12-03  Francois Gouget  <fgouget@codeweavers.com>

	server: Reuse red_get_monotonic_time() in the MJPEG video encoder
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-03  Frediano Ziglio  <fziglio@redhat.com>

	stat: fix stat_info_t initialization
	For compression statistics clock field was not initialized but used
	computing statistics.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-12-03  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: rename process_commands process_display
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-12-03  Frediano Ziglio  <fziglio@redhat.com>

	dcc: reduce statement wrapping
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: change red_worker_new_channel result to CommonChannel*
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	memslot: prefix memslot functions with memslot_
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: do not use dynamic memory for RedSurfaceCmd
	Allocation on stack is sufficient and code is more similar to
	QXL_CMD_MESSAGE and QXL_CMD_UPDATE cases.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	display: move more logic in display_channel_get_drawable()
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move get_drawable to display-channel.c
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-12-02  Marc-André Lureau  <marcandre.lureau@gmail.com>

	smartcard: include libcacard.h if possible

2015-12-02  Yonit Halperin  <yhalperi@redhat.com>

	red_worker: make dcc_clear_surface_drawables_from_pipe declaration consistent with definition
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-12-02  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: merge handle_new_display_channel
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	display: rename detach_streams_behind
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	display: add update_compression() method
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: move red_process_surface
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-11-27  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Add travis CI file

	Update spice-common
	Fix distcheck

	build-sys: remove --enable-opengl
	OpenGL was removed in commit c5c176a5c7, enabling it on discheck will
	fail to link with spice-common gl-enabled library

	server: cleanups
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: remove some unnecessary inline
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: move dcc_send & marshallers to dcc-send.c
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-26  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move red_pipes_remove_drawable
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move current_remove*
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move more stream functions
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	display: remove some public declarations
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	server: move LZ_IMAGE_TYPE_* enum to dcc
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	display: Simplify display_channel_create_surface
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	server: rename _tmpl files
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	display: reuse code in display_channel_draw_until
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: use spice_return_if_fail() instead of spice_assert() in release_item
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: changed some spice_assert in display_channel_draw_till
	Reviewed-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-25  Marc-André Lureau  <marcandre.lureau@gmail.com>

	display: Remove extra parameters from create_canvas_for_surface
	Get them from the surface

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: move display_channel_create_surface
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: move display_channel_update
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: move destroy_surface() familly
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: move display_channel_new
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	display: factor out current_find_intersects_rect
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	display: factor out draw_until
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move display_channel_draw
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: simplify surface_update_dest()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-25  Francois Gouget  <fgouget@codeweavers.com>

	server: Remove MJPEG's video callback assert
	A NULL get_roundtrip_ms() callback simply disables rate control so
	that mjpeg_encoder_get_source_fps() will not be called.
	Should it be called despite this, simply return the highest allowed
	framerate (get_source_fps()'s value is only an estimate anyway).
	Finally update_client_playback_delay() is always checked before use.

	server: Encapsulate the get_source_fps() video encoder callback

2015-11-24  Frediano Ziglio  <fziglio@redhat.com>

	worker: simplify handle_dev_oom
	Do not check if worker->display_channel is NULL as we are already using
	to get some field so must be not NULL.
	Reuse display_red_channel variable.

	Acked-by: Uri Lublin <uril@redhat.com>

	dcc: remove possible dandling pointers
	Set pointers to NULL after releasing encoders.
	This to make sure no further access will occurs.

	Acked-by: Victor Toso <victortoso@redhat.com>
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-11-24  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: Change validate_area to surface_update_dest
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: rename red_connect_cursor and tidy up a bit
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-11-24  Frediano Ziglio  <fziglio@redhat.com>

	worker: fix constant
	Use mnemonic instead of constant to return enumeration value

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-24  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move drawable_draw
	Acked-by: Fabiano Fidêncio <fabiano@fidencio.org>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: remove display_channel prefix from channel callbacks
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: move dcc_release_item
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: simplify handle_migrate_data functions
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move dcc_handle_migrate_data
	Acked-by: Fabiano Fidêncio <fabiano@fidencio.org>

	worker: move attach_stream
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move dcc_add_drawable*
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move dcc_handle_message
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: do not set worker image compression on client request
	Display client can ask to change the preferred compression.
	Previously this setting change the entire worker setting
	so every future client created would have this setting.
	Remove the setting in the worker make the change only to the
	current client.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-23  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: rename update_area
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Fabiano Fidêncio <fabiano@fidencio.org>

	worker: move display_channel_free_some
	Author:    Marc-André Lureau <marcandre.lureau@gmail.com>
	Acked-by: Fabiano Fidêncio <fabiano@fidencio.org>

	worker: replace some precondition checks
	Acked-by: Fabiano Fidêncio <fabiano@fidencio.org>

	worker: generalize surface_dirty_region_to_rects
	Acked-by: Fabiano Fidêncio <fabiano@fidencio.org>

	worker: move dcc_add_surface_area_image
	Author:    Marc-André Lureau <marcandre.lureau@gmail.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-11-23  Pavel Grunt  <pgrunt@redhat.com>

	main channel: Remove unused main_channel_client_get_link_id
	It was introduced in 9cece23ba3e49e6eec9e380daa95d6ee0133c91c
	but never used.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	main channel: Remove unused main_channel_push_notify
	It is not needed since 8d44aa032892ea6643925fa7485d9af32853e127

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	red channel: Remove unused red_channel_apply_clients_data
	It was introduced in 7e8e13593ee681cf04c349bca57dd225d7802494
	but never used.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	red channel: Remove unused declaration of red_channel_pipes_remove
	It was introduced in 09ae4700d27b7c1cca64c2ce4c90f0c6cdf81ccf
	but never used.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	red channel: Remove unused red_channel_push_set_ack
	It is not needed since 8e7b22b7861d2859167767822f29749bfe3ecc16

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	red dispatcher: Remove unused declaration of red_dispatcher_set_mm_time
	It is not used since c541d7e29dc0053e6434d053a50454bb8a7121e9

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	dispatcher: Remove unused dispatcher_read_message
	It is not needed since d3153f861065235c2a7a7120375be5db948c5a77

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-23  Frediano Ziglio  <fziglio@redhat.com>

	worker: move red_drawable_count to DisplayChannel
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	reuse red_get_monotonic_time function
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-11-21  Marc-André Lureau  <marcandre.lureau@gmail.com>

	server: remove OpenGL
	This is really not supported, requires X11, so better to remove it for
	now. Some day it might be revived, using DRM, ..

	Note for later, this could be removed too (not used by client):
	- spice-common/common/ogl_ctx

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	stream: remove red_stream_ prefix from mjpeg callbacks
	Author:    Marc-André Lureau <marcandre.lureau@gmail.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	stream: rename {red_stream_, }get_initial_bit_rate
	Author:    Marc-André Lureau <marcandre.lureau@gmail.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	stream: remove dcc parameter from stream_agent_stop()
	Author:    Marc-André Lureau <marcandre.lureau@gmail.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-20  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move more free_glz_drawable
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-20  Pavel Grunt  <pgrunt@redhat.com>

	worker: Free encoders when client disconnects

	dcc: Fix unused display_channel variable
	Avoid problem when compiling with lz4 and without COMPRESS_STAT

	dcc.c: In function 'dcc_compress_image_lz4':
	dcc.c:657:21: error: unused variable 'display_channel' [-Werror=unused-variable]
	     DisplayChannel *display_channel = DCC_TO_DC(dcc);

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-20  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move stream_clip_item_unref()
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: merge red_draw_qxl_drawable in drawable_draw
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move dcc_pixmap_cache_add
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move dcc_freeze_glz
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: few function renames
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: add display_channel_free_glz_drawables_to_free()
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move dcc_free_glz_drawable_instance
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: move display_channel_flush_all_surfaces
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-20  Frediano Ziglio  <fziglio@redhat.com>

	worker: move compress to dcc_compress_image()
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: move glz_drawable_count to DisplayChannel
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-11-19  Christophe Fergeau  <cfergeau@redhat.com>

	manual: Document path to vdagent logs on Windows

	manual: Small formatting fixes
	The XML namespace to use with libvirt when adding custom QEMU arguments
	looks better in a monospace font.
	asciidoc will also replace the '->' in '<->' with an arrow character,
	which looks bad. This commit reformulates the sentence to avoid the use
	of <->

2015-11-19  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move display_channel_wait_for_migrate_data
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move dcc_start()
	Author:    Marc-André Lureau <marcandre.lureau@gmail.com>
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: start a DisplayChannelClient unit
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-19  Pavel Grunt  <pgrunt@redhat.com>

	Fix spice-common submodule
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-19  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: simplify GlzDrawableInstanceItem fields name
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: move encoders to dcc-encoders
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-18  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: painfully move display_channel_add_drawable
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: add compression parameters to dcc
	This allow different dcc to have different settings from default one.
	The parameters are copied initially from default settings but then they
	can change independently for each client.
	Even having a single client a future client is not affected by a
	previous setting on the old dcc.

	[updated for the preferred compression]
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-18  Jonathon Jongsma  <jjongsma@redhat.com>

	Rename red_display_free_* to dcc_free_*
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-11-18  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: simplify RedCompressBuf
	Make sure an allocated buffer is correctly referenced by the marshaller,
	and can't be free and reused by mistake. Simplify the code by using
	GSlice

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: move surfaces to DisplayChannel
	Ok. this one was painful.Note that in some cases, DCC_TO_DC should be
	made safer (there used to be a if !dcc guard in some places, although
	that looks wrong anyway)...

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-11-18  Jonathon Jongsma  <jjongsma@redhat.com>

	Move stream creation and maintenance functions to stream.[ch]
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-18  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move stream_agent_stop and friends
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-11-18  Pavel Grunt  <pgrunt@redhat.com>

	worker: Remove unused red_show_tree
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-18  Marc-André Lureau  <marcandre.lureau@gmail.com>

	display-channel: Keep macro definition in one line
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-18  Frediano Ziglio  <fziglio@redhat.com>

	worker: simplify red_marshall_image
	Remove some nested blocks using else if.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-11-18  Jonathon Jongsma  <jjongsma@redhat.com>

	worker: Move stream functions to stream.c
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-17  Jonathon Jongsma  <jjongsma@redhat.com>

	Move some tree item functions to tree.[ch]
	Also rename some functions slightly:
	     __find_shadow -> tree_item_find_shadow()
	     __contained_by -> tree_item_contained_by()
	     ring_of -> tree_item_container_items();

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-11-16  Francois Gouget  <fgouget@codeweavers.com>

	build-sys: Use SPICE_WARNING() to issue the architecture warning
	Note that spice-deps.m4 now provides the AS_VAR_APPEND() fallback.

2015-11-16  Jonathon Jongsma  <jjongsma@redhat.com>

	Move some more drawable functions to display channel
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: Rename current_clear() to current_remove_all()
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Move dcc_push_stream_agent_clip() to display channel
	rename to dcc_add_stream_agent_clip()

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-11-16  Francois Gouget  <fgouget@codeweavers.com>

	server: Duplicate typedef definitions are not allowed in C99
	This fixes some compilation errors with gcc 4.4.7 on RHEL 6.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	server: Include stdint.h for int64_t
	This fixes a compilation error with gcc 4.4 on RHEL 6.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-13  Francois Gouget  <fgouget@codeweavers.com>

	server: Remove the display_channel_attach_stream() prototype
	It is unused.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	build-sys: Use AC_MSG_NOTICE()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-13  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: don't use weird RedCompressedBuf nbytes shifting
	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-13  Victor Toso  <victortoso@redhat.com>

	spicevmc: set state of DeviceInstance to NULL
	After spice_char_device_state_destroy is called spicevmc should not keep
	reference to that memory. state->chardev_st and sin->st point to the
	same SpiceCharDeviceState and both should be set to NULL when it is
	destroyed.

	char-device: set to NULL freed pointers on destroy
	As SpiceCharDeviceState is only unref'ed on
	spice_char_device_state_destroy the same device could be destroyed more
	then once so the pointers that are freed should be set to NULL.

	Related: https://bugzilla.redhat.com/show_bug.cgi?id=1281455

2015-11-13  Pavel Grunt  <pgrunt@redhat.com>

	reds: Do not abort due to wrong header
	Just prevent the buggy client from connecting.

	 #0  0x00007fffe83b2a98 in raise () at /lib64/libc.so.6
	 #1  0x00007fffe83b469a in abort () at /lib64/libc.so.6
	 #2  0x00007ffff7b1533d in spice_logv (log_domain=0x7ffff7b87226 "Spice", log_level=SPICE_LOG_LEVEL_ERROR, strloc=0x7ffff7b92aba "reds.c:1373", function=0x7ffff7b94f40 <__FUNCTION__.31775> "reds_send_link_ack", format=0x7ffff7b871fe "assertion `%s' failed", args=args@entry=0x7fffffffcb68) at log.c:109
	 #3  0x00007ffff7b15468 in spice_log (log_domain=log_domain@entry=0x7ffff7b87226 "Spice", log_level=log_level@entry=SPICE_LOG_LEVEL_ERROR, strloc=strloc@entry=0x7ffff7b92aba "reds.c:1373", function=function@entry=0x7ffff7b94f40 <__FUNCTION__.31775> "reds_send_link_ack", format=format@entry=0x7ffff7b871fe "assertion `%s' failed") at log.c:123
	 #4  0x00007ffff7aee335 in reds_handle_read_link_done (link=0x555556b27c70)
	     at reds.c:1373
	 #5  0x00007ffff7aee335 in reds_handle_read_link_done (opaque=0x555556b27c70)
	     at reds.c:2139
	 #6  0x000055555588acc6 in qemu_iohandler_poll ()
	 #7  0x000055555588a8e1 in main_loop_wait ()
	 #8  0x0000555555614064 in main ()

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1281442

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-13  Victor Toso  <victortoso@redhat.com>

	char-device: free all memory pool when no clients
	When no client is connect we should not need to keep the memory pool
	used by char-device. In most situations this is not significant but
	when using webdav this could mean freeing MAX_POOL_SIZE bytes

	Related: https://bugs.freedesktop.org/show_bug.cgi?id=91350

	char-device: Define a memory pool limit
	Otherwise the amount of unused memory could grow while transfering big
	chunks of data. This change only means that once the memory was used it
	will not be stored again after the limit was reached.

	Related: https://bugs.freedesktop.org/show_bug.cgi?id=91350

	char-device: fix usage of free/unref on WriteBuffer
	There are places were the could should definetly free the
	SpiceCharDeviceWriteBuffer and places that it should only unref it. The
	current use of spice_char_device_write_buffer_free was missleading.

	This patch creates the spice_char_device_write_buffer_unref and properly
	call these two functions.

	Related: https://bugs.freedesktop.org/show_bug.cgi?id=91350

2015-11-12  Frediano Ziglio  <fziglio@redhat.com>

	worker: fix compiling with COMPRESS_STAT enabled
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-12  Pavel Grunt  <pgrunt@redhat.com>

	worker: Remove usage of streaming_video global in DisplayChannel
	Avoid creating streams for every image due to not properly initialized
	DisplayChannel->stream_video field.

	Regression since: 4987df8e67f48cde13d39f4e81909f672ae33e29

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-12  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move some tree container functions
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: rename a bit current_add functions
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-11  Jonathon Jongsma  <jjongsma@redhat.com>

	worker: Remove duplicate DISPLAY_CLIENT_TIMEOUT define
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-11  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move RED_WORKER_STAT, make it compile again
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-11  Jonathon Jongsma  <jjongsma@redhat.com>

	worker: Move drawable utility functions to display channel
	Functions that check the equality of a path, brush, etc are moved the
	display channel source file to prepare for moving the surfaces to the
	display channel.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: Move is_opaque_item() to tree.h
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-11  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move drawable to display
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-11-10  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move current to display
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: move red_destroy_surface_item()
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: move stream to display channel
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: move DisplayChannel/DisplayChannelClient functions together
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: rename functions that handle DisplayChannelClient
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move stream functions to a new stream.c file
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move stream definitions to a new stream.h file
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: fix RED_STREAM_TIMOUT macro spelling
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-10  Frediano Ziglio  <fziglio@redhat.com>

	remove server/stream.h file added by mistake in previous commit
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

2015-11-10  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move image cache to display
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker s/surfaces_dest/surface_deps
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-11-09  Pavel Grunt  <pgrunt@redhat.com>

	syntax-check: Add missing #include <config.h>

	red_dispatcher: Remove unused signal.h include

2015-11-09  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: group add_memslot
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: remove unused NUM_CURSORS define
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: make more functions static
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: remove unused function
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: rename {put,ref}_red_drawable
	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	worker: s/destroy_surface/surface_unref
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-09  Frediano Ziglio  <fziglio@redhat.com>

	worker: remove unused parameter from remove_shadow
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-11-09  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: remove some useless counters
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	dispatcher: remove receive_data and send_data functions
	Use read_safe/write_safe instead which do the same stuff

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	server: create display and cursor channels in RedWorker constructor
	Instead of requiring the dispatcher to send a message to the worker to
	create the display channel and cursor channel, just create them when
	the worker is created.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-11-06  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: use RED_CHANNEL_CLIENT for dcc
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-06  Pavel Grunt  <pgrunt@redhat.com>

	spicevmc: Return early when instance has no device state
	Same approach as in spice_server_char_device_wakeup().
	Avoid segmentation fault when the webdav channel (spice port channel) is
	used with the vnc display:
	 #0  0x00007ffff7aab734 in spice_char_device_state_opaque_get (dev=0x0)
	     at char_device.c:720
	 #1  0x00007ffff7b0850c in spice_server_port_event (sin=<optimized out>, event=<optimized out>) at spicevmc.c:578
	 #2  0x0000555555787ba4 in set_guest_connected (port=<optimized out>, guest_connected=1) at hw/char/virtio-console.c:89
	 #3  0x0000555555678d7c in control_out (len=<optimized out>, buf=0x55555775c3a0, vser=0x5555578d1540) at /home/pgrunt/RH/qemu/hw/char/virtio-serial-bus.c:404
	 #4  0x0000555555678d7c in control_out (vdev=0x5555578d1540, vq=0x555557941bc8)
	     at /home/pgrunt/RH/qemu/hw/char/virtio-serial-bus.c:441
	 #5  0x000055555588eb98 in aio_dispatch (ctx=0x5555562e1a50) at aio-posix.c:160
	 #6  0x00005555558829ee in aio_ctx_dispatch (source=<optimized out>, callback=<optimized out>, user_data=<optimized out>) at async.c:226
	 #7  0x00007ffff2010e3a in g_main_context_dispatch () at /lib64/libglib-2.0.so.0
	 #8  0x000055555588d8fb in main_loop_wait () at main-loop.c:211
	 #9  0x000055555588d8fb in main_loop_wait (timeout=<optimized out>)
	     at main-loop.c:256
	 #10 0x000055555588d8fb in main_loop_wait (nonblocking=<optimized out>)
	     at main-loop.c:504
	 #11 0x000055555561b664 in main () at vl.c:1891

2015-11-06  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move shadow_new() and container_new()
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: use more DCC_TO_WORKER
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move some compress stats to display
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: rename WORKER_FOREACH_DCC_SAFE macro to FOREACH_DCC
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: remove unused WORKER_TO_DCC macro
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: rename red_pipe_add_drawable* to dcc_add_drawable*
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: move delta computation
	Move delta computation from red_add_drawable to red_current_add_with_shadow.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-05  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move MonitorsConfig to display channel
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	worker: minor simplification
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-05  Frediano Ziglio  <fziglio@redhat.com>

	worker: don't process drawable if it can't be allocated
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-05  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: move DisplayChannel struct
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-04  Jonathon Jongsma  <jjongsma@redhat.com>

	style: prefer early return to large if blocks
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove unnecessary typedef from pixmap-cache.h
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-04  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: Move some dpi code to display channel
	This commit moves some DrawablePipeItem declarations to
	display-channel.h, though the function implementations remain in
	red_worker.c until they can be disentangled some more.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-04  Fabiano Fidêncio  <fidencio@redhat.com>

	cursor: fix wrong logic when initializing the channel
	It's a regression introduced by commit e601e920bd5. The logic error was
	introduced when trying to achieve the following code[0]. but rewritten
	to prefer an early return, which was wrogly negated.

	[0]:
	if (cursor_is_connected(worker)
	    && !COMMON_CHANNEL(worker->cursor_channel)->during_target_migrate) {
	        red_channel_pipes_add_type(RED_CHANNEL(worker->cursor_channel),
	                                   PIPE_ITEM_TYPE_CURSOR_INIT);
	}

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-04  Jonathon Jongsma  <jjongsma@redhat.com>

	Palette cache: Use correct marshal function
	In order to invalidate a single palette cache item, we were using
	spice_marshall_msg_cursor_inval_one(), which is the marshal function
	used to send an invalidation message for the Cursor channel's cache.
	This didn't cause any problems because SPICE_MSG_CURSOR_INVAL_ONE and
	SPICE_MSG_DISPLAY_INVAL_PALETTE have the same message ID and parameters,
	but it's better to use the correct marshalling function.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-04  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Various changes in RedWorker and CursorChannel related to error and warning messages.
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Move monitors_config to display
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	s/process_drawable/process_draw
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-03  Marc-André Lureau  <marcandre.lureau@gmail.com>

	server: move renderer members to DisplayChannel
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-11-03  Frediano Ziglio  <fziglio@redhat.com>

	worker: remove only assigned set_client_capabilities_pending field
	This field is only assigned and never readed so can be removed.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-03  Marc-André Lureau  <marcandre.lureau@gmail.com>

	server: move bitmap related to spice-bitmap-utils
	Also remove some unused function parameters from
	bitmap_get_graduality_level()

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: remove unused worker parameter
	Acked-by: Pavel Grunt <pgrunt@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Store QXLInstance in CursorItem
	Doing so allows us to remove the extra QXLInstance parameter from
	cursor_item_unref() and makes the code a bit cleaner.

	Also add cursor_item_ref().

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	server: make more of cursor private
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	server: make cursor channel private
	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

2015-11-02  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Move pipe item enumerations out of red_worker.h
	Move the cursor-specific pipe item types to cursor-channel.h, and the
	display-specific types to red_worker.c. Only leave the common
	definitions in red_worker.h. This prepares for splitting the display
	channel into a separate file.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>

	server: move display_channel_client_create() to dcc_new()
	Move function from server/red_worker.c to new server/display-channel.c.

	Acked-by: Fabiano Fidêncio <fidencio@redhat.com>
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	tree: move that to a separate unit
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: s/repoll/poll_tries
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-30  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Various minor style changes to worker and cursor channel
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: remove assertion on alloc_drawable
	There is no guarantee in the code that this can't be hit, so we should
	cope with it (the condition can be reached easily by running the server
	without waiting for blocked clients or pipe size)

	The following commit will attempt to address this.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	__new_channel -> red_worker_new_channel()
	Rename and lightly refactor the function that creates new common
	channels for RedWorker (essentially Cursor and Display channels).

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Make cursor_channel_disconnect a CursorChannel method
	The first argument should be CursorChannel* rather than RedChannel*
	since it's essentially a CursorChannel method.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-30  Francois Gouget  <fgouget@codeweavers.com>

	server: Hide the MJPEG encoder internals from red_worker.c

	server: Move the MJPEG encoder functions to mjpeg_encoder.c
	Note that this requires some adjustments to the encode_frame()
	parameters to avoid red_worker-specific types.

	server: Move mjpeg_encoder_new() to the end of mjpeg_encoder.c
	This also allows getting rid of a couple of forward definitions.

	server: Remove an unnecessary cast in encode_frame()

2015-10-30  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Remove a couple single-use static functions
	red_cursor_marshall_inval(), red_migrate_cursor() and
	on_new_cursor_channel() were short functions that were each only called
	from a single location, so there's no need for them to be separate
	functions.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	CursorChannel* arg in cursor_channel_client_new()
	Instead of passing a CommonChannel* argument, use CursorChannel* since
	this function is only valid for CursorChannels.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	common_channel_client_create -> common_channel_new_client
	Rename and re-order the initial arguments to make this function look and
	act more like a method of the CommonChannel class.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Change red_marshall_verb() to accept a VerbItem
	Instead of passing a verb enumeration value, pass the verb pipe item

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	Remove unused parameter from cursor_channel_new()
	cursor_channel_new() is only called from one location, and always passes
	FALSE as the value for the 'migrate' paramater. In addition, this
	parameter is not used within the function. Remove it.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-29  Frediano Ziglio  <fziglio@redhat.com>

	server: remove undefined declaration

2015-10-29  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Replace now() with get_mononotonic_time()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	utils: add red_get_monotonic_time()

2015-10-29  Frediano Ziglio  <fziglio@redhat.com>

	worker: avoid to use constant directly for capabilities size
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-10-29  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Move red_bitmap_utils.h->tmpl.c
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: move some cursor code to cursor-channel.c
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: rename some cursor functions
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: change CursorItem memory allocation
	Do not use static allocate space but handle dynamically

2015-10-28  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: remove unused type field from AddBufInfo
	value was always BUF_TYPE_RAW

	Acked-by: Uri Lublin <ulublin@redhat.com>

2015-10-28  Frediano Ziglio  <fziglio@redhat.com>

	worker: fix timer queue creation
	Timer queue is attached to current thread when created so it must be
	created from the proper thread.
	After worker initialization is moved in a following patch to main
	thread the queue was created in the wrong thread causing program to
	fail saying that the queue is NULL.

	Acked-by: Uri Lublin <ulublin@redhat.com>

2015-10-26  Marc-André Lureau  <marcandre.lureau@gmail.com>

	server: group worker channel related stuff
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: remove need for WorkerInitData
	Move code around to declare and place it where it fits better.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	worker: access dispatcher pending field using helper functions

2015-10-23  Marc-André Lureau  <marcandre.lureau@gmail.com>

	server: split cache-item.h
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	server: start separate display/cursor channel headers
	Just move some declarations around

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	server: remove worker->id
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-23  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Adjust to new spice-common spice-deps.m4
	This commit also updates the spice-common submodule

	Christophe Fergeau (7):
	      Add marshaller test case
	      build-sys: Use ${PKG_CONFIG} rather than pkg-config
	      build-sys: Rework SPICE_CHECK_* m4 macros
	      build-sys: Add gio-2.0 to SPICE_CHECK_GLIB2
	      build-sys: Fix error in SPICE_CHECK_LZ4 description
	      build-sys: Set automake conditional in SPICE_CHECK_SMARTCARD
	      build-sys: Rename SUPPORT_GL to HAVE_GL

	Javier Celaya (1):
	      Fix linearization of several marshallers with one item

	Lukas Venhoda (3):
	      ssl-verify: Only check addr length when using IP addr
	      m4: Require glib version >= 2.22
	      ssl-verify: Changed IPv4 hostname to IPv6

2015-10-23  Frediano Ziglio  <fziglio@redhat.com>

	remove small leak in MJPEG code
	cinfo.dest is allocated in spice_jpeg_mem_dest but never freed.
	Note that jpeg_destroy_compress does not free this field as is
	supposed to be a buffer provided by jpeg caller.

	reduce locking time in async_command_alloc

	removed unused recv_core field

2015-10-23  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: remove useless MESSAGE_READY
	Now that worker is created before running, and run() returns success,
	there is no point in using MESSAGE_READY.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

	dispatcher: style update
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-22  Marc-André Lureau  <marcandre.lureau@gmail.com>

	server: remove worker thread creation from dispatcher
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	server/dispatcher: move worker enums to dispatcher header
	Group enums with their respective struct location.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Fabiano Fidêncio <fabiano@fidencio.org>

2015-10-21  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: use a single clockid
	The stat functions in worker are not generic enough to deserve to be
	"non-worker", so just pass the worker instance.

2015-10-20  Marc-André Lureau  <marcandre.lureau@gmail.com>

	server: rename red_client_cache.h to cache_item.tmpl.c
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-19  Christophe Fergeau  <cfergeau@redhat.com>

	Add missing license headers

	syntax-check: Exclude png files from sc_prohibit_empty_lines_at_EOF

	syntax-check: Clean-up exception rules
	Some files no longer exists, some exceptions are no longer needed, ...

	syntax-check: Remove unused #include <strings.h>

	syntax-check: Add missing #include <config.h>

	syntax-check: Don't use tabs for indentation

	syntax-check: Exclude red_replay_qxl.c from sc_cast_of_argument_to_free
	red_replay_qxl.c stores some pointers QXLPHYSICAL data members (ie
	uint64_t), and then needs to free them, so the cast is required.

	syntax-check: Ignore .png files in sc_trailing_blank test

	syntax-check: manual: Remove duplicate word

	syntax-check: Add missing AUTHORS

2015-10-19  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: use GOnce to surround some global init in dispatcher
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	server: move some pixmap cache code in own file
	Remove that hideous template header that should really be regular code
	since it's specialized and instanciated only for pixmap.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-19  snir sheriber  <ssheribe@redhat.com>

	fix spelling mistakes in comments (reseting to resetting & dummym to dummy)
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-16  Jeremy White  <jwhite@codeweavers.com>

	Update the .gitignore files for the new manual, for a few newly generated tests, and for the spice-server.h.

2015-10-16  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Remove DRAW_ALL
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-15  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Remove PIPE_DEBUG
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove ACYCLIC_SURFACE_DEBUG
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	Remove unfinished UPDATE_AREA_BY_TREE
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	server: small move to red_channel
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	worker: replace init with red_worker_new
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	red_worker: replace some abort()
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-10-12  Frediano Ziglio  <fziglio@redhat.com>

	Simplify pointer computation
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-10-07  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Remove client check from configure.ac
	configure.ac is checking for pyparsing availability if
	client/generated_marshallers.cpp is missing. The client/ code is gone, and
	the python modules checks are done in spice-common/configure.ac
	nowadays, so we can get rid of this check.

2015-10-06  Frediano Ziglio  <fziglio@redhat.com>

	build-sys: bump libtool version information
	As one interface was added bump the version and put a comment to avoid
	too much updates.

2015-10-06  Christophe Fergeau  <cfergeau@redhat.com>

	Mention the 2 recently fixed CVEs in NEWS

2015-10-06  Frediano Ziglio  <fziglio@redhat.com>

	Prevent leak if size from red_get_data_chunks don't match in red_get_image

	Prevent data_size to be set independently from data
	There was not check for data_size field so one could set data to
	a small set of data and data_size much bigger than size of data
	leading to buffer overflow.

	Avoid race condition copying segments in red_get_path
	The guest can attempt to increase the number of segments while
	spice-server is reading them.
	Make sure we don't copy more then the allocated segments.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Make sure we can read QXLPathSeg structures
	start pointer points to a QXLPathSeg structure.
	Before reading from the structure, make sure the structure is contained
	in the memory range checked.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix some possible overflows in red_get_string for 32 bit
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Prevent DoS from guest trying to allocate too much data on host for chunks
	Limit number of chunks to a given amount to avoid guest trying to
	allocate too much memory. Using circular or nested chunks lists
	guest could try to allocate huge amounts of memory.
	Considering the list can be infinite and guest can change data this
	also prevents strange security attacks from guest.

	Prevent memory leak if red_get_data_chunks_ptr fails
	Free linked list if client tries to do nasty things

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix race condition in red_get_data_chunks_ptr
	Do not read multiple times data from guest as this can be changed by
	other guest vcpus. This causes races and security problems if these
	data are used for buffer allocation or checks.

	Actually, the 'data' member can't change during read as it is just a
	pointer to a fixed array contained in qxl. However, this change will
	make it clear that there can be no race condition.

	Fix integer overflow computing glyph_size in red_get_string
	If bpp is int the formula can lead to weird overflows. width and height
	are uint16_t so the formula is:

	  size_t = u16 * (u16 * int + const_int) / const_int;

	so it became

	  size_t = (int) u16 * ((int) u16 * int + const_int) / const_int;

	However the (int) u16 * (int) u16 can then became negative to overflow.
	Under 64 bit architectures size_t is 64 and int usually 32 so converting
	this negative 32 bit number to a unsigned 64 bit lead to a very big
	number as the signed is extended and then converted to unsigned.
	Using unsigned arithmetic prevent extending the sign.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix race condition in red_get_string
	Do not read multiple time an array size that can be changed.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix race in red_get_image
	Do not read multiple times data from guest as this could be changed
	by other vcpu threads.
	This causes races and security problems if these data are used for
	buffer allocation or checks.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix race condition on red_get_clip_rects
	Do not read multiple time an array size that can be changed.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Prevent 32 bit integer overflow in bitmap_consistent
	The overflow may lead to buffer overflow as the row size computed from
	width (bitmap->x) can be bigger than the size in bytes (bitmap->stride).
	This can make spice-server accept the invalid sizes.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix buffer reading overflow
	Not security risk as just for read.
	However, this could be used to attempt integer overflows in the
	following lines.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Check properly surface to be created
	Check format is valid.
	Check stride is at least the size of required bytes for a row.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	Fix some integer overflow causing large memory allocations
	Prevent integer overflow when computing image sizes.
	Image index computations are done using 32 bit so this can cause easily
	security issues. MAX_DATA_CHUNK is larger than the virtual
	card limit, so this is not going to cause change in behaviours.
	Comparing size calculation results with MAX_DATA_CHUNK will allow us to
	catch overflows.
	Prevent guest from allocating large amount of memory.

	Define a constant to limit data from guest.
	This limit will prevent guest trying to do nasty things and DoS to host.

	worker: avoid double free or double create of surfaces
	A driver can overwrite surface state creating a surface with the same
	id of a previous one.
	Also can try to destroy surfaces that are not created.
	Both requests cause invalid internal states that could lead to crashes
	or memory corruptions.

	worker: validate correctly surfaces
	Do not just give warning and continue to use an invalid index into
	an array.

	Resolves: CVE-2015-5260

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-10-05  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: make it clear it returns from process when no cmd
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-02  Marc-André Lureau  <marcandre.lureau@gmail.com>

	server: remove useless includes
	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-10-01  Christophe Fergeau  <cfergeau@redhat.com>

	manual: Fix Arnon last name
	It's "Gilboa", not "Giloba"

	manual: Add section about debugging
	This details the basics for now, but can be detailed in the future.

	Update NEWS

2015-09-29  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: count in drawable_new()

2015-09-29  Jonathon Jongsma  <jjongsma@redhat.com>

	PALLET -> PALETTE
	Use the correct spelling for the enumeration

2015-09-29  Christophe Fergeau  <cfergeau@redhat.com>

	tests: Fix -Werror=format-zero-length build failure
	replay.c: In function 'replay_channel_event':
	replay.c:226:16: error: zero-length gnu_printf format string
	[-Werror=format-zero-length]
	     g_printerr("");

2015-09-24  Christophe Fergeau  <cfergeau@redhat.com>

	display: Advertise preferred compression cap
	The patches adding a way for the client to set its preferred compression
	method added a new capability so that the server can indicate support
	for this feature. However, spice-server was not setting this capability
	on its display channel, which means clients are not going to try to send
	'preferred-compression' messages even though the user request it.

2015-09-15  Marc-André Lureau  <marcandre.lureau@gmail.com>

	manual: add smartcard channel section
	Add some basic instructions to setup smartcard channel

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	manual: add missing space
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	manual: update webdav virt-manager section
	virt-manager can add webdav channel for a while now.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-09-08  Frediano Ziglio  <fziglio@redhat.com>

	Avoid race conditions reading monitor configs from guest
	For security reasons do not assume guest do not change structures it
	pass to Qemu.
	Guest could change count field while Qemu is copying QXLMonitorsConfig
	structure leading to heap corruption.
	This patch avoid it reading count only once.

	This patch solves CVE-2015-3247.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	replay: fix formatting string
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-09-07  Frediano Ziglio  <fziglio@redhat.com>

	build-sys: Update warning message
	arch_warn was set to 1 only if architecture is not x86, x64 or arm.
	Update the message as we actually mainly test x64.
	Define the warning message and do the architecture checks in the
	same place so that they are easier to keep in sync.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-09-04  Frediano Ziglio  <fziglio@redhat.com>

	improve performances comparing image pixels
	This patch contains a bit of small optimizations.
	It avoid boolean	 operations which could involve branches replacing
	with binary operations (equal/all_ident -> some_differences).
	The other optimization avoids the use of ABS. First the way the macro
	was used (with a large expression) was not easy to optimize by the
	compiler.
	Then instead of using ABS a much simpler range check is used so instead
	of (ABS(n) >= k) a ((n) <= -k || (n) >= k) is used. This looks small
	but modern compilers can translate this not in range check in a couple
	of machine instructions (and a single compare).

	Using operf on same samples (using spice-server-replay) and trying 2 runs
	I got

	run             1       2
	-------------------------
	before    104441   106267
	after      92387    91083

	So the performance increase is about 13%.

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-09-03  Frediano Ziglio  <fziglio@redhat.com>

	avoid to call red_get_streams_timout twice computing timeout
	Due to how the MIN macro is defined the function was called twice
	unless the compiler could demonstrate that was returning the same
	value (which actually is impossible as function as clock_gettime
	are not deterministic).

	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	spice_timer_queue: fix access after free
	Do not access to timer after we call the associated function.
	Some of these callbacks can call spice_timer_remove making the pointer
	pointing to freed data.
	This happen for instance when the client is disconnecting.
	This does not cause memory corruption on current allocator
	implementations as all freeing/accessing happen on a single thread quite
	closely and allocators use different pools for different thread.

	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-09-01  Frediano Ziglio  <fziglio@redhat.com>

	replay: compatibility with former version
	GMutex usage in replay.c was not working so replace with plain pthread.

	replay: do not define same type twice
	Avoid to use typedef twice for the same type as some compiler
	complaints about it.
	SpiceTimer and SpiceWatch are defined in server/spice-core.h
	as an abstract type which should be defined by some code (as
	server/tests/basic_event_loop.c does).

2015-09-01  Christophe Fergeau  <cfergeau@redhat.com>

	Update spice-common submodule
	Christophe Fergeau (1):
	      build-sys: Remove code generation files from EXTRA_DIST

	Frediano Ziglio (1):
	      common: Fix typo in comment

	build-sys: Add missing header files to _SOURCES
	2 newly-added header files were not added to _SOURCES, breaking make
	distcheck.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>

2015-09-01  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Remove useless pack attribute
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

	server: remove srand(time(NULL))
	This is clearly not a library responsability.

	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-09-01  Alon Levy  <alon@pobox.com>

	server/red_worker: remove redundant spice_warn_if in validate_surface
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-09-01  Marc-André Lureau  <marcandre.lureau@gmail.com>

	server: remove hardcoded RED_MAX_RENDERERS
	Acked-by: Frediano Ziglio <fziglio@redhat.com>
	Acked-by: Jonathon Jongsma <jjongsma@redhat.com>

2015-08-28  Frediano Ziglio  <fziglio@redhat.com>

	Simplify set_surface_release_info
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

	replay: fix typo in message
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-08-26  Frediano Ziglio  <fziglio@redhat.com>

	Avoid core calling spice_server_destroy
	spice_server_destroy calls reds_exit which is called also at exit time
	(is registered with atexit) so avoid to keep dangling pointers.
	Currently this does not happen as spice_server_destroy is not called
	by Qemu.

	prevent integer overflow on 32 bit
	On 32 bit machine timespec->tv_sec (time_t) is 32 bit.
	Also 1000 * 1000 * 1000 is 32 bit.
	The multiplication of 2 32 bit integers gives a 32 bit integer, however
	this can overflow.
	Converting the first factor to 64 bit before the multiplication solves
	the issue.

	remove unused SAME_PIXEL macro

2015-08-26  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Remove test_spice_version.h
	This script was used at make distcheck time to verify consistency of the
	version number defined in configure.ac and in spice-server headers.
	Since commit ab12cf414c, these 2 version numbers can no longer be out of
	sync, so we can drop this script.

	server: Readd spice-experimental.h
	Commit 3c6b4e41 removed spice-experimental.h as this header was not
	used, nor supposed to be used. However, QEMU had been including it
	(without using any of its symbols) until commit v2.3.0-rc0~135^2~1

	As this is fairly recent (Nov 2014), building older QEMUs with new
	spice-server releases, or even bisecting QEMU will be broken as they
	will be looking for a no-longer available header.

	This commit readds a spice-experimental.h file, however it only contains
	a #warning indicating this file is deprecated. This means older QEMU
	will build now, but only if they were configured with --disable-werror.

	build-sys: Require a new enough spice-protocol in .pc file
	spice-server headers expose SpiceImageCompression which is only available
	from recent spice-protocol releases.
	This dependency must be expressed in Requires and not Requires.private

2015-08-25  Frediano Ziglio  <fziglio@redhat.com>

	remove wrong statement terminator from preprocessor macro
	Actually not causing problems as when used is always followed by another
	terminator but better to fix the definition.

	Acked-by: Pavel Grunt <pgrunt@redhat.com>

	Use MAX macro to compute the maximum value

	replay: use plain pthread for mutex/condition
	Mutex/conditional require Glib 2.32 which is not available in RHEL6.
	Use plain pthread to make this module compatible with RHEL6.

	Acked-by: Fabiano Fidencio <ffidenci@redhat.com>

	replay: fix check for QXL_SURF_FLAG_KEEP_DATA flag
	A logical and (&&) was used instead of a bit one (&).
	Was working just as is the only flag defined.

	Acked-by: Fabiano Fidencio <ffidenci@redhat.com>

2015-08-24  Frediano Ziglio  <fziglio@redhat.com>

	worker: remove unused members from Drawable
	Acked-by: Christophe Fergeau <cfergeau@redhat.com>

2015-08-22  Alon Levy  <alon@pobox.com>

	server/tests/spice-server-replay: introduce
	usage: spice-server-replay -p <port> -c <client command line> <cmdfile>

	will run the commands from cmdfile ignoring timestamps, right after a
	connection is established from the client, and will SIGINT the client
	on end of cmdfile, and exit itself after waiting for the client.

	spicy-stats from spice-gtk is useful for testing, it prints the summary
	of the traffic on each channel.

	You can also run with no client by doing:
	spice-server-replay <cmdfile>

	For example, the 300 MB file (compressed to 4 MB with xz -9) available
	at [1] produces the following output:

	spicy-stats total bytes read:
	total bytes read:
	inputs: 214
	display: 1968983
	cursor: 390
	main: 256373

	You could run it directly like so:
	curl http://annarchy.freedesktop.org/~alon/win7_boot_shutdown.cmd.xz | \
	  xzcat | server/tests/spice-server-replay -p 12345 -c `which spicy-stats` -

	Known Problems:
	* Implementation is wrong. Should do a single device->host conversion
	 (i.e. get_virt), and then marshall/demarshall that (i.e. RedDrawable).
	* segfault on file read done resulting in the above spicy-stats not
	 being reproducable (well, up to 1% yes).

	[1] http://annarchy.freedesktop.org/~alon/win7_boot_shutdown.cmd.xz

	Now based on glib including using an asyncqueue for reading the playback
	file, and proper freeing of the allocated commands, with --slow,
	--compression and a progress timer, and doesn't use more then nsurfaces.

2015-08-21  Alon Levy  <alon@pobox.com>

	server/red_worker: record to SPICE_WORKER_RECORD_FILENAME
	if the environment variable in the title is set and can be
	opened for writing a log of all display commands (no cursor
	commands yet) and any QXLWorker calls (particularily primary
	create and destroy) will be logged to that file, and possible
	to replay using the replay utility introduced later.

	For an example file (4 MB download, 300 MB after unpack with xz,
	these 300 MB are themselves reduced from 1.2GB using zlib compression
	for any chunk):

	(old file without a header)
	http://annarchy.freedesktop.org/~alon/win7_boot_shutdown.cmd.xz

	server/red_{record, replay}.[ch]: introduce
	Currently hand crafted with some sed scripts and alot of vim macros from
	red_parse_qxl after considering the logger in qemu/hw/qxl-logger.c and seeing
	it was incomplete. The only problem with logging from the server and
	not from qemu is that it requires coordinated shutdown to avoid half a message.

	Should be automatically generated from a declarative syntax, i.e. qxl.proto.

	Note: zlib compression is introduced in a disabled state, see ZLIB
	define

	Now with a simple versioned header and generated ids by the server
	instead of based on the recorded file, and doesn't use more then 1024
	surfaces (configurable).

2015-08-20  Alon Levy  <alon@pobox.com>

	server/dispatcher: add extra_dispatcher, hack for red_record

2015-08-20  Marc-André Lureau  <marcandre.lureau@redhat.com>

	tests: use glib main loop

2015-08-20  Alon Levy  <alon@pobox.com>

	Remove use of INLINE
	It's #define'd to 'inline', and only used in the GLZ encoder.

2015-08-20  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Remove spice-protocol submodule
	It's seeing regular releases and is API stable, so we don't need to
	bundle it with spice-server

2015-08-20  Victor Toso  <victortoso@redhat.com>

	mjpeg and jpeg encoder: fix alignment warnings
	As the input line could be uint8_t*, uint16_t* or uint32_t*, changing
	the default from uint8_t* to void* seems the correct choice to deal with
	upcasting warnings.

	Regarding chunks->data allocation, I quote Frediano explantion:
	"Lines came from spice_bitmap_get_line. This function assume that bitmap
	data is split among chunks each containing some lines
	(always full lines). If chunk->data is allocated using malloc or similar
	SHOULD (not 100% sure) be 4 bytes aligned so in our cases
	(8, 16, 24 or 32 bit images) should be aligned enough.

	All the casts unfortunately came from the fact we compute based on
	pixel bytes to make it generic so we use uint8_t*."

	and

	"Looking at code looks like these chunks came from the virtual machine.
	So the question is... why should the virtual machine give use some
	not-pixel align data?
	I would put a large comment to state that we assume VM send aligned
	data, would be stupid for the VM to not align it!"

	clang output:
	jpeg_encoder.c:109:26: error: cast from 'uint8_t *'
	(aka 'unsigned char *') to 'uint16_t *' (aka 'unsigned short *')
	increases required alignment from 1 to 2 [-Werror,-Wcast-align]
	  uint16_t *src_line = (uint16_t *)line;
	                       ^~~~~~~~~~~~~~~~

	jpeg_encoder.c:144:26: error: cast from 'uint8_t *'
	(aka 'unsigned char *') to 'uint32_t *' (aka 'unsigned int *')
	increases required alignment from 1 to 4 [-Werror,-Wcast-align]
	  uint32_t *src_line = (uint32_t *)line;
	                       ^~~~~~~~~~~~~~~~

	mjpeg_encoder.c:260:23: error: cast from 'uint8_t *'
	(aka 'unsigned char *') to 'uint16_t *' (aka 'unsigned short *')
	increases required alignment from 1 to 2 [-Werror,-Wcast-align]
	  uint16_t pixel = *(uint16_t *)src;
	                    ^~~~~~~~~~~~~~~

	glz: WindowImageSegment lines lines_end as void*
	Instead of using uint8_t* which can cause several warnings on casting as
	the example below:

	./glz_encode_tmpl.c:321:29: error: cast from 'uint8_t *'
	(aka 'unsigned char *') to 'rgb16_pixel_t *' (aka 'unsigned short *')
	increases required alignment from 1 to 2 [-Werror,-Wcast-align]
	 ref_limit = (PIXEL *)(seg->lines_end);
	              ^~~~~~~~~~~~~~~~~~~~~~~~~

	migration_protocol: use SPICE_MAGIC_CONST
	spice-protocol has a new define to create the magic constants, let's use
	that.

2015-08-12  Victor Toso  <victortoso@redhat.com>

	red_parse_qxl: Do not compute abs unsigned int
	SpiceBitmap's stride is uint32_t.

	from clang:
	red_parse_qxl.c:452:41: error: taking the absolute value of unsigned
	type 'uint32_t' (aka 'unsigned int') has no effect

	bitmap_size = red->u.bitmap.y * abs(red->u.bitmap.stride);
	                                ^

2015-08-12  Alon Levy  <alon@pobox.com>

	server/inputs_channel: Cope with NULL keyboard in release_keys()
	This fixes a test_display_no_ssl segfault on client disconnect when
	the keyboard was never initialized.

2015-08-11  Victor Toso  <victortoso@redhat.com>

	red_parse_qxl: remove unused variable

2015-08-11  Jonathon Jongsma  <jjongsma@redhat.com>

	Remove unused struct RedsOutItem

	RedChannel: remove unused BufDescriptor struct

2015-08-11  Christophe Fergeau  <cfergeau@redhat.com>

	Remove unused snd_get_playback_compression() method

	Fix typo in comment in char_device.h

2015-08-11  Jonathon Jongsma  <jjongsma@redhat.com>

	Fix typo in comments

	Move RedsMigSpice to main-channel.h
	This is the place that needs the complete type definition. If it is
	defined in reds.h, it can create circular references.

	Cleanup: move static function declarations out of header
	It doesn't make much sense to have static function declarations in a
	header, even a private header. So move them down into the source file.

2015-08-11  Marc-André Lureau  <marcandre.lureau@gmail.com>

	worker: remove unused preload_group_id

	channel: minor simplification

	server: remove unused CursorData

	server: use more const CoreInterface

	worker: move red_init_*() functions
	There is a red_init() methods, we can group all the red_init_*() calls
	in it rather than calling red_init() followed by all these calls in our
	main function.

2015-08-04  Uri Lublin  <uril@redhat.com>

	spice-common: codegen: ptypes.py: keep attribute names in sets
	This fixes the build on RHEL-6

2015-07-29  Christophe Fergeau  <cfergeau@redhat.com>

	Adjust to new SpiceImageCompress name
	This has been renamed to SpiceImageCompression in order to avoid clashes
	with older spice-server in the SPICE_IMAGE_COMPRESS_ namespace. This
	commit is a straight rename of SpiceImageCompress to
	SpiceImageCompression and SPICE_IMAGE_COMPRESS_ to
	SPICE_IMAGE_COMPRESSION_

2015-07-28  Jeremy White  <jwhite@codeweavers.com>

	Add libraries such as -lm and -lpthread to the tests build line.
	This prevents a compile error on Debian Jessie, from git, such as this:
	/usr/bin/ld: test_playback.o: undefined reference to symbol 'sin@@GLIBC_2.2.5'
	//lib/x86_64-linux-gnu/libm.so.6: error adding symbols: DSO missing from command line

	This is fairly subtle, and Debian specific.  It only happens when you use
	autoreconf to generate a new libtool script.  Debian patches that script
	to require an explicit setting to link with all dependent libraries.

	It should be harmless on other distros, and it does save us Debian guys some
	hassle.

2015-07-20  Frediano Ziglio  <fziglio@redhat.com>

	reds: Assure we don't have stale statistic files before trying to create a new one
	If a previous Qemu executable is not able to delete the statistic file
	on the next creation with same name (statitics file are based on pid
	numbers so if pid get reused for another Qemu process you get the same
	name) it fails as you can't open a file with 0444 permissions (these
	are the permission used to create these files).
	This patch assure there are no stale file trying to remove it before the
	creation of the new one. As file is based on pid and name used for spice
	you are not deleting another file.

	Fixes: rhbz#1177326

2015-07-20  Francois Gouget  <fgouget@codeweavers.com>

	server: spice_debug() messages don't need a trailing '\n'.

	server: Weakly try to get a better latency value for the bandwidth test.
	NET_TEST_WARMUP_BYTES is 0 so the warmup ping is the same as the one we
	use to measure the latency. Even if it was not, the actual latency would
	be the MIN() of both anyway so we might as well use both roundtrip times
	to ward off latency jitter a bit.

	server: Don't reset the latency before showing it in the invalid net test error message.

2015-07-13  Pavel Grunt  <pgrunt@redhat.com>

	Use desired image compression for the first image
	red_marshall_image() allows to use other than QUIC compression only
	when auto_lz or auto_glz image compression is set. Other images don't
	have the problem because they are compressed using red_compress_image()

2015-06-30  Javier Celaya  <javier.celaya@flexvm.es>

	Handle preferred image compression messages

	Use image compress constants from spice-protocol

2015-06-29  Francois Gouget  <fgouget@codeweavers.com>

	server: Remove the rate_control_is_active field from MJpegEncoder.
	It is redundant with the corresponding callbacks.

	server: Fix an incorrect time calculation.

	HAVE_CLOCK_GETTIME is not used so remove it.

2015-06-29  Sandy Stutsman  <sstutsma@redhat.com>

	Lock the pixmap image cache for the entire fill_bits call
	Locking the individual calls that access the pixmap cache in fill_bits is
	not adequately thread safe.  Often a windows guest with multiple monitors
	will be sending the same image via different threads.  Both threads can
	be in fill_bits at the same time making changes to the cache for the same
	image.  This can result in images being deleted before all the client
	channels are finished with them or with the same image being send multiple
	times.  Here's what can happen with out the lock in fill_bits

	On the server in red_worker.c:fill_bits
	 Thread 1 calls pixmap_cache_hit for Image A and finds it isn't in cache
	 Thread 2 calls pixmap_cache_hit for Image A and finds it isn't in cache

	 Thread 1 adds Image 1 to pixmap_cache (1x)
	 Thread 2 adds Image 1 to pixmap_cache (2x)

	On the client
	 Channel 1 adds Image A to image_cache (1x)
	 Channel 2 replaces Image A in image_cache (1x)

	On server
	 Thread 1 sends Image A rendering commands
	 Thread N removes Image A from pixmap_cache (image remains - 1x)
	 Thread 2 sends Image A rendering commands

	On client
	 Channe1 renders from Image A
	 Channel N removes Image a from image_cache (image is completely removed)
	 Channel2 render command hangs waiting for Image A

2015-06-26  Frediano Ziglio  <fziglio@redhat.com>

	server: allows to set maximum monitors
	spice-server will attempt to limit number of monitors.
	Guest machine can send monitor list it accepts. Limiting the number sent
	by guest will limit the number of monitors client will try to enable.
	The guest usually see client monitors enabled and start using it so
	not seeing client monitor won't try to enable more monitor.
	In this case the additional monitor guest can support will always be
	seen as heads with no attached monitors.
	This allows limiting monitors number without changing guest drivers.

2015-06-26  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Fix build with automake < 1.13
	AC_CONFIG_MACRO_DIRS is not available with older automake versions,
	which causes autogen.sh failures on RHEL6. m4_include() can be used
	instead.

2015-06-22  Francois Gouget  <fgouget@codeweavers.com>

	mjpeg: Convert rate control checks to asserts in encoder
	The checks would lead the reader to think these functions can be called
	when bit rate control is off when in fact they are only called when it
	is active.

	server: Refresh the input fps every 5 second, without a timer.

2015-06-22  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Use spice-common m4 macro for lz4
	This will allow to share this detection code with spice-gtk.

	build-sys: Use spice-common m4 macro for opengl
	This factorizes a bit of configure.ac m4 code.

	build-sys: Use spice-common m4 macro for smartcard
	Besides the code factorization, this will allow smartcard support to be
	automatically enabled if libcacard is present and --disable-smartcard is
	not used.

2015-06-17  Marc-André Lureau  <marcandre.lureau@gmail.com>

	reds: increase listening socket backlog
	With a TCP socket, the backlog doesn't seem to matter much,
	perhaps because of latency or underlying protocol behaviour. However,
	on UNIX socket, it is fairly easy to reach the backlog limit and the
	client will get an EAGAIN error (but not ECONNREFUSED as stated in
	listen(7)) that is not easy to deal with: attempting to reconnect in a
	loop might busy-loop forever as there are no guarantee the server will
	accept new connections, so it will be inherently racy.

	Typically, Spice server can easily have up to 15 concurrent incoming
	connections that are established during initialization of the session.
	To improve the situation, raise the backlog limit to the default maximum
	system value, which is 128 on Linux.

2015-06-16  Cédric Bosdonnat  <cbosdonnat@suse.com>

	Add password length check
	Don't allow setting a too long password.

2015-06-16  Frediano Ziglio  <fziglio@redhat.com>

	Use spice_malloc instead of malloc
	Do not just check and give warning before crashing the program
	accessing a NULL pointer but use spice_malloc which exits with a
	proper message.

2015-06-15  Jonathon Jongsma  <jjongsma@redhat.com>

	Remove duplicate streaming enumeration
	There is already a enumeration in a public header that defines the
	different streaming options, so there's no need to duplicate that
	enumeration internally. Just use the public enum values.

	Use AS_HELP_STRING for configure options

2015-06-11  Frediano Ziglio  <fziglio@redhat.com>

	Fix typo in comment

	Use MIN macro to compute a minimum

2015-06-11  Javier Celaya  <javier.celaya@flexvm.es>

	LZ4: warn if trying to set lz4 but not supported

2015-06-09  Francois Gouget  <fgouget@codeweavers.com>

	server: Remove an unused structure.

2015-06-04  Marc-André Lureau  <marcandre.lureau@gmail.com>

	sound: do not modify client state on migration
	During migration, a volume jump is observed by the client. This is due
	to qemu setting up destination server with default sound state, and the
	server sending it after the client is connected. The volume is later
	restored after migration is finished so there is no need to send this
	default state values on connection.

	Tested with both AC97 & HDA devices.

	Fixes:
	https://bugzilla.redhat.com/show_bug.cgi?id=1012868

2015-04-23  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Pass --enable-python-checks when running autogen.sh
	This will tell spice-common configure.ac to test for the availability of
	python-six when building from git.

	Update spice-common submodule
	This fixes a few issues with older python-six versions:

	Christophe Fergeau (2):
	      configure.ac: Check for needed python modules for git builds
	      codegen: Use six.PY3 rather than six.PY2

2015-04-10  Christophe Fergeau  <cfergeau@redhat.com>

	build-sys: Replace cpu detection error with warning
	configure.ac currently errors out when trying to build on
	non-x86/non-ARM CPUs. Since the previous commits improved
	big endian support a lot, this commit replaces the error
	with a warning at configure time to make testing on big
	endian platforms easier.

	build-sys: Remove unused 'X86_64' conditional
	X86_64 was defined as an AM_CONDITIONAL, but then nothing was using it.
	This commit gets rid of it.

	ppc: Fix glz magic endianess
	This is a modified version of a patch initially by Erlon R. Cruz
	<erlon.cruz@br.flextronics.com>

	ppc: Fixing endianness for channel messages
	This is a modified version of a patch initially from
	Erlon R. Cruz <erlon.cruz@br.flextronics.com>

	ppc: Update spice-common for endianness-related fixes
	Alexander Wauck (1):
	      Make spice_codegen.py work on both Python 2 and 3

	Christophe Fergeau (17):
	      Remove unused header file
	      build-sys: Remove unused X check
	      build-sys: Remove unused win32 check
	      build-sys: Remove unused WITH_SMARTCARD conditional
	      build-sys: Small cleanup of AM_CPPFLAGS
	      build-sys: Add fallback for AS_VAR_APPEND
	      build-sys: Move posix checks to a separate m4 macro
	      build-sys: Move smartcard check to m4 macro
	      build-sys: Move celt check to m4 macro
	      build-sys: Move opus check to m4 macro
	      build-sys: Move opengl check to m4 macro
	      build-sys: Move pixman check to m4 macro
	      Remove unused 'invers' arg from canvas_get_*
	      Remove redundant #if defined(SW_CANVAS_CACHE) ||
	defined(SW_CANVAS_IMAGE_CACHE)
	      Remove another redundant (SW_CANVAS_CACHE) ||
	(SW_CANVAS_IMAGE_CACHE) #ifdef
	      Get rid of SW_CANVAS_IMAGE_CACHE
	      ssl_verify: Move wincrypt.h related #ifdef closer to the include

	Erlon Cruz (2):
	      ppc: Fix lz magic endianness
	      ppc: build-sys: Add big-endian support

	Fabiano Fidêncio (1):
	      Fix typo in pixman_image_get_stride() function

	Javier Celaya (6):
	      LZ4: Fix output buffer size
	      LZ4: Adjust reading the top_down flag
	      LZ4: Decode the image format from the stream
	      LZ4: Fix the row alignment when it is not on a 32bit boundary
	      LZ4: Add support for 24bit pixman surfaces
	      LZ4: Do not include arpa/inet.h in Windows builds

	Victor Toso (1):
	      common: fix build with mingw

	ppc: Fix endianness handling in initial SPICE connection
	This commit fixes enough endianness issues that it's possible to
	connect to a spice-server/qemu running on a big-endian box with a client
	running on a little-endian machine.

	I haven't tested more than getting to the bios/bootloader and typing a
	bit on the keyboard as I did not manage to boot a distro afterwards :(

	This is based on patches send by Erlon R. Cruz
	<erlon.cruz@br.flextronics.com>

2015-03-15  Uri Lublin  <uril@redhat.com>

	m4: WARN FLAGS: Drop -Wenum-compare
	My RHEL-6 gcc (4.4.7) complains a lot about it:
	   cc1: warning: command line option "-Wenum-compare" is
	   valid for C++/ObjC++ but not for C

	For older gcc version (e.g. 4.4.7), man gcc says
	-Wenum-compare is "C++ and Objective-C++ only".

	For newer gcc (e.g. 4.9.2), man gcc says
	"In C this warning is enabled by -Wall."

2015-02-25  Fabiano Fidêncio  <fidencio@redhat.com>

	Do not compress bitmaps on UNIX socket
	On UNIX socket do not perform unnecessary image compression

2015-02-24  Fabiano Fidêncio  <fidencio@redhat.com>

	tests: Fix build on Hurd
	As PATH_MAX is not defined on Hurd, let's check for it and define
	whenever it is necessary.

	https://bugs.freedesktop.org/show_bug.cgi?id=74313

2015-02-08  Uri Lublin  <uril@redhat.com>

	char-device: spice_char_device_write_to_device: protect against recursion
	This fixes Spice's smart card support and is related to
	commit 697f3214fd16adcd524456003619f7f44ddd031b.

	Reported-by: Swapna Krishnan <skrishna@redhat.com>

	Recursion is now possible starting with spice_char_device_write_to_device
	going through spice_char_device_wakeup (after going through qemu),
	calling again to spice_char_device_write_to_device.

	The protecting code is the same as the one protecting the read path.

	This function call loop makes the program to abort with the following messages:

	  usb-ccid: chardev: unexpected message of type 3000000
	  qemu: qemu_mutex_lock: Resource deadlock avoided

	Backtrace:

	(gdb) bt
	* #0  0x00007ffff3fc78c7 in raise () from /lib64/libc.so.6
	* #1  0x00007ffff3fc952a in abort () from /lib64/libc.so.6
	* #2  0x0000555555969a95 in error_exit (err=35,
	*     msg=0x5555559f8c90 <__func__.5119> "qemu_mutex_lock")
	*     at util/qemu-thread-posix.c:48
	* #3  0x0000555555969b82 in qemu_mutex_lock (mutex=0x5555562c4d60)
	*     at util/qemu-thread-posix.c:79
	* #4  0x0000555555714771 in qemu_chr_fe_write (s=0x5555562c4d60,
	*     buf=0x7fffffffd2a0 "", len=12) at qemu-char.c:219
	* #5  0x000055555586be49 in ccid_card_vscard_send_msg (s=0x5555565c5f80,
	*     type=VSC_Error, reader_id=0, payload=0x7fffffffd2e0 "", length=4)
	*     at hw/usb/ccid-card-passthru.c:75
	* #6  0x000055555586bf00 in ccid_card_vscard_send_error (s=0x5555565c5f80,
	*     reader_id=0, code=VSC_GENERAL_ERROR) at
	*     hw/usb/ccid-card-passthru.c:91
	* #7  0x000055555586c559 in ccid_card_vscard_handle_message (
	*     card=0x5555565c5f80, scr_msg_header=0x5555565c6008)
	*     at hw/usb/ccid-card-passthru.c:254
	* #8  0x000055555586c72f in ccid_card_vscard_read (opaque=0x5555565c5f80,
	*     buf=0x5555565034b0 "", size=12) at hw/usb/ccid-card-passthru.c:289
	* #9  0x00005555557149db in qemu_chr_be_write (s=0x5555562c4d60,
	*     buf=0x5555565034b0 "", len=12) at qemu-char.c:305
	* #10 0x000055555571cde5 in vmc_write (sin=0x5555562c4e78,
	*     buf=0x5555565034b0 "", len=12) at spice-qemu-char.c:41
	* #11 0x00007ffff4fa86aa in spice_char_device_write_to_device (
	*     dev=0x55555657f210) at char_device.c:462
	* #12 0x00007ffff4fa9b48 in spice_char_device_wakeup (dev=0x55555657f210)
	*     at char_device.c:862
	* #13 0x00007ffff4ff7658 in spice_server_char_device_wakeup
	*     (sin=0x5555562c4e78) at reds.c:2955
	* #14 0x000055555571d1d2 in spice_chr_write (chr=0x5555562c4d60,
	*     buf=0x7fffffffd560 "", len=12) at spice-qemu-char.c:189
	* #15 0x0000555555714789 in qemu_chr_fe_write (s=0x5555562c4d60,
	*     buf=0x7fffffffd560 "", len=12) at qemu-char.c:220
	* #16 0x000055555586be49 in ccid_card_vscard_send_msg (s=0x5555565c5f80,
	*     type=VSC_Error, reader_id=0, payload=0x7fffffffd5a0 "", length=4)
	*     at hw/usb/ccid-card-passthru.c:75
	* #17 0x000055555586bf00 in ccid_card_vscard_send_error
	* (s=0x5555565c5f80,
	*     reader_id=0, code=VSC_SUCCESS) at hw/usb/ccid-card-passthru.c:91
	* #18 0x000055555586c4fc in ccid_card_vscard_handle_message (
	*     card=0x5555565c5f80, scr_msg_header=0x5555565c6008)
	*     at hw/usb/ccid-card-passthru.c:242
	* #19 0x000055555586c72f in ccid_card_vscard_read (opaque=0x5555565c5f80,
	*     buf=0x5555565034b0 "", size=12) at hw/usb/ccid-card-passthru.c:289
	* #20 0x00005555557149db in qemu_chr_be_write (s=0x5555562c4d60,
	*     buf=0x5555565034b0 "", len=12) at qemu-char.c:305
	* #21 0x000055555571cde5 in vmc_write (sin=0x5555562c4e78,
	*     buf=0x5555565034b0 "", len=12) at spice-qemu-char.c:41
	* #22 0x00007ffff4fa86aa in spice_char_device_write_to_device (
	*     dev=0x55555657f210) at char_device.c:462
	* #23 0x00007ffff4fa8d37 in spice_char_device_write_buffer_add (
	*     dev=0x55555657f210, write_buf=0x555556501f70) at char_device.c:597
	* #24 0x00007ffff501142d in smartcard_channel_write_to_reader (
	*     write_buf=0x555556501f70) at smartcard.c:669
	* #25 0x00007ffff501034c in smartcard_char_device_notify_reader_add (
	*     st=0x55555657ef00) at smartcard.c:335
	* #26 0x00007ffff50112b3 in smartcard_add_reader (scc=0x555556493ee0,
	*     name=0x5555565023cc "E-Gate 0 0") at smartcard.c:642
	* #27 0x00007ffff50118d2 in smartcard_channel_handle_message (
	*     rcc=0x555556493ee0, type=101, size=22, msg=0x5555565023c0 "\003")
	*     at smartcard.c:757
	* #28 0x00007ffff4fbc168 in red_peer_handle_incoming
	*     (stream=0x555556588250, handler=0x555556497ff0) at red_channel.c:308
	* #29 0x00007ffff4fbc231 in red_channel_client_receive
	*     (rcc=0x555556493ee0) at red_channel.c:326
	* #30 0x00007ffff4fc0019 in red_channel_client_event (fd=59, event=1,
	*     data=0x555556493ee0) at red_channel.c:1574
	* #31 0x00005555558b6076 in watch_read (opaque=0x5555565002f0)
	*     at ui/spice-core.c:101
	* #32 0x00005555558e8d48 in qemu_iohandler_poll (pollfds=0x5555562b7630,
	*     ret=2) at iohandler.c:143
	* #33 0x00005555558e89a4 in main_loop_wait (nonblocking=0) at
	* main-loop.c:495
	* #34 0x00005555557219b0 in main_loop () at vl.c:1794
	* #35 0x0000555555729257 in main (argc=40, argv=0x7fffffffddc8,
	*     envp=0x7fffffffdf10) at vl.c:4350

2015-02-03  Javier Celaya  <javier.celaya@flexvm.es>

	LZ4: Send the original format with the compressed data

	LZ4: Do not reverse bottom-up images
	Reversing the bottom-up images in the server is not needed since Pixman,
	in the client, is able to deal with them. As a result, the previous code
	was more complex and wrong. This commit fixes and cleans it.

	LZ4: Fix encoder output size

	LZ4: Limit LZ4 to RGB formats
	Currently, the LZ4 encoding only (partially) supports RGB images, so
	we must check the image format before using it. In the future, indexed
	formats may be implemented too, but their use is usually very small
	compared to RGB.

2015-01-15  Marc-André Lureau  <marcandre.lureau@gmail.com>

	Remove spice-experimental
	Remove unneded symbols that nobody should be using anyway.
	ABI is modified with this patch, but the library version is not bumped.

	Do not perform network tests on UNIX socket
	By default, stream latency is 0 and bandwidth is infinite. On UNIX
	socket do not perform unnecessary testing and keep those values.

	reds-stream: add reds_stream_get_family() function

	reds: add Unix socket support
	Learn to listen on a Unix address. In this case, the connection is plain
	only (non-tls).

2014-12-15  Christophe Fergeau  <cfergeau@redhat.com>

	inputs: Remove unneeded variable
	inputs_channel_handle_parsed() is casting its void * argument to
	a uint8_t * buf before recasting this 'buf' variable to different
	other types. This intermediate 'buf' variable is not needed, especially
	as we can then benefit from implicit casts from void * to the type we
	need.

	inputs: Split overlong line
	Cosmetic change.

	inputs: Fix key_up/key_down mismatch
	When handling a KEY_UP message, the various variables were called
	'key_down', and they were called 'key_up' when handling KEY_DOWN
	messages. This commit makes the naming consistent.

2014-12-03  Christophe Fergeau  <cfergeau@redhat.com>

	Remove unused SPICE_CANVAS_INTERNAL

	client: Remove client code
	The client has been superseded by virt-viewer (
	http://virt-manager.org/download/sources/virt-viewer/ ) and is no longer
	being maintained.

2014-12-02  Javier Celaya  <javier.celaya@flexvm.es>

	Add LZ4 compression support.
	- Add lz4 encoder to compress an image of type LZ4 (see spice_common).
	- Add code in red_worker to use LZ4 when it is enabled, and the client
	  supports it through its display capability, or fallback to LZ.
	- Add enable_lz4 switch in the configure script. Show LZ4 support at the
	  end.

2014-12-01  Christophe Fergeau  <cfergeau@redhat.com>

